﻿#include "MAP.h"
void MAP::set_data(HeightData *h, OSM *o){
    this->hd = h;
    this->o = o;
}
void MAP::init(){
    paintmode = 0;
    was_resized = false;
    hd = NULL;
    o = NULL;
    width = new_width = size().width();
    height = new_height = size().height();
    minlat0 = 50;
    minlon0 = 12;
    maxlat0 = 51;
    maxlon0 = 14;
    lowcontour = 10;
    highcontour = 50;
    cmap = new QPixmap;
    cmapf = new QPixmap;
    cmapff = new QPixmap;
    hc = NULL;
    cd = NULL;
    lineos = 0;
    h = NULL;
    wxxold = 0;
    wyyold = 0;
    drawcontour = 1;
    HP[0].setX( 0); HP[0].setY(-3);
    HP[1].setX(-2); HP[1].setY(-2);
    HP[2].setX(-1); HP[2].setY(-2);
    HP[3].setX(0);  HP[3].setY(-2);
    HP[4].setX(1);  HP[4].setY(-2);
    HP[5].setX(2);  HP[5].setY(-2);
    HP[6].setX(-2); HP[6].setY(-1);
    HP[7].setX(-1); HP[7].setY(-1);
    HP[8].setX(0);  HP[8].setY(-1);
    HP[9].setX(1);  HP[9].setY(-1);
    HP[10].setX(2);  HP[10].setY(-1);
    HP[11].setX(-3); HP[11].setY(0);
    HP[12].setX(-2); HP[12].setY(0);
    HP[13].setX(-1); HP[13].setY(0);
    HP[14].setX(1);  HP[14].setY(0);
    HP[15].setX(2);  HP[15].setY(0);
    HP[16].setX(3);  HP[16].setY(0);
    HP[17].setX(-2); HP[17].setY(1);
    HP[18].setX(-1); HP[18].setY(1);
    HP[19].setX(0);  HP[19].setY(1);
    HP[20].setX(1);  HP[20].setY(1);
    HP[21].setX(2);  HP[21].setY(1);
    HP[22].setX(-2); HP[22].setY(2);
    HP[23].setX(-1); HP[23].setY(2);
    HP[24].setX(0);  HP[24].setY(2);
    HP[25].setX(1);  HP[25].setY(2);
    HP[26].setX(2);  HP[26].setY(2);
    HP[27].setX(0);  HP[27].setY(3);
    MS0.minlat = 50;
    MS0.minlon = 13;
    MS0.maxlat = 51;
    MS0.maxlon = 14.5;
    MS0.roadcolor[0] = QColor(0,0,0).rgba();
    MS0.roadcolor[1] = QColor(0,0,0).rgba();
    MS0.roadcolor[2] = QColor(0,0,0).rgba();
    MS0.roadcolor[3] = QColor(0,0,0).rgba();
    MS0.roadcolor[4] = QColor(0,0,0).rgba();
    MS0.roadcolor[5] = QColor(0,0,0).rgba();
    MS0.roadwidth[0] = 6.;
    MS0.roadwidth[1] = 4.;
    MS0.roadwidth[2] = 3.;
    MS0.roadwidth[3] = 2.;
    MS0.roadwidth[4] = 1.;
    MS0.roadwidth[5] = 0.5;
    MS0.summitcolor = QColor(100,15,0).rgba();
    MS0.summitsize = 12;
    MS0.pointsize[0] = 35;
    MS0.pointsize[1] = 25;
    MS0.pointsize[2] = 15;
    MS0.pointsize[3] =  8;
    MS0.pointcolor[0] = QColor(1,1,1).rgba();
    MS0.pointcolor[1] = QColor(1,1,1).rgba();
    MS0.pointcolor[2] = QColor(1,1,1).rgba();
    MS0.pointcolor[3] = QColor(1,1,1).rgba();
    MS0.drawcontour = 1;
    MS0.drawsummit = 1;
    MS0.drawpoints = 1;
    MS0.drawwood = 1;
    MS0.drawstreetcontour = 1;
    MS0.woodcolor = QColor(0,200,0,50).rgba();
    MS0.drawater = 1;
    MS0.watercolor = QColor(0,0,200,100).rgba();
    MS0.drawscale = 1;
    MS0.drawstreetlabel = 1;
    MS0.heightcolor[0] = QColor(228,255,206).rgba();
    MS0.heightcolor[1] = QColor(215,255,127).rgba();
    MS0.heightcolor[2] = QColor(255,249,125).rgba();
    MS0.heightcolor[3] = QColor(197,128, 98).rgba();
    MS0.heightcolor[4] = QColor(220,220,220).rgba();
    MS0.heights[0] = 0;
    MS0.heights[1] = 300;
    MS0.heights[2] = 600;
    MS0.heights[3] = 900;
    MS0.heights[4] = 1200;
    MS0.sun.I = 5;
    MS0.sun.azimut = -135;
    MS0.sun.elevation = 45;
    MS0.sun.cphi = cos(-MS0.sun.azimut/180.*M_PI);
    MS0.sun.sphi = sin(-MS0.sun.azimut/180.*M_PI);
    MS0.sun.ctheta = cos((90-MS0.sun.elevation)/180.*M_PI);
    MS0.sun.stheta = sin((90-MS0.sun.elevation)/180.*M_PI);
    MS = &MS0;
}

MAP::MAP(QWidget *parent){
    init();
    setBackgroundRole(QPalette::Dark);
    setAutoFillBackground(true);
    setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
    setMouseTracking(true);
}
MAP::MAP(HeightData *h, OSM* o){
    init();
    set_data(h,o);
}
MAP::~MAP(void){
    if (hc != NULL){
        for(int wx = 0; wx < width+2; wx++){
            delete(hc[wx]);
            delete(dhdx[wx]);
            delete(dhdy[wx]);
            delete(t[wx]);
        }
        delete(hc);
        delete dhdx;
        delete dhdy;
        delete(t);
    }
    if(cd != NULL)
        delete cd;
    delete cmap;
    delete cmapf;
}
void MAP::settings(MapSettings* MS){
    this->MS = MS;
}

void MAP::resize(int width, int height){
    new_width = width;
    new_height = height;
}
void MAP::set_borders(double latmin0, double latmax0,
                      double lonmin0, double lonmax0){
    minlat = minlat0 = latmin0;
    maxlat = maxlat0 = latmax0;
    minlon = minlon0 = lonmin0;
    maxlon = maxlon0 = lonmax0;
}
void MAP::init_map(int width, int height){
    resize(width,height);
    width = size().width();
    height = size().height();
    set_borders(MS->minlat, MS->maxlat,MS->minlon, MS->maxlon);
    calc_borders();
    draw_map(NULL,NULL,NULL,1);
}

QPixmap* MAP::get_Map(){
    return cmap;
}
QColor MAP::color(double lon, double lat, QImage* Img){
    double x = lontox(lon);
    double y = lattoy(lat);
    //if(x > 0 && x < width-1 && y >= 1 && y < height-1)
    if(x >= 0 && x < width && y >= 0 && y < height){
        x = qMax(0.01, qMin(width -1.01,x));
        y = qMax(0.01, qMin(height-1.01,y));
        return color_xy(x,y,Img);
    }
    else
        return Qt::black;
}
QColor MAP::color_xy(double x, double y, QImage* Img){
    QColor c00 = Img->pixel(floor(x),floor(y));
    QColor c10 = Img->pixel(ceil(x),floor(y));
    QColor c01 = Img->pixel(floor(x),ceil(y));
    QColor c11 = Img->pixel(ceil(x),ceil(y));
    double dx = x - floor(x);
    double dy = y - floor(y);
    return QColor(c00.  red()*(1-dx)*(1-dy)+c10.  red()*(  dx)*(1-dy)+c01.  red()*(1-dx)*(  dy)+c11.  red()*(  dx)*(  dy),
                  c00.green()*(1-dx)*(1-dy)+c10.green()*(  dx)*(1-dy)+c01.green()*(1-dx)*(  dy)+c11.green()*(  dx)*(  dy),
                  c00. blue()*(1-dx)*(1-dy)+c10. blue()*(  dx)*(1-dy)+c01. blue()*(1-dx)*(  dy)+c11. blue()*(  dx)*(  dy));
}

QColor MAP::color(double lon, double lat){
    QImage Img = cmap->toImage();
    return color(lon,lat,&Img);
}
void MAP::color_integral(double lon, double lat, double lastlon,
                      double lastlat, double* samplecount,
                      double* red, double* green, double* blue, QImage* Img){
    double x = lontox(lon);
    double y = lattoy(lat);
    double x0 = lontox(lastlon);
    double y0 = lattoy(lastlat);
    // check whether part of the line lies on this map
    double df = 1./qMin(1,int(sqrt((x-x0)*(x-x0)+(y-y0)*(y-y0))));
    //for(double f = df*0.5; f < 1; f += df){
    double f = 0;{
        double xt = x*f + x0*(1-f);
        double yt = y*f + y0*(1-f);
        if(xt > 0 && xt < width && yt > 0 && yt < height){
            QColor c = color_xy(xt,yt,Img);
            (*samplecount)++;
            *red += c.red();
            *green += c.green();
            *blue += c.blue();
        }
    }
}

void MAP::calc_borders(){
    double middle;
    /*double q = distance(minlat0,minlon0,maxlat0,minlon0)
            /distance((minlat0+maxlat0)/2.,minlon0,(minlat0+maxlat0)/2.,maxlon0);

    if( q > 1.0 * new_height/new_width){
        // specified Area too wide
        middle = (minlon+maxlon)/2.;
        minlon = middle - ((middle-minlon0)*new_width*q/new_height);
        maxlon = middle + ((maxlon0-middle)*new_width*q/new_height);
    }
    else{
        // specified Area too high
        middle = (minlat+maxlat)/2;
        maxlat = middle + ((maxlat0-middle)/new_width/q*new_height);
        minlat = middle - ((middle-minlat0)/new_width/q*new_height);
    }
    */
    mmaxlat = lattomercator(maxlat0);
    mminlat = lattomercator(minlat0);
    double q = (mminlat-mmaxlat)/(minlon0-maxlon0);
    if( q > 1.0 * new_height/new_width){
        // specified Area too wide
        middle = (minlon+maxlon)/2.;
        minlon = middle - ((middle-minlon0)*new_width*q/new_height);
        maxlon = middle + ((maxlon0-middle)*new_width*q/new_height);
    }
    else{
        // specified Area too high
        middle = (mminlat+mmaxlat)/2;
        mmaxlat = middle + ((mmaxlat-middle)/new_width/q*new_height);
        mminlat = middle - ((middle-mminlat)/new_width/q*new_height);
        maxlat = mercatortolat(mmaxlat);
        minlat = mercatortolat(mminlat);
    }
    //scaling factors for SRTM3 data cell
    //(meters per elemenary cell, px per elementary cell
    middle = (minlat+maxlat)/2;
    mperlat = float(distance(minlat,minlon,maxlat,minlon)/(maxlat-minlat)*1000/1200);
    mperlon = float(distance(middle,minlon,middle,maxlon)/(maxlon-minlon)*1000/1200);
    pxperlat = float(new_height/(maxlat-minlat)/1200.);
    pxperlon = float(new_width/(maxlon-minlon)/1200.);
    /*zoom in meter/pixel*/
    zoom = distance((minlat+maxlat)/2,minlon,(minlat+maxlat)/2,maxlon)*1000/new_width;

    /*countour step size for the current zoom*/
    int zoomint = int(zoom);
    switch(zoomint > 50 ? 4 : zoomint > 30 ? 3:
           zoomint > 15 ? 2:zoomint <= 15 ? 1:zoomint){
        case 4:	lowcontour = 100; highcontour = 10000; break;
        case 3:	lowcontour =  50; highcontour = 250; break;
        case 2:	lowcontour =  20; highcontour = 100; break;
        case 1:	lowcontour =  10; highcontour = 50; break;
    }
    //lowcontour = 100; highcontour = 500;
    /*recreate picture memory if neccesary*/
    if((width != new_width || height != new_height)
       && new_width != 0 && new_height != 0){
        /*delete picture memory an recreate*/
        if (hc != NULL){
            for(int wx = 0; wx < width+2; wx++){
                delete(hc[wx]);
                delete(dhdx[wx]);
                delete(dhdy[wx]);
                delete(t[wx]);
            }
            delete(hc);
            delete dhdx;
            delete dhdy;
            delete(t);
        }
        /*delete and recreate colourdate of every single px*/
        if(cd != NULL)
            delete cd;
        width = new_width;
        height = new_height;
        new_map_memory();
    }
    MS->minlat = minlat;
    MS->maxlat = maxlat;
    MS->minlon = minlon;
    MS->maxlon = maxlon;
}

void MAP::new_map_memory(){
    lineos = 3*width % 4;
    if(lineos > 0) lineos = 4 - lineos;
    hc = new double*[width+2];
    dhdx = new double*[width+2];
    dhdy = new double*[width+2];
    t = new char*[width+2];
    for(int wx = 0; wx < width+2; wx++){
        hc[wx] = new double[height+2];
        dhdx[wx] = new double[height+2];
        dhdy[wx] = new double[height+2];
        t[wx]  = new char[height+2];
    }
    cd = new unsigned char[(3*width+lineos)*height];
}
/*
void MAP::keyPressEvent(QKeyEvent *event){
    switch(event->key()){
        case Qt::Key_Right:
            scale(1. , 0.5,   0); break;
        case Qt::Key_Left:
            scale(1. ,-0.5,   0); break;
        case Qt::Key_Up:
            scale(1. ,   0, 0.5); break;
        case Qt::Key_Down:
            scale(1. ,   0,-0.5); break;
        case Qt::Key_Plus:
            scale(0.5,   0,   0); break;
        case Qt::Key_Minus:
            scale(2. ,   0,   0); break;
        default:
            emit keypressed(event); break;
    }
}

void MAP::mousePressEvent(QMouseEvent *event){
    if(event->button()==Qt::LeftButton){
        xold = event->x();
        yold = event->y();
    }
}
void MAP::mouseReleaseEvent(QMouseEvent *event){
    x = event->x();
    y = event->y();
    if(x == xold && y == yold)
        emit clicked(Y_to_lat(y),X_to_lon(x),
                     event->modifiers()==Qt::ControlModifier);
    else
        if(event->button()==Qt::LeftButton){
            if(event->modifiers()==Qt::ControlModifier){
                // zoom box
                scale((1.*abs(x-xold)/size().width()+1.*abs(y-yold)/size().height())/2.,
                       1.*((x+xold)/2.-size().width()/2.)/size().width(),
                       1.*(size().height()/2.-(yold+y)/2.)/size().height());
            }
            else{
                // move map
                scale(1.,1.*(xold-x)/size().width(),1.*(y-yold)/size().height());
            }
        }
}
void MAP::mouseMoveEvent(QMouseEvent *event){
    x = event->x();
    y = event->y();
    if(event->buttons()==Qt::LeftButton){
        if(event->modifiers()==Qt::ControlModifier){
            // zoom box
            paintmode = 1;
            update();
            emit position(Y_to_lat(y),X_to_lon(x),XY_to_height(x,y));
        }
        else{
            // move map
            paintmode = 2;
            update();
        }
    }
    else
        emit position(Y_to_lat(y),X_to_lon(x),XY_to_height(x,y));
}
void MAP::wheelEvent(QWheelEvent * event ){
    x = event->x();
    y = event->y();
    int xmiddle = size().width()/2;
    int ymiddle = size().height()/2;
    if (event->delta() < 0)
        scale(2. ,1.*(x-xmiddle)/size().width(),
              1.*(ymiddle-y)/size().height());
    else
        scale(0.5,1.*(x-xmiddle)/size().width(),
              1.*(ymiddle-y)/size().height());
}
*/
void MAP::show_zoombox(int x, int xold, int y, int yold){
    this->x = x;
    this->xold = xold;
    this->y = y;
    this->yold = yold;
    paintmode = 1;
    update();
}

void MAP::show_translated(int x, int xold, int y, int yold){
    this->x = x;
    this->xold = xold;
    this->y = y;
    this->yold = yold;
    paintmode = 2;
    update();

}

void MAP::SRTM3toMAP(short getcmap){
    // first extend heighdata area by 1 screen px in every direction
    double minlatex = mercatortolat(mminlat - (mmaxlat-mminlat)/height);
    double maxlatex = mercatortolat(mmaxlat + (mmaxlat-mminlat)/height);
    double minlonex = minlon - (maxlon - minlon)/width;
    double maxlonex = maxlon + (maxlon - minlon)/width;

    hd->set_rect(minlatex,maxlatex,minlonex,maxlonex);
    if(pxperlat < 1)
        /*map show big area*/
        //hd->interpolate_linear(width,height,0,hc,dhdx,dhdy);
        hd->interpolate_linear_mercator(width+2,height+2,0,hc,dhdx,dhdy);
    else
        /*map shows small area, detailed presentation necessary*/
        //hd->interpolate_bicubic_conv3(width,height,0,hc,dhdx,dhdy);
        hd->interpolate_bicubic_conv3_mercator(width+2,height+2,0,hc,dhdx,dhdy);
    add_DEM();
    if(MS->drawcontour)
        add_contour();
    if(getcmap){
        QImage img(cd,width,height,QImage::Format_RGB888);
        delete cmap;
        cmap = new QPixmap(width,height);
        cmap->convertFromImage(img);
    }
}
void MAP::add_DEM(){
    for(int k = 0; k < width; k++)
        for(int l = 0; l < height; l++){
                    htocolorfast(&(cd[l*(3*width+lineos)+k*3]),
                                 hc[k+1][l+1],
                                 dhdx[k+1][l+1]/mperlon,
                                 dhdy[k+1][l+1]/mperlat);
                }
}
void MAP::add_contour(){
    if(drawcontour){
        /*set important constants for calculation*/
        double dI[4], f0l, f0h, fnl, fnh;
        int dx[4]={+1,+1,+1,0};
        int dy[4]={-1,0,+1,+1};
        double I[4]={-0.2,-0.4,-0.2,-0.4};
        int dd[4]={-1,0,1,2};
        /*for every single px do ...*/
        for(int x = 0; x < width; x++)
            for(int y = 0; y < height; y++){
                f0l = floor(hc[x+1][y+1]/lowcontour);
                f0h = floor(hc[x+1][y+1]/highcontour);
                /*... inspect all four neighbour px*/
                for(int i = 0; i < 4; i++){
                    /*try small contour step first*/
                    fnl = floor(hc[x+1+dx[i]][y+1+dy[i]]/lowcontour);
                    if(f0l != fnl){
                        fnh = floor(hc[x+1+dx[i]][y+1+dy[i]]/highcontour);
                        if(f0h != fnh){
                            /*draw fat line*/
                            fnh=max(fnh,f0h);
                            dI[1] = qAbs(hc[x+1      ][y+1      ] - fnh*highcontour)
                                   /qAbs(hc[x+1+dx[i]][y+1+dy[i]] - hc[x+1][y+1]);
                            dI[2] = 1. - dI[1];
                            dI[0] = dI[1] + 1;
                            dI[3] = dI[2] + 1;
                            for(int j = 0; j < 4; j++){
                                if(dI[j] < 0.5) dI[j] = 1.;
                                else			dI[j] = qMax(0.,1.5-dI[j]);
                                change_intensity(x+dx[i]*dd[j],y+dy[i]*dd[j],I[i]*dI[j]);
                            }
                        }
                        else{
                            /*draw thin line*/
                            fnl=max(fnl,f0l);
                            change_intensity(x      ,y      ,I[i]
                                            *qAbs(hc[x+1+dx[i]][y+1+dy[i]] - fnl*lowcontour)
                                            /qAbs(hc[x+1+dx[i]][y+1+dy[i]] - hc[x+1][y+1]));
                            change_intensity(x+dx[i],y+dy[i],I[i]
                                            *qAbs(hc[x+1	  ][y+1      ] - fnl*lowcontour)
                                            /qAbs(hc[x+1+dx[i]][y+1+dy[i]] - hc[x+1][y+1]));
                        }
                    }
                }
            }
    }
}
inline void MAP::htocolorfast(unsigned char* cd,float h,float dxf,float dyf){
    int i = 0;
    while(h > MS->heights[i+1] && i < 3)
        i++;
    float l = qMax(0.,
              qMin(1.,
                   (MS->heights[i+1]-h)/(MS->heights[i+1]-MS->heights[i])));
    float r = 1-l;

    float I =  MS->sun.I*((-(dxf*MS->sun.sphi+dyf*MS->sun.cphi)*MS->sun.stheta
                           +MS->sun.ctheta)
               /sqrt(1+dxf*dxf+dyf*dyf)-MS->sun.ctheta);
    if(I>0){
        cd[0] = qMin(uchar(255),
                uchar((qRed  (MS->heightcolor[i])*l+qRed  (MS->heightcolor[i+1])*r)/(I+1)
                + I/(I+1)*255.));
        cd[1] = qMin(uchar(255),
                uchar((qGreen(MS->heightcolor[i])*l+qGreen(MS->heightcolor[i+1])*r)/(I+1)
                + I/(I+1)*255.));
        cd[2] = qMin(uchar(255),
                uchar((qBlue (MS->heightcolor[i])*l+qBlue (MS->heightcolor[i+1])*r)/(I+1)
                + I/(I+1)*255.));
    }
    else{
        cd[0] = uchar((qRed  (MS->heightcolor[i])*l+qRed  (MS->heightcolor[i+1])*r)/(-I+1));
        cd[1] = uchar((qGreen(MS->heightcolor[i])*l+qGreen(MS->heightcolor[i+1])*r)/(-I+1));
        cd[2] = uchar((qBlue (MS->heightcolor[i])*l+qBlue (MS->heightcolor[i+1])*r)/(-I+1));
    }
}
void MAP::change_intensity(int x, int y, double dI){
    if( x >= 0 && x < width && y >= 0 && y < height){
        unsigned char* c = &(cd[y*(3*width+lineos)+x*3]);
        if(dI>0){
            c[0] = c[0]/(1+dI)+255*dI/1+dI;
            c[1] = c[1]/(1+dI)+255*dI/1+dI;
            c[2] = c[2]/(1+dI)+255*dI/1+dI;
        }
        else{
            c[0] = c[0]/(1-dI);
            c[1] = c[1]/(1-dI);
            c[2] = c[2]/(1-dI);
        }
    }
}
double MAP::getminlat(){
    return minlat;
}
double MAP::getminlon(){
    return minlon;
}
double MAP::getmaxlat(){
    return maxlat;
}
double MAP::getmaxlon(){
    return maxlon;
}
int MAP::getwidth(){
    return width;
}
int MAP::getheight(){
    return height;
}
int MAP::X_to_x(int X){
    return X + (width - size().width())/2;
}
int MAP::Y_to_y(int Y){
    return Y + (height - size().height())/2;
}
int MAP::y_to_Y(int y){
    return y - (height - size().height())/2;
}
int MAP::x_to_X(int x){
    return x - (width - size().width())/2;
}
double MAP::Y_to_lat(int Y){
    return y_to_lat(Y_to_y(Y));
}
double MAP::X_to_lon(int X){
    return x_to_lon(X_to_x(X));
}
double MAP::y_to_lat(int y){
    //return maxlat-(maxlat-minlat)/height*(0.5 + y);
    return mercatortolat(mmaxlat-(mmaxlat-mminlat)/height*(0.5 + y));
}
double MAP::x_to_lon(int x){
    return minlon+(maxlon-minlon)/width*(0.5 + x);
}
double MAP::lat_to_y(double lat){
    //return (maxlat-lat)/(maxlat-minlat)*height;
    return (mmaxlat-lattomercator(lat))/(mmaxlat-mminlat)*height;
}
double MAP::lon_to_x(double lon){
    return (lon-minlon)/(maxlon-minlon)*width;
}
double MAP::xy_to_height(int x, int y){
    if(x>=0 && x < width && y >= 0 && y < height)
        return hc[x][y];
    else
        return 0;
}
double MAP::XY_to_height(int X, int Y){
    return xy_to_height(x_to_X(X),Y_to_y(Y));
}

inline float MAP::lattoy(double lat){
    //return (maxlat-lat)/(maxlat-minlat)*height;
    return (mmaxlat-lattomercator(lat))/(mmaxlat-mminlat)*height;
}
inline float MAP::lontox(double lon){
    return (lon-minlon)/(maxlon-minlon)*width;
}
float MAP::get_mperlon(){
    return mperlon;
}
float MAP::get_mperlat(){
    return mperlat;
}
void MAP::OSMtoMAP(short getcmap,short drawroads, short drawnature , short drawpoints){
    if(o->get_status() >= 3){
        reset_Template();
        if(drawnature && MS->drawwood) facetoTemplate(o->wood,1);
        if(drawnature && MS->drawater) facetoTemplate(o->water,10);
        if(drawnature && (MS->drawwood||MS->drawater))
            TemplatetoColorData();
        if(getcmap){
            delete cmap;
            cmap = new QPixmap(width,height);
            cmap->fill(Qt::red);
        }
        QPainter p(cmap);
        if(getcmap){
            QImage img(cd,width,height,QImage::Format_RGB888);
            p.drawImage(0,0,img);
        }
        p.setRenderHint(QPainter::Antialiasing);
        p.setRenderHint(QPainter::TextAntialiasing);

        if(drawnature && MS->drawater){
            linetomap(o,&p,o->creek,		QColor(0,0,255,100), zoomsize(1 ),1);
            linetomap(o,&p,o->river,		QColor(0,0,255,100), zoomsize(4 ),1);
        }

        if(drawroads){
            linetomap(o,&p,o->track2,   QColor(MS->roadcolor[4]),zoomsize(MS->roadwidth[4]),1);
            linetomap(o,&p,o->track,	QColor(MS->roadcolor[3]),zoomsize(MS->roadwidth[3]),1);
            linetomap(o,&p,o->secondary,QColor(MS->roadcolor[2]),zoomsize(MS->roadwidth[2]),1);
            linetomap(o,&p,o->primary,	QColor(MS->roadcolor[1]),zoomsize(MS->roadwidth[1]),1);
            linetomap(o,&p,o->highway,	QColor(MS->roadcolor[0]),zoomsize(MS->roadwidth[0]),1);
        }

        reset_Template();				// enables space checking for labels

        if(drawpoints && MS->drawpoints){
            pointtomap(o,&p,o->metropolis,	QColor(MS->pointcolor[0]),zoomsize(MS->pointsize[0]));
            pointtomap(o,&p,o->city,		QColor(MS->pointcolor[1]),zoomsize(MS->pointsize[1]));
        }
        if(drawpoints && MS->drawsummit)
            peaktomap(o,&p,o->peak,0,1e10,  QColor(MS->summitcolor),  zoomsize(MS->summitsize));
        if(MS->drawater)
            rivernametomap(o,&p,o->river,	QColor(0,0,60,255),	zoomsize(8 ));
        if(drawpoints && MS->drawpoints)
            pointtomap(o,&p,o->town,		QColor(MS->pointcolor[2]),zoomsize(MS->pointsize[2]));
        if(MS->drawater)
            waternametomap(o,&p,o->water,	QColor(0,0,60,255), zoomsize(8 ));
        if(MS->drawater)
            pointtomap(o,&p,o->village,		QColor(MS->pointcolor[3]),zoomsize(MS->pointsize[3]));
        if(MS->drawstreetlabel){
            streetnametomap(o,&p,o->primary,QColor(200,200,200),zoomsize(8 ));
            streetnametomap(o,&p,o->highway,QColor(200,200,200),zoomsize(8 ));
        }
        if(MS->drawscale)
            add_scale(&p);
    }
}
void MAP::linetomap(OSM* o, QPainter *p, lines** ll,QColor color,
                    float linewidth, float minlinewidth){
    if(linewidth >= minlinewidth){
        QPoint* pts;
        lines* l = *ll;
        if(MS->drawstreetcontour)
            p->setPen(QPen(color,linewidth,Qt::SolidLine,Qt::RoundCap,Qt::RoundJoin));
        else
            p->setPen(QPen(color,linewidth));
        while(l != NULL){
            if(o->isin(l,minlat,maxlat,minlon,maxlon)){
                pts = new QPoint[l->way->nodec];
                for(int i = 0; i < l->way->nodec;i++){
                    pts[i].setX(lontox(l->way->node[i]->lon));
                    pts[i].setY(lattoy(l->way->node[i]->lat));
                }
                p->drawPolyline(pts,l->way->nodec);
                delete pts;
            }
            l = l->next;
        }
    }
}
void MAP::facetoTemplate(lines** ff, char val){
    lines* f = *ff;
    while(f != NULL){
        if(o->isin(f,minlat,maxlat,minlon,maxlon)){
            linestoTemplate(f,val);
        }
        f = f->next;
    }
}
void MAP::pointtomap(OSM* o, QPainter *p, points** pp,QColor color,float size){
    if(size>8){
        QColor  btext(color);
        QColor  blight(color.red()*0.1+220,
                       color.green()*0.1+220,
                       color.blue()*0.1+200,
                       20);
        p->setFont(QFont("Arial",size, QFont::Bold, false));
        QFontMetricsF fm(p->font());
        QRectF R;
        R.setHeight(fm.height());
        float yoffset = fm.ascent()-fm.strikeOutPos();
        float yso = fm.strikeOutPos();
        int x,y;
        points* pts = *pp;
        while(pts != NULL){
            if(o->isin(pts,minlat,maxlat,minlon,maxlon)){
                x = lontox(pts->k->lon);
                y = lattoy(pts->k->lat);
                QString w = QString().fromUtf8(pts->name);
                R.setWidth(fm.width(w));
                R.moveTo(x-R.width()/2,y-yoffset);
                if(check_TemplateSpace(R)){
                    Draw_lighted_text(p,&w,QPointF(R.left(),y+yso),&blight,&btext);
                    set_TemplateSpace(R);
                }
            }
            pts = pts->next;
        }
    }
}
void MAP::peaktomap(OSM* o, QPainter *p, points** pp, float min, float max,
                   QColor color,float size){
    QBrush  btext(color);
    QBrush	blight(QColor(color.red()*0.2+204,
                          color.green()*0.2+204,
                          color.blue()*0.2+204,
                          140));
    QRectF R;
    points* pts = *pp;
    QPointF alignto[3];
    float size0 = size;
    int x,y;
    while(pts != NULL && pts->index >= min){
        if(pts->index < max &&
           o->isin(pts,minlat,maxlat,minlon,maxlon)){
            /*Schriftgroesse auf Berge mit Index 20 normieren, falls zu klein
            nicht zeichnen*/
            size = size0 * sqrt(pts->index/1500);
            if(size > 8){
                p->setFont(QFont("Arial",size, QFont::Bold, false));
                x = lontox(pts->k->lon);
                y = lattoy(pts->k->lat);
                float size05 = size * 0.5;
                float frc = 0.3;
                QString w = QString().fromUtf8(pts->name);
                QPointF p1(x            ,y-size05*1.2);
                QPointF p2(x+size05*0.866,y+size05*0.5);
                QPointF p3(x-size05*0.866,y+size05*0.5);
                QPointF d1(frc*size05,0);
                QPointF d2(-frc*size05*0.5,frc*size05*0.866);
                QPointF d3(-frc*size05*0.5,-frc*size05*0.866);
                QPainterPath Triang;
                Triang.moveTo(p1);
                Triang.cubicTo(p1+d1,p2-d2,p2);
                Triang.cubicTo(p2+d2,p3-d3,p3);
                Triang.cubicTo(p3+d3,p1-d1,p1);
                alignto[0].setX(x-5*size);	alignto[0].setY(y+1*size);
                alignto[1].setX(x);			alignto[1].setY(y-1.5*size);
                alignto[2].setX(x+5*size);	alignto[2].setY(y+1*size);
                R = Triang.boundingRect();
                if(check_TemplateSpace(R))
                    if(Draw_aligned_text(p,&(alignto[0]),3,&w,p1,&blight,&btext)){
                        p->setPen(Qt::NoPen);
                        Draw_lighted_Path(p,&Triang,&blight,&btext);
                        set_TemplateSpace(R);
                    }
            }
        }
        pts = pts->next;
    }
}
void MAP::waternametomap(OSM* o, QPainter *p, lines** pp,QColor color,float size){
    if(size > 8){
        color.setAlpha(255);
        QColor  btext(color.darker(200));
        QColor  blight(color.red()*0.1+220,
                       color.green()*0.1+220,
                       color.blue()*0.1+220,
                       20);
        p->setFont(QFont("Arial",size, QFont::Bold, false));
        QFontMetricsF fm(p->font());
        QRectF R;
        R.setHeight(fm.height());
        float yoffset = fm.ascent()-fm.strikeOutPos();
        float yso = fm.strikeOutPos();
        int x,y;
        lines* pts = *pp;

        while(pts != NULL){
            if(	   pts->name != NULL
                && o->isin(pts,minlat,maxlat,minlon,maxlon)
                && (pts->way->maxlon - pts->way->minlon)*
                   (pts->way->maxlat - pts->way->minlat)*mperlat*1200*mperlon*1200
                    > 1000*zoom*zoom){
                x = lontox((pts->way->maxlon+pts->way->minlon)/2);
                y = lattoy((pts->way->maxlat+pts->way->minlat)/2);
                QString w = QString().fromUtf8(pts->name);
                R.setWidth(fm.width(w));
                R.moveTo(x-R.width()/2,y-yoffset);
                if(check_TemplateSpace(R)){
                    Draw_lighted_text(p,&w,QPointF(R.left(),y+yso),&blight,&btext);
                    set_TemplateSpace(R);
                }
            }
            pts = pts->next;
        }
    }
}
void MAP::streetnametomap(OSM* o, QPainter *p, lines** pp,QColor color,float size){
    QColor  btext(color);
    p->setBrush(QBrush(QColor(50,50,50,150)));
    p->setFont(QFont("Arial",size, QFont::Bold, false));
    QFontMetricsF fm(p->font());
    QRectF R;
    float yoffset = fm.ascent()-fm.strikeOutPos();
    float yso = fm.strikeOutPos();
    int x,y,fwidth;
    lines* pts = *pp;

    while(pts != NULL){
        if(pts->name != NULL){
            x = lontox(pts->way->node[pts->way->nodec/2]->lon);
            y = lattoy(pts->way->node[pts->way->nodec/2]->lat);
            QString w = QString().fromUtf8(pts->name);
            R.setHeight(fm.height());
            fwidth = fm.width(w);
            R.setWidth(fwidth*1.2);
            R.moveTo(x-R.width()/2,y-yoffset);
            if(check_TemplateSpace(R)){
                p->setPen(QColor(0,0,0));
                p->drawRoundRect(R,25,25);
                p->setPen(btext);
                p->drawText(x-fwidth/2,y+yso,w);
                /*bevor Templatespace setzen, Rechteck aufblähen, da sonst
                zuviele weitere Beschriftungen eingefuegt werden. Beachte:
                Die Straßen sind die letzen Beschriftungen in der Karte*/
                R.adjust(-2*R.width(),-2*R.height(),2*R.width(),2*R.height());
                set_TemplateSpace(R);
            }
        }
        pts = pts->next;
    }
}
void MAP::rivernametomap(OSM* o, QPainter *p, lines** pp,QColor color,float size){
    if(size > 8){
        int i,j;
        color.setAlpha(255);
        QBrush  btext(color.darker(200));
        QBrush	blight(QColor(color.red()*0.2+204,
                              color.green()*0.2+204,
                              color.blue()*0.2+204,
                              140));
        p->setFont(QFont("Arial",size,QFont::Bold));
        QFontMetricsF fm(p->font());
        QPointF P(0.,0.);
        lines* pts = *pp;
        QPointF path[1000];
        float d;
        QRectF brect;
        while(pts != NULL){
            if(	   pts->name != NULL
                && o->isin(pts,minlat,maxlat,minlon,maxlon)){
                // river lies within map and has a name
                QString w = QString().fromUtf8(pts->name);
                brect = fm.boundingRect(w);
                if(
                    sqrt( (pts->way->maxlon - pts->way->minlon)*
                            (pts->way->maxlon - pts->way->minlon)*mperlon*1200*mperlon*1200
                        +(pts->way->maxlat - pts->way->minlat)*
                            (pts->way->maxlat - pts->way->minlat)*mperlon*1200*mperlon*1200)
                    > brect.width()*2*zoom){
                    // river is long enough to be labeled
                    path[0].setX(lontox(pts->way->node[0]->lon));
                    path[0].setY(lattoy(pts->way->node[0]->lat));
                    i = 1;
                    j = 0;
                    d = 0;
                    do{	path[i].setX(lontox(pts->way->node[i]->lon));
                        path[i].setY(lattoy(pts->way->node[i]->lat));
                        d = d+ sqrt((path[i-1].x()-path[i].x())*(path[i-1].x()-path[i].x())
                                    +(path[i-1].y()-path[i].y())*(path[i-1].y()-path[i].y()));
                        if(d < brect.width()*1.5) j = i;
                        i++;
                    }while(d < brect.width()*3 && i < pts->way->nodec);
                    if(i != pts->way->nodec){
                        i--;
                        P = path[j];
                        Draw_aligned_text(p,&(path[0]),i,&w,P,&blight,&btext);
                    }
                }
            }
            pts = pts->next;
        }
    }
}
void MAP::add_scale(QPainter *p){
    QColor  b(0,0,0);
    QColor  w(255,255,255,120);
    QColor  wt(255,255,255,20);
    p->setFont(QFont("Arial",10, QFont::Bold, false));
    QFontMetricsF fm(p->font());
    float sd = width/3*zoom/1000;
    float dsd = float(upperscale(sd/8));
    int x0 = width/3*2-20;
    int y0 = height - 20;
    int width0 = int(floor(dsd*1000/zoom));
    QRectF R;
    QPointF P;
    p->setPen(Qt::NoPen);
    for(int i = 0; i < sd/dsd-1; i++)
        if(i % 2 == 0){
            p->setBrush(w);
            p->drawRect(x0+i*width0,y0,width0,10);
        }
        else{
            p->setBrush(b);
            p->drawRect(x0+i*width0,y0,width0,10);
        }

    P.setY(0);
    for(int i = 0; i < sd/dsd; i++){
        P.setX(x0+i*width0);
        QString label = QString("%1 km").arg(i*dsd,0,'f',1);
        R = fm.boundingRect(label);
        R.translate(x0+i*width0-R.width()/2,y0-5-fm.descent());
        Draw_lighted_text(p,&label,R.bottomLeft(),&wt,&b);
    }
}
void MAP::Draw_lighted_text(QPainter *p, QString* w, QPointF P,
                            QColor* lightcolor, QColor* textcolor){
    p->setPen(*lightcolor);
    for(int i = 0; i < 28; i++)
        p->drawText(P+HP[i],*w);
    p->setPen(*textcolor);
    p->drawText(P,*w);
}
int MAP::Draw_lighted_text(QPainter* p, KOO *k, QString* w,
                      QColor* lightcolor, QColor* textcolor){
    float x = lontox(k->lon);
    float y = lattoy(k->lat);
    QFontMetricsF fm(p->font());
    QRectF R;
    R.setHeight(fm.height());
    float yoffset = fm.ascent()-fm.strikeOutPos();
    float yso = fm.strikeOutPos();
    R.setWidth(fm.width(*w));
    R.moveTo(x-R.width()/2,y-yoffset);
    if(check_TemplateSpace(R)){
        set_TemplateSpace(R);
        Draw_lighted_text(p,w,QPointF(R.left(),y+yso),lightcolor,textcolor);
        return 1;
    }
    else
        return 0;
}

float MAP::zoomsize(float size){
    return size * sqrt(40/zoom);
}
void MAP::linestoTemplate(lines* f,char val){
/*Edge-flag-Algorithmus*/
    if(f->way->node[0]== f->way->node[f->way->nodec-1]){
    /*falls eine geschlossene Kurve voliegt*/
        int i,j,ymin,ymax,xmin;
        float dxdy;
        templatepoint* p = new templatepoint[f->way->nodec];

        /*Koordinaten berechnen*/
        for(i = 0; i < f->way->nodec; i++){
            p[i].x = lontox(f->way->node[i]->lon);
            p[i].y = lattoy(f->way->node[i]->lat);
        }

        /*Schablone setzen*/
        for(i = 0; i < f->way->nodec-1; i++){
            if(p[i+1].y != p[i].y){
            /*fallsPolygonteil beitrag liefert*/
                if(p[i+1].y > p[i].y){
                    ymin = p[i].y;
                    ymax = p[i+1].y;
                    dxdy = float(1.*(p[i+1].x - p[i].x)/(ymax - ymin));
                    xmin = p[i].x;
                }
                else{
                    ymin = p[i+1].y;
                    ymax = p[i].y;
                    xmin = p[i+1].x;
                    dxdy = float(1.*(p[i].x - p[i+1].x)/(ymax - ymin));
                }
                for(j = ymin; j < ymax; j++)
                    set(xmin+int((j-ymin)*dxdy),j,val);
            }
        }
        delete p;
    }
}
void MAP::TemplatetoColorData(){
    int x , y;
    int wor = qRed(MS->woodcolor);
    int wog = qGreen(MS->woodcolor);
    int wob = qBlue(MS->woodcolor);
    float woa = 1.*qAlpha(MS->woodcolor)/255.;
    int war = qRed(MS->watercolor);
    int wag = qGreen(MS->watercolor);
    int wab = qBlue(MS->watercolor);
    float waa = 1.*qAlpha(MS->watercolor)/255.;

    short wood ,water;
    for(y = 0; y < height; y++){
        wood = water = 0;
        for(x = 0; x < width; x++){
            if(t[x][y] %10 == 1){
                if(wood)    wood = 0;
                else        wood = 1;
            }
            if(t[x][y] >= 10){
                if(water)   water = 0;
                else        water = 1;
            }
            if(water == 1){
                cd[y *(3*width+lineos)+x*3+0] = uchar(cd[y *(3*width+lineos)+x*3+0]*(1-waa)+waa*war);
                cd[y *(3*width+lineos)+x*3+1] = uchar(cd[y *(3*width+lineos)+x*3+1]*(1-waa)+waa*wag);
                cd[y *(3*width+lineos)+x*3+2] = uchar(cd[y *(3*width+lineos)+x*3+2]*(1-waa)+waa*wab);
            }
            else
                if(wood == 1){
                    cd[y *(3*width+lineos)+x*3+0] = uchar(cd[y *(3*width+lineos)+x*3+0]*(1-woa)+woa*wor);
                    cd[y *(3*width+lineos)+x*3+1] = uchar(cd[y *(3*width+lineos)+x*3+1]*(1-woa)+woa*wog);
                    cd[y *(3*width+lineos)+x*3+2] = uchar(cd[y *(3*width+lineos)+x*3+2]*(1-woa)+woa*wob);
                }
        }
    }
}
inline void MAP::set(int x, int y,char val){
    if(y >= 0 && x < width && y < height){
        if(x < 0)
            x = 0;
        if(val == 10){
            // water
            if(t[x][y] >= 10)
                t[x][y] -= 10;
            else
                t[x][y] += 10;
        }
        else{
            // wood
            if(t[x][y] % 10 == 1)
                t[x][y] -= 1;
            else
                t[x][y] += 1;
        }
    }
}

void MAP::reset_Template(){
    int i,j;
    for(i = 0; i < width; i++)
        for(j = 0; j < height; j++)
            t[i][j] = 0;
}
short MAP::check_TemplateSpace(QRectF R){
    if(R.height() == 0 || R.width() == 0)
        return 1;
    short result = 1;
    int x,y,xmin,xmax,ymin,ymax;
    if(R.bottom() >= height)ymax = height;
    else					ymax = int(R.bottom()+1);
    if(R.top()	 < 0)		ymin = 0;
    else					ymin = int(R.top());
    if(R.right() >= width)	xmax = width;
    else					xmax = int(R.right()+1);
    if(R.left()	 < 0)		xmin = 0;
    else					xmin = int(R.left());
    for(y = ymin ; y < ymax; y++)
        for(x = xmin ; x < xmax; x++)
            if (t[x][y] > 0){
                y = ymax;
                x = xmax;
                result = 0;
            }
    return result;
}
void MAP::set_TemplateSpace(QRectF R){
    if(R.height() == 0 || R.width() == 0)
        return;
    int x,y,xmin,xmax,ymin,ymax;
    if(R.bottom() >= height) ymax = height;
    else						ymax = int(R.bottom()+1);
    if(R.top()	 < 0)		ymin = 0;
    else						ymin = int(R.top());
    if(R.right() >= width)	xmax = width;
    else						xmax = int(R.right()+1);
    if(R.left()	 < 0)		xmin = 0;
    else						xmin = int(R.left());
    for(y = ymin ; y < ymax; y++)
        for(x = xmin ; x < xmax; x++)
            t[x][y] = 1;
}
short MAP::check_TemplateSpace(QRectF R, char l){
    if(R.height() == 0 || R.width() == 0)
        return 1;
    short result = 1;
    int x,y,xmin,xmax,ymin,ymax;
    if(R.bottom() >= height) ymax = height;
    else						ymax = int(R.bottom()+1);
    if(R.top()	 < 0)		ymin = 0;
    else						ymin = int(R.top());
    if(R.right() >= width)	xmax = width;
    else						xmax = int(R.right()+1);
    if(R.left()	 < 0)		xmin = 0;
    else						xmin = int(R.left());
    for(y = ymin ; y < ymax; y++)
        for(x = xmin ; x < xmax; x++)
            if (t[x][y] >= l){
                y = ymax;
                x = xmax;
                result = 0;
            }
    return result;
}
void MAP::set_TemplateSpace(QRectF R, char l){
    if(R.height() == 0 || R.width() == 0)
        return;
    int x,y,xmin,xmax,ymin,ymax;
    if(R.bottom() >= height) ymax = height;
    else						ymax = int(R.bottom()+1);
    if(R.top()	 < 0)		ymin = 0;
    else						ymin = int(R.top());
    if(R.right() >= width)	xmax = width;
    else						xmax = int(R.right()+1);
    if(R.left()	 < 0)		xmin = 0;
    else						xmin = int(R.left());
    for(y = ymin ; y < ymax; y++)
        for(x = xmin ; x < xmax; x++)
            t[x][y] = l;
}
int MAP::IntSec(QRectF R, char l){
    if(R.height() == 0 || R.width() == 0)
    return 0;
    short result = 0;
    int x,y,xmin,xmax,ymin,ymax;
    if(R.bottom() >= height) ymax = height;
    else						ymax = int(R.bottom()+1);
    if(R.top()	 < 0)		ymin = 0;
    else						ymin = int(R.top());
    if(R.right() >= width)	xmax = width;
    else						xmax = int(R.right()+1);
    if(R.left()	 < 0)		xmin = 0;
    else						xmin = int(R.left());
    for(y = ymin ; y < ymax; y++)
        for(x = xmin ; x < xmax; x++)
            if (t[x][y] >= l)
                result++;
    return result;
}
int MAP::Draw_aligned_text(QPainter* g,QPointF* path,int pointcount, QString*w,
                           QPointF P,QBrush* lightbrush, QBrush* textbrush){
    if(w->isEmpty())
        return 0;
    int i,j;

    QMatrix matrix, KOOfwd,KOObwd;
    QFontMetricsF fm(g->font());

    QRectF brect,crect;
    QPointF O(0,0);

    /*Bestimme die Laenge des zu druckenden Wortes*/
    int strhigh = w->length();
    double* x;

    /*Drehe Koordinatensystem, zuerst Drehwinkel bestimmen*/
    double PHI;
    brect = fm.boundingRect(*w);
    if(sqrt((path[0].y()-path[pointcount-1].y())*(path[0].y()-path[pointcount-1].y())
           +(path[0].x()-path[pointcount-1].x())*(path[0].x()-path[pointcount-1].x()))
        < brect.width()){
        /*falls die Linienenden nah beieinander liegen wird eine Gerade durch
        die Punktwolke gefittet und aus ihr der Drehwinkel bestimmt*/
        x = FitPolynom(path,pointcount,1);
        if(x != NULL) PHI = -atan(x[0])/M_PI*180;
        else		  PHI = 90;
    }
    else
        /*sonst wird einfach die durchschnittliche Steiung der Linie für den
        Drehwinkel herangezogen*/
        PHI = -atan((path[0].y()-path[pointcount-1].y())/(path[0].x()-path[pointcount-1].x()))/M_PI*180;

    KOOfwd.reset();
    KOOfwd.rotate(qreal(PHI));
    KOOfwd.translate(-path[pointcount/2].x(),-path[pointcount/2].y());
    for(int i = 0; i < pointcount; i++)
        path[i] = KOOfwd.map(path[i]);
    P = KOOfwd.map(P);
    KOObwd = KOOfwd.inverted();

    /*Bestimme das Polynom, an dem Text ausgerichet werden soll*/
    int grad = min(5,pointcount);						//Startwert
    x = NULL;
    while(x == NULL &&  grad >= 0){
        grad--;
        x = FitPolynom(path,pointcount,grad);
    }

    /*falls Polynom gefunden wurde, kann die Routine durchgeführt werden*/
    if(x != NULL){
        /*malt das Polynom
        g->setPen(QPen(Qt::white,1));
        QPointF polynom[300];
        for(j = 0; j < 300; j++){
            polynom[j].setX(j-150);
            polynom[j].setY(fpln(polynom[j].x(),x,grad));
            polynom[j] = KOObwd.map(polynom[j]);
        }
        g->drawPoints(polynom,300);*/

        /*Lege die Buchstaben an*/
        QPainterPath* c = new QPainterPath[strhigh];
        float* clen = new float[strhigh];
                                        //länge eines Buchstaben
        float* cangle = new float[strhigh];
                                        //Winkel eines Buchstaben, in Grad
        float strlenpx = 0, lent = 0;
        double em = fm.width('M');
        double yoffset = fm.strikeOutPos();
        for(i = 0; i < strhigh; i++){
            brect = fm.boundingRect(w->mid(i,1));
            c[i].addText(0,0,g->font(),w->mid(i,1));
            crect = c[i].boundingRect();
            clen[i] = qMax(crect.width()*1.4,0.3*em);
            strlenpx = strlenpx + clen[i];
            c[i].translate(-crect.left(),yoffset);
        }

        /*Startpunkte (sp) und Winkel (cangle) der Buchstaben anlegen*/
        i = 0;
        while(lent < strlenpx/2 && i < strhigh-1){
            lent = lent + clen[i];
            i++;
        }
        lent = lent-strlenpx/2;


        QPointF* sp = new QPointF[strhigh];
        float dx = 0, dy = 0;

        /*Zuerst Wort mittig in P platzieren*/
        P.setY(fpln(P.x(),x,grad));
        while(sqrt(dx*dx+dy*dy) <= lent){
            dx = dx + float(0.01);
            dy = float(P.y()-fpln(double(P.x() + dx),x,grad));
        }
        sp[i].setX(P.x() + dx);
        sp[i].setY(fpln(sp[i].x(),x,grad));

        /*dann den rechten und linken Worteil ergänzen*/
        for(j = i-1; j >= 0; j--){		//linker Wortteil
            dx = 0;
            dy = 0;
            while(sqrt(dx*dx+dy*dy) <= clen[j]){
                dx = dx + float(0.01);
                dy = sp[j+1].y()-float(fpln(sp[j+1].x()-dx,x,grad));
            }
            sp[j].setX(sp[j+1].x() - dx);
            sp[j].setY(sp[j+1].y() - dy);
            cangle[j] = float(atan(dy/dx)/M_PI*180);
        }

        for(j = i+1; j < strhigh; j++){	//rechter Wortteil
            dx = 0;
            dy = 0;
            while(sqrt(dx*dx+dy*dy) <= clen[j-1]){
                dx = dx + float(0.01);
                dy = sp[j-1].y()-float(fpln(sp[j-1].x()+dx,x,grad));
            }
            sp[j].setX(sp[j-1].x() + dx);
            sp[j].setY(sp[j-1].y() - dy);
            cangle[j-1] = float(atan(-dy/dx)/M_PI*180);
        }

        dx = 0;							//Winkel des letzten Buchstaben
        dy = 0;
        while(sqrt(dx*dx+dy*dy) <= clen[strhigh-1]){
                dx = dx + float(0.01);
                dy = sp[strhigh-1].y()-float(fpln(sp[strhigh-1].x()+dx,x,grad));
            }
        cangle[strhigh-1] = float(atan(-dy/dx)/M_PI*180);

        /*Buchstaben an die Richtige Stelle verschieben und
        KOO-Ruecktransformation durchführen, Buchstaben wieder zu Wort
        zusammenfügen und zeichnen*/
        QPainterPath cg;
        cg.setFillRule(Qt::WindingFill);
        int freespace = 1;
        QList<QRectF> spacelist;
        for(i = 0; i < strhigh; i++){
            matrix.reset();
            matrix.translate(sp[i].x(),sp[i].y());
            matrix.rotate(cangle[i]);
            c[i] = matrix.map(c[i]);
            c[i] = KOObwd.map(c[i]);
            brect = c[i].boundingRect();
            if(!check_TemplateSpace(brect)){
                freespace = 0;
                i = strhigh;
            }
            else{
                cg.addPath(c[i]);
                spacelist.append(brect);
            }
        }
        if(freespace){
            Draw_lighted_Path(g,&cg,lightbrush,textbrush);
            for(i = 0; i < strhigh; i++)
                set_TemplateSpace(spacelist.at(i));
        }


        /*Hilfsdaten löschen*/
        delete clen;
        delete cangle;
        delete sp;
        delete[] c;

        if(freespace)
            return 1;
        else
            return 0;
    }
    else
        return 0;
}
void MAP::Draw_lighted_Path(QPainter* g, QPainterPath* p,
                            QBrush* lightbrush,QBrush* textbrush){
    g->setPen(QPen(*lightbrush,4.5));
    g->setBrush(Qt::NoBrush);
    g->drawPath(*p);
    g->setPen(Qt::NoPen);
    g->setBrush(*textbrush);
    g->drawPath(*p);
}
double MAP::scale(){
    /*km pro Pixel*/
    return zoom/1000.;
}
void MAP::draw_line(QPainter* p, KOOlist* k, int kc){
    if(kc > 0){
        QPointF* pts = new QPointF[kc];
        int ci = 1;
        pts[0].setX(lontox(k[0].k->lon));
        pts[0].setY(lattoy(k[0].k->lat));
        for(int i = 1; i < kc; i++){
            pts[ci].setX(lontox(k[i].k->lon));
            pts[ci].setY(lattoy(k[i].k->lat));
            if((pts[ci]-pts[ci-1]).manhattanLength()>5
               || i == kc-1)
                ci++;
        }
        p->drawPolyline(pts,ci);
        delete pts;
    }
}
void MAP::draw_line(QPainter* p, KOO** k, int count){
    QPointF* pts = new QPointF[count];
    for(int cp = 0; cp < count; cp++){
        pts[cp].setX(lontox(k[cp]->lon));
        pts[cp].setY(lattoy(k[cp]->lat));
    }
    p->drawPolyline(pts,count);
    delete pts;
}
void MAP::draw_line(QPainter* p, double** k, int count){
    QPointF* pts = new QPointF[count];
    for(int cp = 0; cp < count; cp++){
        pts[cp].setX(lontox(k[1][cp]));
        pts[cp].setY(lattoy(k[0][cp]));
    }
    p->drawPolyline(pts,count);
    delete pts;
}
void MAP::draw_line(QPainter* p, Track* ct){
    int kc;
    KOOlist* kl;
    ct->get_data_ref(NULL,NULL,&kl,&kc);
    draw_line(p,kl,kc);
    double r = zoomsize(MS->trackwidth);
    p->setPen(Qt::NoPen);
    for(int i = 0; i < kc; i++)
        if(kl[i].marked)
            p->drawEllipse(lon_to_x(kl[i].k->lon)-r,
                           lat_to_y(kl[i].k->lat)-r,
                           2*r,2*r);
}
void MAP::draw_elements(Track* ct, KOO* kold, KOO* knew, Way* selected_way){
    delete cmapf;
    cmapf = new QPixmap(*cmap);
    double r = zoomsize(MS->trackwidth);
    QPainter p(cmapf);
    p.setPen(QPen(QBrush(MS->trackcolor),zoomsize(MS->trackwidth)));
    p.setBrush(QBrush(MS->trackcolor));

    // draws regular track
    if(ct != NULL)
        draw_line(&p,ct);

    // draws cross
    p.setPen(Qt::NoPen);
    p.setBrush(QBrush(Qt::green));
    if(kold != NULL)
        p.drawEllipse(lon_to_x(kold->lon)-r,lat_to_y(kold->lat)-r,2*r,2*r);
    if(knew != NULL)
        p.drawEllipse(lon_to_x(knew->lon)-r,lat_to_y(knew->lat)-r,2*r,2*r);

    // draws selected way
    p.setPen(QPen(QBrush(Qt::red),zoomsize(MS->trackwidth)));
    if(selected_way != NULL)
        draw_line(&p,selected_way->node,selected_way->nodec);

    delete cmapff;
    cmapff = new QPixmap(*cmapf);

    repaint();
}

void MAP::show_elements(Way* w, int X, int Y, QBrush b){
    delete cmapff;
    cmapff = new QPixmap(*cmapf);
    double r = zoomsize(MS->trackwidth);
    QPainter p(cmapff);
    p.setPen(QPen(QBrush(Qt::red),zoomsize(MS->trackwidth)));
    if(w != NULL)
        draw_line(&p,w->node,w->nodec);
    p.setBrush(b);
    p.setPen(Qt::NoPen);
    p.drawEllipse(X-r,Y-r,2*r,2*r);
    repaint();
}

void MAP::save_to_png(QString filename){
    cmap->save(filename,"PNG");
}
void MAP::climblayer_to_map(climblayer* cl){
    QPainter p(cmap);
    p.setRenderHint(QPainter::Antialiasing);
    QColor  blight(140,140,140,60);
    /*Strecken malen*/
    for(long i = 0; i < cl->climbcount; i++){
        float linewidth = zoomsize(3);
        QColor c = colorgradient((sqrt(cl->climb[i].P)-2.23)/7.61);
        p.setPen(QPen(Qt::black,linewidth*zoomsize(0.6)+2));
        draw_line(&p,cl->climb[i].KOOarray,cl->climb[i].KOOcount);
        p.setPen(QPen(c,linewidth*zoomsize(0.6)));
        draw_line(&p,cl->climb[i].KOOarray,cl->climb[i].KOOcount);
    }
    /*Beschriftungen malen*/
    QString w;
    reset_Template();
    for(long i = cl->climbcount - 1; i >= 0 ; i--){
        int mindex = cl->climb[i].KOOcount/2;
        KOO k;
        k.lon = cl->climb[i].KOOarray[1][mindex];
        k.lat = cl->climb[i].KOOarray[0][mindex];
        if(o->isin(&k,minlat,maxlat,minlon,maxlon)){
            QColor c = colorgradient((sqrt(cl->climb[i].P)-2.23)/7.61);
            c = c.dark(300);
            /*w = QString("%.1f P %.0f Hm\n%.1f %% %.1f S")
                    .arg(cl->climb[i].P),
                    .arg(cl->climb[i].hmup,
                    .arg(cl->climb[i].slope,
                   .arg(cl->climb[i].bend);*/
            w = QString("%1 m").arg(cl->climb[i].P,0,'f',1);
            p.setFont(QFont("Arial",8 + 10 * cl->climb[i].LocRank,QFont::Bold));
            if(!Draw_lighted_text(&p,&k,&w,&blight,&c)){
                int s = 0; short repeat;
                do{
                    if(s > 0)	s = -s;
                    else    	s = -s + 1;
                    if((mindex+s)>= 0 && (mindex+s)< cl->climb[i].KOOcount){
                        k.lon = cl->climb[i].KOOarray[1][mindex];
                        k.lat = cl->climb[i].KOOarray[0][mindex];
                        if(Draw_lighted_text(&p,&k,&w,&blight,&c))
                            repeat = 0;
                    }
                    else
                        repeat = 0;

                }while(repeat);
            }
        }
    }
}
void MAP::STRONGlayer_to_Map(QPainter* p,STRONGlayer* SL){
    if(SL->data != NULL){
        QPainter* g;
        if(p != NULL)
            g = p;
        else{
            g = new QPainter(cmap);
            g->setRenderHint(QPainter::Antialiasing);
        }
        KOO** k;
        float linewidth;
        float x;
        for(int drawblack = 1; drawblack >= 0; drawblack --){
            for(long int i = 0; i < SL->ncount; i++){
                if(SL->data[i].n != NULL){
                    k = &(SL->data[i].n->node[0]);
                    x = sqrt(qMax(float(0.),SL->data[i].index));
                    linewidth = 1+(4+zoomsize(6.8))*x;
                    QPointF* p = new QPointF[SL->data[i].n->nodec];
                    for(int j = 0; j < SL->data[i].n->nodec; j++){
                        p[j].setX(lontox(k[j]->lon));
                        p[j].setY(lattoy(k[j]->lat));
                    }
                    if(drawblack){
                        g->setPen(QPen(Qt::black,linewidth,Qt::SolidLine,Qt::RoundCap));
                        g->drawPolyline(p,SL->data[i].n->nodec);
                    }
                    else{
                        if(linewidth >= 2){
                            linewidth = linewidth - 2;
                            g->setPen(QPen(Qt::green,linewidth,Qt::SolidLine,Qt::RoundCap));
                            g->drawPolyline(p,SL->data[i].n->nodec);
                        }
                    }
                    delete p;
                }
            }
        }
        if(p == NULL)
            delete g;
    }
}
void MAP::add_BestClimb_Bar(QPainter* p,climblayer* cl){
    if(cl != NULL){
        float bendv;
        int vsteps = height / 15;
        int hsteps = width / 20;
        float *hP = new float[hsteps];
        float *hbend = new float[hsteps];
        float *hslope = new float[hsteps];
        float *vP = new float[vsteps];
        float *vbend = new float[vsteps];
        float *vslope = new float[vsteps];
        for(int i = 0; i < hsteps; i++)
            hP[i] = hbend[i] = hslope[i] = 0;
        for(int i = 0; i < vsteps; i++)
            vP[i] = vbend[i] = vslope[i] = 0;
        int ix,iy;
        /*Array fuellen*/
        for(int  i = 0; i < cl->climbcount; i++){
            ix = hsteps * lontox(cl->climb[i].midlon)/width;
            iy = vsteps * lattoy(cl->climb[i].midlat)/height;
            if(ix >= 0 && ix < hsteps && iy >= 0 && iy < vsteps){
                bendv = cl->climb[i].bend*cl->climb[i].bend*cl->climb[i].d/48.;
                if(cl->climb[i].P > hP[ix])
                    hP[ix] = cl->climb[i].P;
                if(cl->climb[i].slope > hslope[ix])
                    hslope[ix] = cl->climb[i].slope;
                if(bendv > hbend[ix])
                    hbend[ix] = bendv;
                if(cl->climb[i].P > vP[iy])
                    vP[iy] = cl->climb[i].P;
                if(cl->climb[i].slope > vslope[iy])
                    vslope[iy] = cl->climb[i].slope;
                if(bendv > vbend[iy])
                    vbend[iy] = bendv;
            }

        }
        /*Arrays zeichnen*/
        QPainter* g;
        if(p != NULL)
            g = p;
        else
            g = new QPainter(cmap);
        g->setRenderHint(QPainter::Antialiasing);
        g->setFont(QFont("Arial",10,QFont::Bold));
        QString w;
        float t,l,rt;
        for(int i = 0; i < hsteps; i++){
            if(hP[i] > 0){
                w = QString("%1").arg(hP[i],0,'f',0);
                QColor c = colorgradient((sqrt(hP[i])-2.23)/7.61);
                if(c == Qt::black)
                    c = Qt::white;
                l = 1.*width * i/hsteps;
                rt = qMin(width-1.,1.*width * (i+1)/hsteps);
                QRectF r; r.setRect(l,height-13.5,rt-l,13);
                g->setBrush(QBrush(c));
                g->setPen(Qt::NoPen);
                g->drawRect(r);
                g->setPen(QPen(Qt::black,2));
                g->drawText(r,Qt::AlignCenter,w);
                g->setPen(QPen(Qt::white,2));
                g->drawLine(r.left(),r.top()+1,
                            r.left()+ r.width()*qMin(1.,double(sqrt(hbend[i]))),r.top()+1);
                g->drawLine(r.left(),r.bottom()-1,
                           r.left()+ r.width()*qMin(1.,double(sqrt(hbend[i]))),r.bottom()-1);
                r.moveTop(0.5);
                g->setPen(Qt::NoPen);
                g->drawRect(r);
                g->setPen(QPen(Qt::black,2));
                g->drawText(r,Qt::AlignCenter,w);
                g->setPen(QPen(Qt::white,2));
                g->drawLine(r.left(),r.top()+1,
                            r.left()+ r.width()*qMin(1.,double(sqrt(hbend[i]))),r.top()+1);
                g->drawLine(r.left(),r.bottom()-1,
                           r.left()+ r.width()*qMin(1.,double(sqrt(hbend[i]))),r.bottom()-1);
            }
        }
        for(int i = 0; i < vsteps; i++){
            if(vP[i] > 0){
                w = QString("%1").arg(vP[i],0,'f',0);
                QColor c = colorgradient((sqrt(vP[i])-2.23)/7.61);
                if(c == Qt::black)
                    c = Qt::white;
                t = floor(1.*height * i/vsteps)+0.5;
                QRectF r; r.setRect(0,t,20,14);
                g->setBrush(QBrush(c));
                g->setPen(Qt::NoPen);
                g->drawRect(r);
                g->setPen(QPen(Qt::black,2));
                g->drawText(r,Qt::AlignCenter,w);
                g->setPen(QPen(Qt::white,2));
                g->drawLine(r.left(),r.top()+1,
                            r.left()+ r.width()*qMin(1.,double(sqrt(hbend[i]))),r.top()+1);
                g->drawLine(r.left(),r.bottom()-1,
                           r.left()+ r.width()*qMin(1.,double(sqrt(hbend[i]))),r.bottom()-1);
                r.moveRight(width-0.5);
                g->setPen(Qt::NoPen);
                g->drawRect(r);
                g->setPen(QPen(Qt::black,2));
                g->drawText(r,Qt::AlignCenter,w);
                g->setPen(QPen(Qt::white,2));
                g->drawLine(r.left(),r.top()+1,
                            r.left()+ r.width()*qMin(1.,double(sqrt(hbend[i]))),r.top()+1);
                g->drawLine(r.left(),r.bottom()-1,
                           r.left()+ r.width()*qMin(1.,double(sqrt(hbend[i]))),r.bottom()-1);
            }
        }
        if(p == NULL)
            delete g;
        if(hsteps>0){
            delete hP;
            delete hbend;
            delete hslope;
        }
        if(vsteps){
            delete vP;
            delete vbend;
            delete vslope;
        }
    }
}
void MAP::draw_map(STRONGlayer* SL, climblayer* cl, Track *ct, int fastmode){
    if(fastmode || cl == NULL)  SRTM3toMAP(0);
    else                        SRTM3ClimbtoMAP(cl);
    reset_Template();
    if(MS->drawwood)    facetoTemplate(o->wood,1);
    if(MS->drawater)    facetoTemplate(o->water,10);
    if(MS->drawater || MS->drawwood)
        TemplatetoColorData();
    QImage img(cd,width,height,QImage::Format_RGB888);
    //QPainter p(cmap);
    //p.drawImage(0,0,img);
    QPainter p(&img);
    p.setRenderHint(QPainter::Antialiasing);
    if(MS->drawater){
        linetomap(o,&p,o->creek,QColor::fromRgba(MS->watercolor), zoomsize(1 ),1);
        linetomap(o,&p,o->river,QColor::fromRgba(MS->watercolor), zoomsize(4 ),1);
    }
    if(SL != NULL)
        STRONGlayer_to_Map(&p,SL);
    else{
        if(MS->drawstreetcontour){
            linetomap(o,&p,o->track,	Qt::black,zoomsize(MS->roadwidth[4])+2,3);
            linetomap(o,&p,o->secondary,Qt::black,zoomsize(MS->roadwidth[3])+2,3);
            linetomap(o,&p,o->primary,	Qt::black,zoomsize(MS->roadwidth[2])+2,3);
            linetomap(o,&p,o->highway,	Qt::black,zoomsize(MS->roadwidth[1])+2,3);
            linetomap(o,&p,o->motorWay, Qt::black,zoomsize(MS->roadwidth[0])+2,3);
        }
        linetomap(o,&p,o->track2,   QColor::fromRgba(MS->roadcolor[5]),zoomsize(MS->roadwidth[5]),1);
        linetomap(o,&p,o->track,	QColor::fromRgba(MS->roadcolor[4]),zoomsize(MS->roadwidth[4]),1);
        linetomap(o,&p,o->secondary,QColor::fromRgba(MS->roadcolor[3]),zoomsize(MS->roadwidth[3]),1);
        linetomap(o,&p,o->primary,	QColor::fromRgba(MS->roadcolor[2]),zoomsize(MS->roadwidth[2]),1);
        linetomap(o,&p,o->highway,	QColor::fromRgba(MS->roadcolor[1]),zoomsize(MS->roadwidth[1]),1);
        linetomap(o,&p,o->motorWay, QColor::fromRgba(MS->roadcolor[0]),zoomsize(MS->roadwidth[0]),1);
    }
    if(cl != NULL)
        ClimbTracks(&p,cl);
    if(ct != NULL){
        p.setPen(QPen(QBrush(MS->trackcolor),zoomsize(MS->trackwidth)));
        draw_line(&p,ct);
    }
    reset_Template();
    if(MS->drawpoints){
        pointtomap(o,&p,o->metropolis,	QColor::fromRgba(MS->pointcolor[0]),zoomsize(MS->pointsize[0]));
        pointtomap(o,&p,o->city,		QColor::fromRgba(MS->pointcolor[1]),zoomsize(MS->pointsize[1]));
    }
    if(MS->drawsummit)
        peaktomap(o,&p,o->peak,1500,1e10,QColor::fromRgba(MS->summitcolor),zoomsize(MS->summitsize));
    if(cl != NULL)
        ClimbLabels(&p,cl,fastmode);
    if(MS->drawater)
        rivernametomap(o,&p,o->river,	QColor::fromRgba(MS->watercolor),	zoomsize(8 ));
    if(MS->drawpoints)
        pointtomap(o,&p,o->town,		QColor::fromRgba(MS->pointcolor[2]),zoomsize(MS->pointsize[2]));
    if(MS->drawsummit)
        peaktomap(o,&p,o->peak,0,1500,  QColor::fromRgba(MS->summitcolor),zoomsize(MS->summitsize));
    if(MS->drawater)
        waternametomap(o,&p,o->water,	QColor::fromRgba(MS->watercolor), zoomsize(8 ));
    if(MS->drawpoints){
        pointtomap(o,&p,o->village,		QColor::fromRgba(MS->pointcolor[3]),zoomsize(MS->pointsize[3]));
        pointtomap(o,&p,o->locality,    QColor::fromRgba(MS->pointcolor[4]),zoomsize(MS->pointsize[4]));
        pointtomap(o,&p,o->col,         QColor::fromRgba(MS->pointcolor[5]),zoomsize(MS->pointsize[5]));
    }
    if(MS->drawstreetlabel){
        rivernametomap(o,&p,o->track2,    QColor(1,1,1),zoomsize(8));
        rivernametomap(o,&p,o->track,     QColor(1,1,1),zoomsize(8));
        rivernametomap(o,&p,o->secondary, QColor(1,1,1),zoomsize(4));
        rivernametomap(o,&p,o->primary,	  QColor(1,1,1),zoomsize(4));
        rivernametomap(o,&p,o->highway,	  QColor(1,1,1),zoomsize(4));
        rivernametomap(o,&p,o->motorWay,  QColor(1,1,1),zoomsize(8));
    }
    if(MS->drawscale)
        add_scale(&p);

    add_BestClimb_Bar(&p,cl);
    //p.end();
    delete cmap;
    //cmap = new QPixmap(width,height);
    //cmap->fill(Qt::red);
    cmap = new QPixmap(width,height);
    //cmap->fill(Qt::red);
    cmap->convertFromImage(img);
    //QPainter p2(cmap);
    //p2.drawImage(0,0,img);
    delete cmapf;
    cmapf = new QPixmap(*cmap);
    delete cmapff;
    cmapff = new QPixmap(*cmapf);

    emit new_rawmap();
}
void MAP::SRTM3ClimbtoMAP(climblayer* cl){
    // first extend heighdata area by 1 screen px in every direction
    double minlatex = mercatortolat(mminlat - (mmaxlat-mminlat)/height);
    double maxlatex = mercatortolat(mmaxlat + (mmaxlat-mminlat)/height);
    double minlonex = minlon - (maxlon - minlon)/width;
    double maxlonex = maxlon + (maxlon - minlon)/width;

    hd->set_rect(minlatex,maxlatex,minlonex,maxlonex);
    if(pxperlat < 1)
        /*map show big area*/
        hd->interpolate_linear_mercator(width+2,height+2,0,hc,dhdx,dhdy);
    else
        /*map shows small area, detailed presentation necessary*/
        hd->interpolate_bicubic_conv3_mercator(width+2,height+2,0,hc,dhdx,dhdy);
    add_DEM();
    if(MS->drawcontour)
        add_contour();
    climblayer_schading(cl);
}
void MAP::climblayer_schading(climblayer* cl){
    if(cl != NULL){
        /*Rasterdaten anlegen*/
        double d, lat, lon, dx ,dy,gmax = 0;
        double spergx = 20;
        double spergy = 20;
        int gx = width / spergx;
        int gy = height / spergy;
        spergx = 1.*width / (gx-1);
        spergy = 1.*height / (gy-1);

        double **grid = (double**)malloc(gx*sizeof(double*));
        for(int x = 0; x < gx; x++)
            grid[x] = (double*)malloc(gy*sizeof(double));
        for(int x = 0; x < gx; x++)
            for(int y = 0; y < gy; y++){
                grid[x][y] = 0;
                lat = maxlat - (maxlat-minlat)*y/(gy-1);
                lon = minlon + (maxlon-minlon)*x/(gx-1);
                for(int i = 0; i < cl->climbcount; i++){
                    d = distance(lat,lon,cl->climb[i].midlat,cl->climb[i].midlon);
                    grid[x][y] += cl->climb[i].P/(1.+(d*d*d*d*d*d/512./512.));
                }
                grid[x][y] = sqrt(grid[x][y]);
                if(grid[x][y] > gmax)
                    gmax = grid[x][y];

            }
        for(int x = 0; x < gx-1; x++)
            for(int y = 0; y < gy-1; y++)
                for(int xx = ceil(x * spergx); xx < qMin(double(width-1.),(x+1)*spergx); xx++)
                    for(int yy = ceil(y * spergy); yy < qMin(double(height-1.),(y+1)*spergy); yy++){
                        dx = 1.*xx/spergx - x;
                        dy = 1.*yy/spergy - y;
                        d = grid[x+0][y+0]*(1-dx) * (1-dy) +
                            grid[x+1][y+0]*(  dx) * (1-dy) +
                            grid[x+0][y+1]*(1-dx) * (  dy) +
                            grid[x+1][y+1]*(  dx) * (  dy);
                        d = d / gmax;
                        QRgb c = colorgradientSchading(d).rgb();
                        uchar* cdt = &(cd[yy*(3*width+lineos)+xx*3]);
                        cdt[0] = uchar((1.-MS->climblayershading) * cdt[0] +
                                MS->climblayershading  * cdt[0]* qRed(c)/255.);
                        cdt[1] = uchar((1.-MS->climblayershading) * cdt[1] +
                                MS->climblayershading  * cdt[1]* qGreen(c)/255.);
                        cdt[2] = uchar((1.-MS->climblayershading) * cdt[2] +
                                MS->climblayershading  * cdt[2]* qBlue(c)/255.);
                    }
        for(int x = 0; x < gx; x++)
            free(grid[x]);
        free(grid);
    }
}
void MAP::ClimbTracks(QPainter*p,climblayer* cl){
    /*Strecken malen*/
    for(long i = 0; i < cl->climbcount; i++){
        float linewidth = zoomsize(1.8);
        QColor c = colorgradient((sqrt(cl->climb[i].P)-2.23)/7.61);
        QColor b(0,0,0);
        p->setPen(QPen(Qt::black,linewidth+2));
        draw_line(p,cl->climb[i].KOOarray,cl->climb[i].KOOcount);
        p->setPen(QPen(c,linewidth));
        draw_line(p,cl->climb[i].KOOarray,cl->climb[i].KOOcount);
    }
}
void MAP::ClimbLabels(QPainter*p,climblayer* cl, int fastmode){
    QColor blight(140,140,140,60);
    QString w;
    for(long i = cl->climbcount - 1; i >= 0 ; i--){
        KOO k;
        k.lat = cl->climb[i].midlat;
        k.lon = cl->climb[i].midlon;
        QPointF P(float(lontox(cl->climb[i].midlon)),
                  float(lattoy(cl->climb[i].midlat)));
        if(o->isin(&k,minlat,maxlat,minlon,maxlon)){
            QColor c = colorgradient((sqrt(cl->climb[i].P)-2.23)/7.61);
            c = c.darker(500);
            w = QString("%1").arg(cl->climb[i].P,0,'f',1);
            w = QString().fromUtf8(cl->climb[i].name);
            p->setPen(c);
            p->setFont(QFont("Arial",8 + 10 * cl->climb[i].LocRank,QFont::Bold));
            /*nach bestem Labelplatz suchen*/
            QFontMetricsF fm(p->font());
            QRectF R,Rt;
            int drawn = 1, minIntSec = R.height() * R.width()+100;
            QPointF Pmin = P;
            Track t(cl->climb[i].KOOarray,cl->climb[i].KOOcount);
            double d = cl->climb[i].d / 2.;
            KOO kt;
            int IntSect;
            if(fastmode){
                for(double dt = 0.0; dt < d; dt += d/3.){
                    for(int dtm = -1; dtm <= 1; dtm = dtm + 2){
                        t.extract_KOO(&kt,d+dtm*dt);
                        P = QPointF(float(lontox(kt.lon)),
                                    float(lattoy(kt.lat)));
                        R = fm.boundingRect(w);
                        R.moveTo(P);
                        R.translate(-R.width()/2,-R.height()/2);
                        IntSect = IntSec(R,1);
                        if(IntSect < minIntSec){
                            /*bisher bester Platz*/
                            minIntSec = IntSect;
                            Pmin = P;
                        }
                        if(IntSect == 0){
                            /*perfekter Platz gefunden*/
                            dtm = 2;
                            dt = d;

                        }
                    }
                }
            }
            else{
                int pr;                     // plus-radius
                int mr;                     // minus-radius
                int j;
                int* ref[4][2];
                ref[0][0] = &j;  ref[0][1] = &pr;
                ref[1][0] = &j;  ref[1][1] = &mr;
                ref[2][0] = &pr; ref[2][1] = &j;
                ref[3][0] = &mr; ref[3][1] = &j;
                R = fm.boundingRect(w);
                int radius = floor(min(R.width(),R.height()));
                for(pr = 0; pr <= radius; pr++){
                    mr = -pr;
                    for(double dt = 0.0; dt < d; dt += 0.1){
                        for(int dtm = -1; dtm <= 1; dtm = dtm + 2){
                            t.extract_KOO(&kt,d+dtm*dt);
                            P = QPointF(float(lontox(kt.lon)),float(lattoy(kt.lat)));
                            R = fm.boundingRect(w);
                            R.moveTo(P);
                            R.translate(-R.width()/2,-R.height()/2);
                            for(int k = 0; k < 4; k++){
                                for(j = -pr; j <= pr; j++){
                                    Rt = R;
                                    Rt.translate(*ref[k][0],*ref[k][1]);
                                    IntSect = IntSec(Rt,1);
                                    if(IntSect < minIntSec){
                                        /*bisher bester Platz*/
                                        minIntSec = IntSect;
                                        Pmin = P + QPointF(float(*(ref[k][0])),
                                                           float(*(ref[k][1])));
                                    }
                                    if(IntSect == 0){
                                        /*perfekter Platz gefunden*/
                                        pr = radius;
                                        j = pr + 1;
                                        k = 4;
                                        dtm = 2;
                                        dt = d;

                                    }
                                }
                            }
                        }
                    }
                }
            }
            R = fm.boundingRect(w);
            R.moveTo(Pmin);
            R.translate(-R.width()/2,-R.height()/2);
            P = QPointF(R.left(),R.top()+fm.ascent());
            if(minIntSec == 0){
                Draw_lighted_text(p,&w,P,&blight,&c);
                set_TemplateSpace(R,2);
                drawn = 1;
            }
            else{
                drawn = 0;
                if(fastmode == 0){
                    float alpha = 255*cl->climb[i].LocRank*(1-1.*minIntSec/(R.width()*R.height()));
                    c = colorgradient((sqrt(cl->climb[i].P)-2.23)/7.61);
                    c.setAlpha(alpha);
                    p->setPen(c);
                    p->drawText(P,w);
                    if(alpha > 0.5)
                        set_TemplateSpace(R,2);
                }
            }
            if(drawn){
                float d = - R.left() + R.right();
                p->setPen(QPen(c,2));
                p->drawLine(R.left(),R.top()+1.,R.right(),R.top()+1.);
                p->drawLine(R.left(),R.bottom()-1.,R.right(),R.bottom()-1.);
                p->setPen(QPen(Qt::white,2));
                p->drawLine(R.left(),R.top()+1.,
                            R.left() + d *qMin(1.,sqrt(
                            cl->climb[i].bend*cl->climb[i].bend*cl->climb[i].d/48.)),R.top()+1.);
                p->drawLine(R.left(),R.bottom()-1.,
                            R.left() + d*qMin(1.,(cl->climb[i].slope-5)/10.),R.bottom()-1.);
            }
        }
    }
}
QColor MAP::colorgradient(float x){
    if(x<0	 ) return QColor(		0,		0,		0);
    if(x<0.25) return QColor(	255*x/0.25,255,		0);
    if(x<0.50) return QColor(	255,255*(0.50-x)/0.25,		0);
    if(x<0.75) return QColor(255,0,	(x-0.5)/0.25*255);
    if(x<=1)   return QColor((1-x)/0.25*255,0,255);
    if(x>1)    return QColor(0,0,255);
    return Qt::black;
}
QColor MAP::colorgradientSchading(float x){
    int min = 100;
    int d = 255 - min;
    if(x<0	 ) return QColor(		255,		255,		255);
    if(x<0.2) return QColor(	min+d*(0.2-x)/0.2,255,min+d*(0.2-x)/0.2);
    if(x<0.4) return QColor(	min+d*(x-0.2)/0.2,255,		min);
    if(x<0.6) return QColor(	255,min+d*(0.60-x)/0.2,		min);
    if(x<0.8) return QColor(255,min,	min+d*(x-0.6)/0.2);
    if(x<=1) return QColor(min+d*(1-x)/0.2,min,255);
    if(x>1) return QColor(min,min,255);
    return Qt::black;
}
inline void MAP::mult_color(unsigned char* cd, QColor* c){
    cd[0] = cd[0] * c->red() / 255.;
    cd[1] = cd[1] * c->green() / 255.;
    cd[2] = cd[2] * c->blue() / 255.;
}
void MAP::paintEvent(QPaintEvent *){
    QPainter p(this);
    switch(paintmode){
        case 1:{
            p.drawPixmap((size().width()-width)/2,
                         (size().height()-height)/2,
                         *cmapff);
            QRectF R(qMin(x,xold),qMin(y,yold),qAbs(x-xold),qAbs(y-yold));
            p.setBrush(QBrush(QColor(0,255,0,60)));
            p.drawRect(R);}
            break;
        case 2:{
            p.fillRect(this->rect(),Qt::black);
            p.drawPixmap((size().width()-width)/2  +x-xold,
                         (size().height()-height)/2+y-yold,
                         *cmapff);}
            break;
        case 3:{
            p.fillRect(this->rect(),Qt::black);
            QRectF Rsrc(this->rect());
            p.drawPixmap(zoomrect,*cmapff,Rsrc);
            }
            break;
        default:
            p.drawPixmap((size().width()-width)/2,
                         (size().height()-height)/2,
                         *cmapff);


    }
    paintmode = 0;
}
void MAP::resizeEvent(QResizeEvent *event){
    was_resized = true;
}
void MAP::adapt_map_size_to_window(){
    if(was_resized){
        resize(size().width(),size().height());
        set_borders(Y_to_lat(size().height()-1),
                    Y_to_lat(0),
                    X_to_lon(0),
                    X_to_lon(size().width()-1));
        calc_borders();
        draw_map(NULL,NULL,NULL,1);
        update();
    }
    was_resized = 0;
}

void MAP::scale(double zoomfactor,double dlonfactor, double dlatfactor){
        adapt_map_size_to_window();
        double dlat = (maxlat-minlat)*dlatfactor;
        double dlon = (maxlon-minlon)*dlonfactor;
        double mlat = (maxlat+minlat)/2+dlat;
        double mlon = (maxlon+minlon)/2+dlon;
        dlat = (maxlat-minlat)/2*zoomfactor;
        dlon = (maxlon-minlon)/2*zoomfactor;

        //draw preview
        paintmode = 3;
        zoomrect = QRectF  (-int(size().width() /zoomfactor*(1/2.+dlonfactor-1/2.*zoomfactor)),
                            -int(size().height()/zoomfactor*(1/2.-dlatfactor-1/2.*zoomfactor)),
                             int(size().width() /zoomfactor),
                             int(size().height()/zoomfactor));
        repaint();
        //render new map
        set_borders(mlat-dlat, mlat+dlat, mlon-dlon, mlon+dlon);
        calc_borders();
}


