﻿#include "Routing.h"

Routing::Routing(OSM *o){
    this->o = o;
}
Routing::~Routing(void){
}
Track* Routing::airline(HeightData* h, KOO* s, KOO* e){
    double d = distance(s->lat,s->lon,e->lat,e->lon);
    int pc = d/0.05 + 2;
    KOOlist* kl = new KOOlist[pc];
    trackpoint* tpl = new trackpoint[pc];
    kl[0   ].k = s; if(1||kl[0   ].k->cd != NULL) kl[0   ].marked = 1;
    kl[pc-1].k = e; if(1||kl[pc-1].k->cd != NULL) kl[pc-1].marked = 1;
    for(int i = 1; i < pc - 1; i++){
        kl[i].k = new KOO;
        kl[i].k->id = -1;
        kl[i].k->lat = s->lat * (pc-1-i)/(pc-1)
                     + e->lat * (     i)/(pc-1);
        kl[i].k->lon = s->lon * (pc-1-i)/(pc-1)
                     + e->lon * (      i)/(pc-1);
        kl[i].marked = 0;
        kl[i].k->cd = NULL;
    }
    for(int j = 0; j < pc; j++){
        tpl[j].d  = kl[j].d = d*j/(pc-1.);
        tpl[j].h = h->height(kl[j].k->lon,kl[j].k->lat,NULL,0);
    }
    return new Track(tpl,pc,kl,pc);
}

short Routing::Dijkstra(KOO* s, KOO* e, char max, char min, OSM* o, int Si,
                        float (*attr)(Neighbour* n)){
    resetSTRONG(o->get_first_KOO(),Si);
    if(s != NULL && s->cd != NULL){
        Neighbour* n;
        FibunacciHeap<STRONGfib> f;
        STRONGfib* t = f.ins(0), *t2;
        s->cd->s[Si].from =  new STRONGfib;
        ((STRONGfib*)(s->cd->s[Si].from))->d = -1;
        s->cd->s[Si].via = NULL;
        t->k = s;
        t->from = NULL;
        t->via = s->cd->neighbours;

        t = f.extmin();
        while(t != NULL && t->d >-1){
            /*Die Prioritaetswarteliste hatte noch Elemente und das gewaehlte
            Element ist nicht zum ueberspringen freigegeben (d.h. t->d = -1)*/
            n = t->k->cd->neighbours;
            while(n != NULL){
                if(n->way->type >= min && n->way->type <= max ){
                    /*Der Weg erfüllt die Anforderung an den Typ und hat die
                    Prioritaetswarteschlange noch nie durchlaufen*/
                    if(	   n->nb->cd->s[Si].from == NULL
                        && n->nb->cd->s[Si].via == NULL){
                        /*KOO wurde noch nie erreicht*/
                        t2 = f.ins(t->d + attr(n));
                        t2->k = n->nb;
                        t2->from = &(t->k->cd->s[Si]);
                        t2->via = n;
                        n->nb->cd->s[Si].from = t2;
                    }
                    else{
                        /*KOO wurde schon erreicht, pruefe: hat der Punkt die
                        Prioritaetswarteschlange schon wieder verlassen, falls
                        nicht: pruefe, ob Distanz jetzt kuerzer ist*/
                        if( n->nb->cd->s[Si].via == NULL &&
                            ((STRONGfib*)(n->nb->cd->s[Si].from))->d > t->d + attr(n)){
                            /*alten Eintrag löschen und neuen erzeugen*/
                            ((STRONGfib*)(n->nb->cd->s[Si].from))->d = -1;
                            t2 = f.ins(t->d + attr(n));
                            t2->k = n->nb;
                            t2->from = &(t->k->cd->s[Si]);
                            t2->via = n;
                            n->nb->cd->s[Si].from = t2;
                        }
                    }
                }
                n = n->next;
            }
            /*KOO ist abgehandelt, Daten koennen gespeichert werden*/
            t->k->cd->s[Si].via = t->via;
            t->k->cd->s[Si].from = t->from;


            if(t->k != e)
                do{
                delete(t);					//Datenstruktur des FibunacciHeap free
                t = f.extmin();//naechste zu bearbeitende KOO
                }while(t != NULL && t->d < 0);
            else
                t->d = -1;					//Endpunkt erreicht
        }

        if(t == NULL)
            return 0;						//Endpunkt wurde nicht erreicht
        else{
            delete(t);
            return 1;						//Endpunkt wurde erreicht
        }
    }
    else
        return 0;
}
dse::dse(double d, int s, int e, dse **s_used_by, dse **e_used_by){
    this->d = d;
    this->s = s;
    this->e = e;
    this->s_user = s_user;
    this->e_user = e_user;
    is_used = false;
    parent = this;
    start = this;
    end = this;
}
void dse::connect(dse *nb){
    if(s = nb->e){
        parent = nb->parent;
        start = nb->start;
        nb->end = end;
    }
    if(e = nb->s){
        nb->parent = this->parent;
        nb->start = start;
        end = nb->end;
    }
}

bool dse::operator <(const dse o2)const{
    return this->d < o2.d;
}
bool dse::is_available(){
    if((s_user) && (e_user)){
        // check that this segment does not close a ring
        if(e_user[s] != NULL){
        }
        return true;

    }
    else
        return false;
}

void dse::set_used(){
    *s_user = this;
    *e_user = this;
    is_used = true;
}
void Routing::deactivate_neighbours(Neighbour** n, int nc){
    for(int j = 0; j < nc; j++){
        n[j]->d = 1e10;
        n[j]->brthr->d = 1e10;
    }
}

void Routing::restore_neighbours(Neighbour** n, int nc){
    for(int j = 0; j < nc; j++){
        n[j]->d = n[j]->tp[n[j]->tpc-1].d;
        n[j]->brthr->d = n[j]->d;

    }
}
Track* Routing::shortest_track(KOO* s, KOO* e, char max, char min, OSM* o){
    if( s == NULL || e == NULL)
        return NULL;
    Dijkstra(s,e,max,min,o,0,get_d);
    Neighbour** N=NULL;
    int Nc;
    if(e->cd->s[0].from != NULL){
        extract_neighbourlist(s->cd->s,e->cd->s,&N,&Nc);
        // check if track was eventually deactivated via distance modification
        double checkd = 0;
        for(int i = 0; i < Nc; i++) checkd += N[i]->d;
        if(checkd >= 1e10)
            return NULL;
        else
            return new Track(N,Nc);
     }
    else
        return NULL;
}
short Routing::salesman(KOO* s, KOO* e, char max, char min, OSM* o,
               Track** T0, int tc, Track** result, bool *unreachable){
    // calculate all possible tracks
    Track ***t = new Track**[tc+1];       // t[i][j]: end of [j] -->start of [i]
    Neighbour*** n = new Neighbour**[tc];
    int *nc = new int[tc];
    Track **t0 = new Track*[tc+1];
    bool all_OK = true;

    // collect osm data to enable/disable ways
    int i,j,ji;
    double total_P = 0;
    for( i = 0; i < tc; i++){
        t0[i] = T0[i];
        t0[i]->reconstruct_neighbours(&(n[i]),&(nc[i]));
        t[i] = new Track*[tc+1];
        total_P += t0[i]->get_height_meters()*t0[i]->get_height_meters()/t0[i]->get_length();
    }
    t[tc] = new Track*[tc+1];
    t0[tc] = NULL;
    //QMessageBox(QMessageBox::NoIcon,"Warning",QString("total climb: %1").arg(total_P)).exec();
    Neighbour** N=NULL;
    int Nc;
    //QMessageBox(QMessageBox::NoIcon,"Warning","customers reconstructed").exec();
    for( i = 0; i < tc; i++){
        unreachable[i] = false;
        // disable ascent for routing
        deactivate_neighbours(n[i],nc[i]);
        // get all connecting tracks;
        for( j = 0; j < tc ; j++){
            if(i != j){
                deactivate_neighbours(n[j],nc[j]);
                t[i][j] = shortest_track(t0[j]->get_last_KOO(),
                                        t0[i]->get_first_KOO(),
                                        max,min,o);
                restore_neighbours(n[j],nc[j]);

            }
            else
                t[i][j] = NULL;
        }
        // enable descent for routing again
        restore_neighbours(n[i],nc[i]);
    }
    //QMessageBox(QMessageBox::NoIcon,"Warning","tracks routed").exec();
    // check if every customer was reached and left
    /**/for(int i = 0; i < tc; i++){
        bool fromOK = false, toOK = false;
        for(int j = 0; j < tc; j++){
            if(t[i][j] != NULL) toOK = true;
            if(t[j][i] != NULL) fromOK = true;
        }
        if(!toOK || !fromOK){
            all_OK = false;
            unreachable[i] = true;
        }
    }
    if(!all_OK)
        return false;
    //QMessageBox(QMessageBox::NoIcon,"Warning","tracks checked").exec();
    // set up Matrix
    double ** tsp_data = new double*[tc+1];
    for(int i = 0; i < tc+1; i++)
        tsp_data[i] = new double[tc+1];
    for(int i = 0; i < tc; i++){
        for(int j = 0; j < tc; j++){
            if(i != j && t[j][i] != NULL)
                tsp_data[i][j] = t[j][i]->get_length();
            else
                tsp_data[i][j] = 1e9;
        }
    }
    //QMessageBox(QMessageBox::NoIcon,"Warning","MAtrix OK").exec();
    // set up routing mode environment
    int tspc = tc, mode = 0;
    for(int i = 0; i < tc +1; i++){
        tsp_data[i][tc] = tsp_data[tc][i] = 0;
        t[i][tc] = t[tc][i] = NULL;
    }
    tsp_data[tc][tc] = 1e9;

    if(s == NULL){
        if(QMessageBox::Yes == QMessageBox::question(NULL,
                                           "Sales man goal",
                                           "Calculated closed trip to reach start again?",
                                           QMessageBox::Yes|QMessageBox::No)){
            // ordinary TSP problem with trip reaching the start
            tspc = tc;
            mode = 0;
        }
        else{
            // calculate ultimately shortes trip to link all customers
            tspc = tc+1;
            mode = 1;
        }
    }
    else{
        for(int i = 0; i < tc; i++){
            deactivate_neighbours(n[i],nc[i]);
            t[i][tc] = shortest_track(s,t0[i]->get_first_KOO(),max,min,o);
            tsp_data[tc][i] = t[i][tc]->get_length();
            if(t[i][tc] == NULL){
                all_OK = false;
                if(unreachable != NULL) unreachable[i] = true;
            }
            restore_neighbours(n[i],nc[i]);
        }
        if(e == NULL){
            // calculate TSP including way to first customer
            tspc = tc+1;
            mode = 2;
        }
        else{
            // calculate TSP including way to first and from last customer
            for(int i = 0; i < tc; i++){
                deactivate_neighbours(n[i],nc[i]);
                t[tc][i] = shortest_track(t0[i]->get_last_KOO(),e,max,min,o);
                tsp_data[i][tc] = t[tc][i]->get_length();
                if(t[tc][i] == NULL){
                    all_OK = false;
                    if(unreachable != NULL) unreachable[i] = true;
                }
                restore_neighbours(n[i],nc[i]);
            }
            tspc = tc+1;
            mode = 3;
        }

    }
    //QMessageBox(QMessageBox::NoIcon,"Warning","Algortithm prepared").exec();
    // solve the mathematical Problem
    TSP tsp(tsp_data,tspc);
    double dcheck;
    edge* solution = tsp.BranchAndBound(&dcheck);
    *result = new Track();
    //QMessageBox(QMessageBox::NoIcon,"Warning","Algortithm executed").exec();
    // reconstruct the total track
    switch(mode){
        case 0:
            // ordinary TSP problem
            tspc = tc;
            break;
        case 1:
            // TSP with open start and end, one way
            solution = tsp.sort(solution,tc);
            solution = solution->fw();
            tspc = tc;
            break;
        case 2:
            // TSP with open end and fixed start
        case 3:
            // TSP with fixed start and fixed and
            solution = tsp.sort(solution,tc);
            tspc = tc+1;
            break;


    }

    //reconstruct track
    for( i = 0; i < tspc; i++){
        (*result)->add(t0[solution->from]);
        (*result)->add(t [solution->to][solution->from]);
        solution = solution ->fw();
    }
    return all_OK;
}
double Routing::free_RAM_Bytes(){
    return TSP::free_RAM_Bytes();
}

void Routing::resetSTRONG(KOO* k, int STRONGindex){
	if(k != NULL){
        if(k->cd != NULL)
			if(k->cd->s != NULL){
				k->cd->s[STRONGindex].from = NULL;
				k->cd->s[STRONGindex].via = NULL;
			}
		resetSTRONG(k->r, STRONGindex);
		resetSTRONG(k->l, STRONGindex);
	}
}
void Routing::setSTRONG(KOO* k, KOO* s, KOO* e, float radius, int n){
    if(k != NULL){
        if(k->cd != NULL){
            if( s == NULL || e == NULL ||
                distance(k->lat,k->lon,s->lat,s->lon)
               +distance(k->lat,k->lon,e->lat,e->lon) < radius){
                delete(k->cd->s);
                k->cd->s = new STRONG[n];
                for(int i = 0; i < n; i++){
                    k->cd->s[i].from = NULL;
                    k->cd->s[i].via = NULL;
                }
            }
            else{
                delete(k->cd->s);
                k->cd->s = NULL;
            }
        }
        setSTRONG(k->l, s, e, radius, n);
        setSTRONG(k->r, s, e, radius, n);
    }
}
void Routing::extract_neighbourlist(STRONG* s, STRONG* e,
                                    Neighbour ***nl,int* nc){
    STRONG* st = e;
    int nct = 0;
    while(st != s){
        st = (STRONG*)st->from;
        nct++;
    }
    *nl = new Neighbour*[nct];
    *nc = nct;
    st = e;
    while(st != s){
        nct--;
        (*nl)[nct] = st->via;
        st = (STRONG*)st->from;
    }
}
void Routing::finish_STRONG(){
    setSTRONG(o->get_first_KOO(), NULL, NULL,0,2);
}
void Routing::STRONGlayer_reset_d(KOO* k){
	if(k!= NULL){
		if(k->cd != NULL){
            Neighbour* n = k->cd->neighbours;
			while(n != NULL){
				n->d = 0;
				n = n->next;
			}
		}
		STRONGlayer_reset_d(k->l);
		STRONGlayer_reset_d(k->r);
	}
}
void Routing::STRONGlayer_reconstruct_d(KOO* k){
	if(k!= NULL){
		if(k->cd != NULL){
            Neighbour* n = k->cd->neighbours;
			while(n != NULL){
				n->d = n->tp[n->tpc-1].d;
				n = n->next;
			}
		}
		STRONGlayer_reconstruct_d(k->l);
		STRONGlayer_reconstruct_d(k->r);
	}
}
void Routing::STRONGlayer_count_neighbours(KOO* k, int *nbc){
	if(k!= NULL){
		if(k->cd != NULL){
			if(k->lon > SLlonmax) SLlonmax = k->lon;
			if(k->lon < SLlonmin) SLlonmin = k->lon;
			if(k->lat > SLlatmax) SLlatmax = k->lat;
			if(k->lat < SLlatmin) SLlatmin = k->lat;
            Neighbour* n = k->cd->neighbours;
			while(n != NULL){
				if(n->rd == fw) (*nbc)++;
				n = n->next;
			}
		}
		STRONGlayer_count_neighbours(k->l, nbc);
		STRONGlayer_count_neighbours(k->r, nbc);
	}
}
void Routing::STRONGlayer_mark_neighbours(KOO* k, int si){
	if(k!= NULL){
        if(	   k->cd != NULL
			&& k->cd->s != NULL
            && k->cd->s[si].from != NULL)
            if(STRONGlayer_grid_free(k)){
				STRONG* s = &(k->cd->s[si]);
                while(s != NULL){
					if(s->via->rd == fw) 	s->via->d ++;
					else					s->via->brthr->d ++;
					s = (STRONG*) s->from;
				}
            }
		STRONGlayer_mark_neighbours(k->l, si);
		STRONGlayer_mark_neighbours(k->r, si);
	}
}
void Routing::STRONGlayer_fill_neighbours(KOO* k, STRONGlayerele* data, 
                                          int *nbc){
	if(k!= NULL){
		if(k->cd != NULL){
            Neighbour* n = k->cd->neighbours;
			while(n != NULL){
				if(n->rd == fw){
					data[*nbc].n = n;
					(*nbc)++;
				}
				n = n->next;
			}
		}
		STRONGlayer_fill_neighbours(k->l, data, nbc);
		STRONGlayer_fill_neighbours(k->r, data, nbc);
	}
}
void Routing::STRONGlayer_grid_new(){
    double gridperkm = 0.5;
	SLlatmax = SLlatmax +0.01;
	SLlonmax = SLlonmax +0.01;
	SLlatmin = SLlatmin -0.01;
	SLlonmin = SLlonmin -0.01;
	dlat = SLlatmax-SLlatmin;
	dlon = SLlonmax-SLlonmin;
	nlat = dlat*111*gridperkm;
	nlon = dlon*111*sin(double((SLlatmax+SLlatmin)/360.*3.14159265))*gridperkm;
    SLgrid = new char*[nlon];
	for(int x = 0; x < nlon; x++){
        SLgrid[x] = new char[nlat];
	}
}
void Routing::STRONGlayer_grid_reset(){
	for(int x = 0; x < nlon; x++)
		for(int y = 0; y < nlat; y++)
			SLgrid[x][y] = 0;
}
short Routing::STRONGlayer_grid_free(KOO* k){
	int x = int((k->lon-SLlonmin)/dlon*nlon);
	int y = int((k->lat-SLlatmin)/dlat*nlat);
	if( x >= 0 && x < nlon && y >= 0 && y < nlat && SLgrid[x][y] == 0){
		SLgrid[x][y] = 1;
		return 1;
	}
	else
		return 0;
}
void Routing::STRONGlayer_grid_delete(){
	for(int x = 0; x < nlon; x++)
        delete(SLgrid[x]);
    delete(SLgrid);
}
STRONGlayer* Routing::STRONGlayer_create(STRONGlayer* SL,int N){
	if(SL == NULL) return STRONGlayer_create(N);
	/*andernfalls liegen neighbourpointer schon vor*/
	/*Indeces absammeln*/
	STRONGlayer_grid_new();
	STRONGlayer_grid_reset();
    STRONGlayer_reset_d(o->get_first_KOO());
    //    for(int i = 0; i <= N; i++)
    STRONGlayer_mark_neighbours(o->get_first_KOO(),N);
    for(int j = 0; j < SL->ncount; j++){
        /*double maxq = 0, d,hm;
        for(int i = 10; i < N; i++){
            STRONG* s = &(SL->data[j].n->brthr->nb->cd->s[i]);
            d = hm = 0;
            while(s != NULL){
                d += s->via->d;
                hm += s->via->hm;
                s = (STRONG*) s->from;
            }
            if(d > 0 && hm/d > maxq)
                maxq = hm/d;
        }
        SL->data[j].index = maxq;*/
        SL->data[j].index = SL->data[j].n->d;

	}
	STRONGlayer_grid_delete();

	/*Indeces normieren*/
	float max = 0;
    for(int j = 0; j < SL->ncount; j++){
		if(SL->data[j].index > max)
			max = SL->data[j].index;
	}
    for(int j = 0; j < SL->ncount; j++){
		SL->data[j].index = SL->data[j].index / max;
	}
	/*Distanz wieder herstellen (wurde zum Rechnen benutzt)*/
	STRONGlayer_reconstruct_d(o->get_first_KOO());

	STRONGlayer_sort(SL,0,SL->ncount-1);
	return SL;
}
STRONGlayer* Routing::STRONGlayer_create(int N){
    int nbc = 0;
	SLlonmax = -90; SLlatmax = -180; SLlonmin = 90; SLlatmin = 180;
	STRONGlayer_count_neighbours(o->get_first_KOO(),&nbc);
    STRONGlayer* SL = new STRONGlayer;
	SL->ncount = nbc;
    SL->data = new STRONGlayerele[nbc];

	/*Nachbarschaftrelation ins Array laden*/
	nbc = 0;
	STRONGlayer_fill_neighbours(o->get_first_KOO(),SL->data,&nbc);
	
	SL = STRONGlayer_create(SL,N);
	return SL;
}
STRONGlayer* Routing::STRONGlayer_load(char* filename){
    qint64 kid,knid; KOO* k;
	FILE* f = fopen(filename,"rb");
    STRONGlayer* SL = new STRONGlayer;
    fread(&(SL->ncount),sizeof(int),1,f);
    SL->data = new STRONGlayerele[SL->ncount];
    Neighbour* n;
    for(int j = 0; j < SL->ncount; j++){
        fread(&(kid),sizeof(qint64),1,f);
        fread(&(knid),sizeof(qint64),1,f);
		fread(&(SL->data[j].index),sizeof(float),1,f);
		k = o->search(kid,o->get_first_KOO());
        if(k != NULL && k->cd != NULL){
            n = k->cd->neighbours;
            while( n!= NULL && n->nb->id != knid){
                n = n->next;
            }
            if(n != NULL)
                SL->data[j].n = n;
            else
                SL->data[j].n = NULL;
        }
        else
            SL->data[j].n = NULL;
	}
	fclose(f);
	return SL;
}
void Routing::STRONGlayer_save(char* filename, STRONGlayer *SL){
	/*Datei speichern*/
	FILE* f = fopen(filename,"wb");
    fwrite(&(SL->ncount),sizeof(int),1,f);
    for(int j = 0; j < SL->ncount; j++){
        fwrite(&(SL->data[j].n->node[0]->id),sizeof(qint64),1,f);
        fwrite(&(SL->data[j].n->nb->id),sizeof(qint64),1,f);
		fwrite(&(SL->data[j].index),sizeof(float),1,f);
	}
	fclose(f);
}
void Routing::STRONGlayer_sort(STRONGlayer* SL, long s, long e){
	long l = s, r = e;
	STRONGlayerele c;
	float p = SL->data[(s+e)/2].index;
	do{
		while(SL->data[l].index < p) l++;
		while(SL->data[r].index > p) r--;
		if(l<=r){
			c = SL->data[l];
			SL->data[l] = SL->data[r];
			SL->data[r] = c;
			l++;
			r--;
		}
	}while(l <= r);
	if(s < r) STRONGlayer_sort(SL,s,r);
	if(l < e) STRONGlayer_sort(SL,l,e);
}
float Routing::get_hm(Neighbour* n){
    return n->hm;
}

float Routing::get_d(Neighbour* n){
    return n->d;
}

float Routing::get_t(Neighbour* n){
    return n->t;
}
