﻿#pragma once
#include "Track.h"
//! UndoRedo container list element, stores Track
typedef struct undoredolist{
	undoredolist *prev, *next;
    Track* element;
}undoredolist;

//! undo and redo container class for BTP to save no longer needed tracks
/*! before a track is modified by BTP, it will be save to UndoRedo list and
 *  therefor can be reactivated, if the user wants to.
 */
class UndoRedo{
public:
	UndoRedo();
	~UndoRedo();
    void add(Track* element);
    Track* undo(Track* element);
    Track* redo();
private:
    short keepbeforeundo;
	undoredolist* l, *c;
	void del_list(undoredolist* t);
};
