﻿
#include "btp3setups.h"
void BTP3setups::set_NULL(){
    ms = NULL;
    ss = NULL;
    cs = NULL;
    ems = NULL;
    CA = NULL;
    PS = NULL;
    MS = NULL;
    L = new QGridLayout();
}

BTP3setups::BTP3setups(STRONGsetting* ss, STRONGsetting* ms, STRONGsetting* cs){
    set_NULL();
    this->ms = ms;
    ms0 = *ms;
    this->ss = ss;
    ss0 = *ss;
    this->cs = cs;
    cs0 = *cs;
    setWindowTitle("STRONG options");

    QLabel* ssl = new QLabel("STRONG (s-mode) settings");
    QLabel* msl = new QLabel("route hm/km (m-mode) settings");
    QLabel* csl = new QLabel("maximum climbs (c-mode) settings");
    L->addWidget(ssl,0,0);
    L->addWidget(msl,0,1);
    L->addWidget(csl,0,2);

    edit[0]= new EditInputs("data radius factor",&(ss0.rfac));
    edit[1]= new EditInputs("data radius absolut",&(ss0.rabs));
    edit[2]= new EditInputs("hm steps",&(ss0.hmstep));
    edit[3]= new EditInputs("hm max",&(ss0.hmmax));
    edit[4]= new EditInputs("hm/km max",&(ss0.hmperkm));
    edit[5]= new EditInputs("no climb restrictions",&(ss0.noSTRONGPlus));
    edit[6]= new EditInputs("restr.: min Hm",&(ss0.dhmin));
    edit[7]= new EditInputs("restr.: max descent/ascent",&(ss0.downtoupmax));
    edit[8]= new EditInputs("restr.: min difficulty",&(ss0.minP));
    edit[8]= new EditInputs("restr.: min difficulty",&(ss0.minP));

    edit[10]= new EditInputs("data radius factor",&(ms0.rfac));
    edit[11]= new EditInputs("data radius absolut",&(ms0.rabs));
    edit[12]= new EditInputs("hm steps",&(ms0.hmstep));
    edit[13]= new EditInputs("hm max",&(ms0.hmmax));
    edit[14]= new EditInputs("hm/km max",&(ms0.hmperkm));
    edit[15]= new EditInputs("no climb restrictions",&(ms0.noSTRONGPlus));
    edit[16]= new EditInputs("restr.: min Hm",&(ms0.dhmin));
    edit[17]= new EditInputs("restr.: max descent/ascent",&(ms0.downtoupmax));
    edit[18]= new EditInputs("restr.: min difficulty",&(ms0.minP));

    edit[20]= new EditInputs("data radius factor",&(cs0.rfac));
    edit[21]= new EditInputs("data radius absolut",&(cs0.rabs));
    edit[22]= new EditInputs("Points steps",&(cs0.hmstep));
    edit[23]= new EditInputs("Points max",&(cs0.hmmax));
    edit[24]= new EditInputs("Points/km max",&(cs0.hmperkm));
    edit[25]= new EditInputs("no climb restrictions",&(cs0.noSTRONGPlus));
    edit[26]= new EditInputs("restr.: min Hm",&(cs0.dhmin));
    edit[27]= new EditInputs("restr.: max descent/ascent",&(cs0.downtoupmax));
    edit[28]= new EditInputs("restr.: min difficulty",&(cs0.minP));

    for(int i = 0; i < 9; i++){
        L->addWidget(edit[i   ],i+1,0);
        L->addWidget(edit[i+10],i+1,1);
        L->addWidget(edit[i+20],i+1,2);
    }



    buttons[1].setText("OK");
    connect(&(buttons[1]), SIGNAL(clicked()), this, SLOT(OK()));
    buttons[2].setText("Cancel");
    connect(&(buttons[2]), SIGNAL(clicked()), this, SLOT(cancel()));
    buttons[3].setText("Default");
    connect(&(buttons[3]), SIGNAL(clicked()), this, SLOT(init_buffer()));


    setLayouts();
}
BTP3setups::BTP3setups(ClimbAnalyseSettings* CA){
    setWindowTitle("Climb Analyse settings");
    set_NULL();
    this->CA = CA;
    CA0 = *CA;

    edit[0]= new EditInputs("project folder",CA0.ProjectFolder,true);
    edit[1]= new EditInputs("project name",CA0.ProjectName,false);
    edit[2]= new EditInputs("max descent/ascent",&(CA0.maxdwnHM));
    edit[3]= new EditInputs("min Hm",&(CA0.minHM));
    edit[4]= new EditInputs("min difficulty",&(CA0.minP));
    edit[5]= new EditInputs("min gradient",&(CA0.minS));
    edit[6]= new EditInputs("create Climblayer",&(CA0.Climblayer));
    edit[7]= new EditInputs("create html data",&(CA0.html));
    edit[8]= new EditInputs("create climb text list",&(CA0.list));
    edit[9]= new EditInputs("create climb map",&(CA0.map));
    edit[10]=new EditInputs("mapsize [Mega-px]",&(CA0.mapsize));

    for(int i = 0; i < 11; i++)
        L->addWidget(edit[i],i,0);

    buttons[1].setText("Default");
    buttons[2].setText("OK");
    buttons[3].setText("Cancel");
    connect(&(buttons[1]), SIGNAL(clicked()), this, SLOT(init_buffer()));
    connect(&(buttons[2]), SIGNAL(clicked()), this, SLOT(OK()));
    connect(&(buttons[3]), SIGNAL(clicked()), this, SLOT(cancel()));

    setLayouts();
}
BTP3setups::BTP3setups(ExtMapSettings* ems){
    setWindowTitle("Map settings");
    set_NULL();
    this->ems = ems;
    ems0 = *ems;
    edit[0]= new EditInputs("mapsize [Mega-px]",&(ems0.mapsize));
    edit[1]= new EditInputs("maxlat",&(ems0.maxlat));
    edit[2]= new EditInputs("minlat",&(ems0.minlat));
    edit[3]= new EditInputs("maxlon",&(ems0.maxlon));
    edit[4]= new EditInputs("minlon",&(ems0.minlon));
    edit[5]= new EditInputs("draw climblayer",&(ems0.drawCL));
    edit[6]= new EditInputs("draw current track",&(ems0.drawct));
    edit[7]= new EditInputs("draw STRONG layer",&(ems0.drawSL));
    for(int i = 0; i < 8; i++)
        L->addWidget(edit[i],i,0);

    buttons[1].setText("Default");
    buttons[2].setText("OK");
    buttons[3].setText("Cancel");

    connect(&(buttons[1]), SIGNAL(clicked()), this, SLOT(init_buffer()));
    connect(&(buttons[2]), SIGNAL(clicked()), this, SLOT(OK()));
    connect(&(buttons[3]), SIGNAL(clicked()), this, SLOT(cancel()));

    setLayouts();
}
BTP3setups::BTP3setups(ProfilSettings *PS){
    setWindowTitle("Profil settings");
    set_NULL();
    this->PS = PS;
    PS0 = *PS;

    edit[0]= new EditInputs("width [px]",&(PS0.width));
    edit[1]= new EditInputs("height [px]",&(PS0.height));
    edit[2]= new EditInputs("font name",PS0.font,0);
    edit[3]= new EditInputs("titel font size",&(PS0.fstitle));
    edit[4]= new EditInputs("normal font size",&(PS0.fsnormal));
    edit[5]= new EditInputs("font color",&(PS0.fontcolor));
    edit[6]= new EditInputs("background color",&(PS0.bgcolor));
    edit[7]= new EditInputs("lattice color",&(PS0.latticecolor));
    edit[8]= new EditInputs("draw title",&(PS0.drawtitle));
    edit[9]= new EditInputs("draw xlabel",&(PS0.drawxbarlabel));
    edit[10]= new EditInputs("draw ylabel",&(PS0.drawybarlabel));
    edit[11]= new EditInputs("draw x grid",&(PS0.drawxlattice));
    edit[12]= new EditInputs("draw y grid",&(PS0.drawylattice));
    edit[13]= new EditInputs("xmin",&(PS0.xmin));
    edit[14]= new EditInputs("xmax",&(PS0.xmax));
    edit[15]= new EditInputs("ymin",&(PS0.ymin));
    edit[16]= new EditInputs("ymax",&(PS0.ymax));
    edit[17]= new EditInputs("margin",&(PS0.margin));
    edit[18]= new EditInputs("fill single color",&(PS0.singlecolor));
    edit[19]= new EditInputs("fill color",&(PS0.fillcolor));
    edit[20]= new EditInputs("draw line",&(PS0.showline));
    edit[21]= new EditInputs("line color",&(PS0.linecolor));
    edit[22]= new EditInputs("reduce data",&(PS0.showreduceddata));
    edit[23]= new EditInputs("autoscale",&(PS0.autoscale));

    for(int i = 0; i < 24; i++)
        L->addWidget(edit[i],i,0);

    buttons[1].setText("Default");
    buttons[2].setText("OK");
    buttons[3].setText("Cancel");
    connect(&(buttons[1]), SIGNAL(clicked()), this, SLOT(init_buffer()));
    connect(&(buttons[2]), SIGNAL(clicked()), this, SLOT(OK()));
    connect(&(buttons[3]), SIGNAL(clicked()), this, SLOT(cancel()));

    setLayouts();

}
BTP3setups::BTP3setups(MapSettings *MS){
    setWindowTitle("Map settings");
    set_NULL();
    this->MS = MS;
    MS0 = *MS;


    edit[0]= new EditInputs("road type 0 width",&(MS0.roadwidth[0]));
    edit[1]= new EditInputs("road type 1 width",&(MS0.roadwidth[1]));
    edit[2]= new EditInputs("road type 2 width",&(MS0.roadwidth[2]));
    edit[3]= new EditInputs("road type 3 width",&(MS0.roadwidth[3]));
    edit[4]= new EditInputs("road type 4 width",&(MS0.roadwidth[4]));
    edit[5]= new EditInputs("road type 5 width",&(MS0.roadwidth[5]));
    edit[6]= new EditInputs("road color 0",&(MS0.roadcolor[0]));
    edit[7]= new EditInputs("road color 1",&(MS0.roadcolor[1]));
    edit[8]= new EditInputs("road color 2",&(MS0.roadcolor[2]));
    edit[9]= new EditInputs("road color 3",&(MS0.roadcolor[3]));
    edit[10]= new EditInputs("road color 4",&(MS0.roadcolor[4]));
    edit[11]= new EditInputs("road color 5",&(MS0.roadcolor[5]));
    for(int i = 0; i < 6; i++){
        L->addWidget(edit[i]  ,i,0);
        L->addWidget(edit[i+6],i,1);
    }
    edit[12]= new EditInputs("metropolos size", &(MS0.pointsize[0]));
    edit[13]= new EditInputs("city size",       &(MS0.pointsize[1]));
    edit[14]= new EditInputs("town size",       &(MS0.pointsize[2]));
    edit[15]= new EditInputs("village size",    &(MS0.pointsize[3]));
    edit[16]= new EditInputs("locality size",   &(MS0.pointsize[4]));
    edit[17]= new EditInputs("col size",        &(MS0.pointsize[5]));
    edit[18]= new EditInputs("metropolos color",&(MS0.pointcolor[0]));
    edit[19]= new EditInputs("city color",      &(MS0.pointcolor[1]));
    edit[20]= new EditInputs("town color",      &(MS0.pointcolor[2]));
    edit[21]= new EditInputs("village color",   &(MS0.pointcolor[3]));
    edit[22]= new EditInputs("locality color",  &(MS0.pointcolor[4]));
    edit[23]= new EditInputs("col color",       &(MS0.pointcolor[5]));

    for(int i = 12; i < 18; i++){
        L->addWidget(edit[i]  ,i-6,0);
        L->addWidget(edit[i+6],i-6,1);
    }
    edit[24]= new EditInputs("draw summit",&(MS0.drawsummit));
    edit[25]= new EditInputs("summit size",&(MS0.summitsize));
    edit[26]= new EditInputs("summit color",&(MS0.summitcolor));
    L->addWidget(edit[24],12,0);
    L->addWidget(edit[25],12,1);
    L->addWidget(edit[26],13,1);

    edit[27]= new EditInputs("height 1 [m]",&(MS0.heights[0]));
    edit[28]= new EditInputs("height 2 [m]",&(MS0.heights[1]));
    edit[29]= new EditInputs("height 3 [m]",&(MS0.heights[2]));
    edit[30]= new EditInputs("height 4 [m]",&(MS0.heights[3]));
    edit[31]= new EditInputs("height 5 [m]",&(MS0.heights[4]));
    edit[32]= new EditInputs("heights 1 color",&(MS0.heightcolor[0]));
    edit[33]= new EditInputs("heights 2 color",&(MS0.heightcolor[1]));
    edit[34]= new EditInputs("heights 3 color",&(MS0.heightcolor[2]));
    edit[35]= new EditInputs("heights 4 color",&(MS0.heightcolor[3]));
    edit[36]= new EditInputs("heights 5 color",&(MS0.heightcolor[4]));
    for(int i = 27; i < 32; i++){
        L->addWidget(edit[i]  ,i-13,0);
        L->addWidget(edit[i+5],i-13,1);
    }

    edit[37]= new EditInputs("draw wood",   &(MS0.drawwood   ));
    edit[38]= new EditInputs("draw water",  &(MS0.drawater   ));
    edit[39]= new EditInputs("draw contour",&(MS0.drawcontour));
    edit[40]= new EditInputs("draw points", &(MS0.drawpoints ));
    edit[41]= new EditInputs("wood color",  &(MS0.woodcolor));
    edit[42]= new EditInputs("water color", &(MS0.watercolor));
    edit[43]= new EditInputs("draw scale",  &(MS0.drawscale  ));
    edit[44]= new EditInputs("draw street label",&(MS0.drawstreetlabel  ));
    for(int i = 37; i < 41; i++){
        L->addWidget(edit[i],i-18,0);
        L->addWidget(edit[i+4],i-18,1);
    }
    edit[45]= new EditInputs("light intensity",&(MS0.sun.I));
    L->addWidget(edit[45],25,0);
    edit[46]= new EditInputs("light azimut [Â°]",&(MS0.sun.azimut   ));
    L->addWidget(edit[46],25,1);
    edit[47]= new EditInputs("light elevation [Â°]",&(MS0.sun.elevation));
    L->addWidget(edit[47],26,1);
    edit[48]= new EditInputs("climblayer shading",&(MS0.climblayershading));
    L->addWidget(edit[48],26,0);
    edit[49]= new EditInputs("draw street contour",&(MS0.drawstreetcontour));
    L->addWidget(edit[49],13,0);
    edit[50]= new EditInputs("track width",&(MS0.trackwidth));
    L->addWidget(edit[50],27,0);
    edit[51]= new EditInputs("track color",&(MS0.trackcolor));
    L->addWidget(edit[51],27,1);

    buttons[1].setText("Default");
    buttons[2].setText("OK");
    buttons[3].setText("Cancel");
    connect(&(buttons[1]), SIGNAL(clicked()), this, SLOT(init_buffer()));
    connect(&(buttons[2]), SIGNAL(clicked()), this, SLOT(OK()));
    connect(&(buttons[3]), SIGNAL(clicked()), this, SLOT(cancel()));

    setLayouts();
}
void BTP3setups::setLayouts(){
    QScrollArea *scroll = new QScrollArea(this);
    QWidget *viewport = new QWidget(this);
    scroll->setWidget(viewport);
    scroll->setWidgetResizable(true);
    viewport->setLayout(L);
    QGridLayout *dl = new QGridLayout(this);
    dl->addWidget(scroll,0,0,1,3);
    dl->addWidget(&(buttons[1]),1,0);
    dl->addWidget(&(buttons[2]),1,1);
    dl->addWidget(&(buttons[3]),1,2);
    setLayout(dl);
}

void BTP3setups::cancel(){
    reject();
}
void BTP3setups::init(){
    init_dest();
    reject();
}
void BTP3setups::OK(){
    if(PS != NULL)
        *PS = PS0;
    if(ss != NULL)
        *ss = ss0;
    if(ms != NULL)
        *ms = ms0;
    if(cs != NULL)
        *cs = cs0;
    if(CA != NULL)
        *CA = CA0;
    if(PS != NULL)
        *PS = PS0;
    if(ems != NULL)
        *ems = ems0;
    if(MS != NULL){
        *MS = MS0;
        MS->sun.cphi = cos(-MS->sun.azimut/180.*M_PI);
        MS->sun.sphi = sin(-MS->sun.azimut/180.*M_PI);
        MS->sun.ctheta = cos((90-MS->sun.elevation)/180.*M_PI);
        MS->sun.stheta = sin((90-MS->sun.elevation)/180.*M_PI);
    }
    accept();
}
void BTP3setups::init_buffer(){
    if(PS != NULL){
        ProfilSettings *buf = PS;
        PS = &PS0;
        init_dest();
        PS = buf;
        for(int i = 0; i < 24; i++)
            edit[i]->refresh();
    }
    if(ss != NULL){
        STRONGsetting *buf = ss;
        ss = &ss0;
        init_dest();
        ss = buf;
        for(int i = 0; i < 9; i++)
            edit[i]->refresh();
    }
    if(ms != NULL){
        STRONGsetting *buf = ms;
        ms = &ms0;
        init_dest();
        ms = buf;
        for(int i = 10; i < 19; i++)
            edit[i]->refresh();
    }
    if(ms != NULL){
        STRONGsetting *buf = cs;
        cs = &cs0;
        init_dest();
        cs = buf;
        for(int i = 20; i < 29; i++)
            edit[i]->refresh();
    }

    if(CA != NULL){
        ClimbAnalyseSettings *buf = CA;
        CA = &CA0;
        init_dest();
        CA = buf;
        for(int i = 0; i < 11; i++)
            edit[i]->refresh();
    }
    if(ems != NULL){
        ExtMapSettings *buf = ems;
        ems = &ems0;
        init_dest();
        ems = buf;
        for(int i = 0; i < 8; i++)
            edit[i]->refresh();
    }
    if(MS != NULL){
        MapSettings *buf = MS;
        MS = &MS0;
        init_dest();
        MS = buf;
        for(int i = 0; i < 52; i++)
            edit[i]->refresh();
    }
}
void BTP3setups::init_dest(){
    if(ss != NULL){
        ss->rfac = 3.;
        ss->rabs = 200.;
        ss->hmstep = 15.;
        ss->hmmax = 10000;
        ss->hmperkm = 35;
        ss->dhmin = 200;
        ss->downtoupmax = 0.1;
        ss->minP = 5.;
        ss->noSTRONGPlus = true;
    }
    if(ms != NULL){
        ms->rfac = 1.5;
        ms->rabs = 5.;
        ms->hmstep = 40;
        ms->hmmax = 1500;
        ms->hmperkm = 35;
        ms->dhmin = 200;
        ms->downtoupmax = 0.1;
        ms->minP = 5.;
        ms->noSTRONGPlus = true;
    }
    if(cs != NULL){
        cs->rfac = 1.5;
        cs->rabs = 5.;
        cs->hmstep = 2;
        cs->hmmax = 200;
        cs->hmperkm = 15;
        cs->dhmin = 200;
        cs->downtoupmax = 0.1;
        cs->minP = 5.;
        cs->noSTRONGPlus = false;
    }

    if(CA != NULL){
        CA->Climblayer = true;
        CA->html = false;
        CA->list = true;
        CA->map = false;
        CA->mapsize = 8;
        CA->maxdwnHM = 0.1;
        CA->minHM = 100;
        CA->minP = 5;
        CA->minS = 0.05;
        strcpy(CA->ProjectFolder,"C:\\");
        strcpy(CA->ProjectName,"projectname");
    }
    if(ems != NULL){
        ems->drawCL = true;
        ems->drawct = false;
        ems->drawSL = true;
        ems->mapsize = 8;
        ems->maxlat = 51;
        ems->minlat = 50;
        ems->maxlon = 14;
        ems->minlon = 12;
    }
    if(PS != NULL){
        PS->autoscale = true;
        PS->bgcolor = QColor(QPalette().color(QPalette::Window)).rgba();
        PS->drawtitle = true;
        PS->drawxbarlabel = true;
        PS->drawybarlabel = true;
        PS->drawxlattice = true;
        PS->drawylattice = true;
        strcpy(PS->font,"Arial");
        PS->fontcolor = QColor(0,0,0).rgba();
        PS->fsnormal = 6;
        PS->fstitle= 10;
        PS->height = 300;
        PS->latticecolor = QColor(0,0,0,100).rgba();
        PS->margin = 5;
        PS->width = 450;
        PS->xmin = -1;
        PS->xmax = 1;
        PS->ymin = -1;
        PS->ymax = 1;
        PS->singlecolor = false;
        PS->fillcolor = QColor(0,255,0,150).rgba();
        PS->showline = true;
        PS->linecolor = QColor(Qt::black).rgba();
        PS->showreduceddata = true;
    }
    if(MS != NULL){
        MS->minlat = 50;
        MS->minlon = 13;
        MS->maxlat = 51;
        MS->maxlon = 14.5;
        MS->roadcolor[0] = QColor(0,170,127).rgba();
        MS->roadcolor[1] = QColor(170,0,0).rgba();
        MS->roadcolor[2] = QColor(255,170,0).rgba();
        MS->roadcolor[3] = QColor(255,255,0).rgba();
        MS->roadcolor[4] = QColor(255,255,255).rgba();
        MS->roadcolor[5] = QColor(0,0,0).rgba();
        MS->roadwidth[0] = 6.;
        MS->roadwidth[1] = 4.;
        MS->roadwidth[2] = 3.;
        MS->roadwidth[3] = 2.;
        MS->roadwidth[4] = 1.;
        MS->roadwidth[5] = 0.5;
        MS->summitcolor = QColor(100,15,0).rgba();
        MS->summitsize = 12;
        MS->pointsize[0] = 35;
        MS->pointsize[1] = 25;
        MS->pointsize[2] = 15;
        MS->pointsize[3] =  8;
        MS->pointsize[4] =  4;
        MS->pointsize[5] =  4;
        MS->pointcolor[0] = QColor(1,1,1).rgba();
        MS->pointcolor[1] = QColor(1,1,1).rgba();
        MS->pointcolor[2] = QColor(1,1,1).rgba();
        MS->pointcolor[3] = QColor(1,1,1).rgba();
        MS->pointcolor[4] = QColor(1,1,1).rgba();
        MS->pointcolor[5] = QColor(100,15,0).rgba();
        MS->drawcontour = 1;
        MS->drawsummit = 1;
        MS->drawpoints = 1;
        MS->drawwood = 1;
        MS->woodcolor = QColor(0,80,0,55).rgba();
        MS->drawater = 1;
        MS->watercolor = QColor(0,0,200,100).rgba();
        MS->drawscale = 1;
        MS->drawstreetlabel = 1;
        MS->drawstreetcontour = 1;
        MS->heightcolor[0] = QColor(228,255,206).rgba();
        MS->heightcolor[1] = QColor(215,255,127).rgba();
        MS->heightcolor[2] = QColor(255,249,125).rgba();
        MS->heightcolor[3] = QColor(197,128, 98).rgba();
        MS->heightcolor[4] = QColor(220,220,220).rgba();
        MS->heights[0] = 0;
        MS->heights[1] = 300;
        MS->heights[2] = 600;
        MS->heights[3] = 900;
        MS->heights[4] = 1200;
        MS->climblayershading = 0.2;
        MS->sun.I = 5;
        MS->sun.azimut = -135;
        MS->sun.elevation = 45;
        MS->sun.cphi = cos(-MS->sun.azimut/180.*M_PI);
        MS->sun.sphi = sin(-MS->sun.azimut/180.*M_PI);
        MS->sun.ctheta = cos((90-MS->sun.elevation)/180.*M_PI);
        MS->sun.stheta = sin((90-MS->sun.elevation)/180.*M_PI);
        MS->trackwidth =  5;
        MS->trackcolor = QColor(0,255,0).rgba();
    }
}
ColorButton::ColorButton(QRgb* color){
    this->color = color;
    connect(this,SIGNAL(clicked()),this,SLOT(edit_color()));
}
void ColorButton::paintEvent(QPaintEvent *){
    QPainter p(this);
    p.fillRect(this->rect(),QColor::fromRgba(*color));
}
void ColorButton::edit_color(){
    QColor newcolor = QColorDialog::getColor(QColor::fromRgba(*color),NULL,"Select color",
                                             QColorDialog::ShowAlphaChannel);
    *color = newcolor.rgba();
    update();
}
EditInputs::EditInputs(QString name, double* v){
    cv = NULL;
    iv = NULL;
    sv = NULL;
    dv = v;
    fv = NULL;
    bv = NULL;
    rgbv = NULL;
    folder = NULL;
    label.setText(name);
    edit.setText(QString("%1").arg(*v));
    QBoxLayout* L = new QBoxLayout(QBoxLayout::LeftToRight);
    L->setContentsMargins(0,0,0,0);
    L->addWidget(&label,2);
    L->addWidget(&edit,1);
    setLayout(L);
    connect(&edit,SIGNAL(textEdited(QString)),this,SLOT(checkedit(QString)));

}
EditInputs::EditInputs(QString name, float* v){
    cv = NULL;
    iv = NULL;
    sv = NULL;
    dv = NULL;
    fv = v;
    bv = NULL;
    rgbv = NULL;
    folder = NULL;
    label.setText(name);
    edit.setText(QString("%1").arg(*v));
    QBoxLayout* L = new QBoxLayout(QBoxLayout::LeftToRight);
    L->setContentsMargins(0,0,0,0);
    L->addWidget(&label,2);
    L->addWidget(&edit,1);
    setLayout(L);
    connect(&edit,SIGNAL(textEdited(QString)),this,SLOT(checkedit(QString)));

}

EditInputs::EditInputs(QString name, int* v){
    cv = NULL;
    iv = v;
    sv = NULL;
    dv = NULL;
    fv = NULL;
    bv = NULL;
    rgbv = NULL;
    folder = NULL;
    label.setText(name);
    edit.setText(QString("%1").arg(*v));
    QBoxLayout* L = new QBoxLayout(QBoxLayout::LeftToRight);
    L->setContentsMargins(0,0,0,0);
    L->addWidget(&label,2);
    L->addWidget(&edit,1);
    setLayout(L);
    connect(&edit,SIGNAL(textEdited(QString)),this,SLOT(checkedit(QString)));
}
EditInputs::EditInputs(QString name, short* v){
    cv = NULL;
    iv = NULL;
    sv = v;
    dv = NULL;
    fv = NULL;
    bv = NULL;
    rgbv = NULL;
    folder = NULL;
    label.setText(name);
    edit.setText(QString("%1").arg(*v));
    QBoxLayout* L = new QBoxLayout(QBoxLayout::LeftToRight);
    L->setContentsMargins(0,0,0,0);
    L->addWidget(&label,2);
    L->addWidget(&edit,1);
    setLayout(L);
    connect(&edit,SIGNAL(textEdited(QString)),this,SLOT(checkedit(QString)));
}

EditInputs::EditInputs(QString name, char* v, bool folder){
    iv = NULL;
    sv = NULL;
    dv = NULL;
    fv = NULL;
    bv = NULL;
    rgbv = NULL;

    if(folder){
        this->folder = v;
        cv = NULL;
        label.setText(QString(v));
        QPushButton *selectbutton = new QPushButton(name);
        connect(selectbutton,SIGNAL(clicked()),this,SLOT(select_folder()));
        QBoxLayout* L = new QBoxLayout(QBoxLayout::LeftToRight);
        L->setContentsMargins(0,0,0,0);
        L->addWidget(&label,2);
        L->addWidget(selectbutton,1);
        setLayout(L);
    }
    else{
        this->folder = NULL;
        cv = v;
        label.setText(name);
        edit.setText(QString("%1").arg(v));
        QBoxLayout* L = new QBoxLayout(QBoxLayout::LeftToRight);
        L->setContentsMargins(0,0,0,0);
        L->addWidget(&label,2);
        L->addWidget(&edit,1);
        setLayout(L);
        connect(&edit,SIGNAL(textEdited(QString)),this,SLOT(checkedit(QString)));
    }
}
EditInputs::EditInputs(QString name, bool* v){
    cv = NULL;
    iv = NULL;
    sv = NULL;
    dv = NULL;
    fv = NULL;
    bv = v;
    rgbv = NULL;
    folder = NULL;
    label.setText(name);
    check.setChecked(*v);
    QBoxLayout* L = new QBoxLayout(QBoxLayout::LeftToRight);
    L->setContentsMargins(0,0,0,0);
    L->addWidget(&label,2);
    L->addWidget(&check,1);
    setLayout(L);
    connect(&check,SIGNAL(clicked()),this,SLOT(checkbox()));
}
EditInputs::EditInputs(QString name, QRgb* v){
    cv = NULL;
    iv = NULL;
    sv = NULL;
    dv = NULL;
    fv = NULL;
    bv = NULL;
    rgbv = v;
    folder = NULL;
    label.setText(name);
    colorbutton = new ColorButton(v);
    QBoxLayout* L = new QBoxLayout(QBoxLayout::LeftToRight);
    L->setContentsMargins(0,0,0,0);
    L->addWidget(&label,2);
    L->addWidget(colorbutton,1);
    setLayout(L);
}
void EditInputs::checkedit(QString newtext){
    bool OK;
    if(dv != NULL){
        double dvb = newtext.toDouble(&OK);
        if(OK)
            *dv = dvb;
        else
            edit.setText("type float!");
    }
    if(fv != NULL){
        float fvb = newtext.toFloat(&OK);
        if(OK)
            *fv = fvb;
        else
            edit.setText("type float!");
    }

    if(iv != NULL){
        int ivb = newtext.toInt(&OK);
        if(OK)
            *iv = ivb;
        else
            edit.setText("type integer");
    }
    if(sv != NULL){
        short svb = newtext.toShort(&OK);
        if(OK)
            *sv = svb;
        else
            edit.setText("type integer");
    }
    if(cv != NULL)
        strcpy(cv,edit.text().toLocal8Bit().data());
}
void EditInputs::checkbox(){
    *bv = check.isChecked();
}
void EditInputs::refresh(){
    if(dv != NULL)
        edit.setText(QString("%1").arg(*dv));
    if(fv != NULL)
        edit.setText(QString("%1").arg(*fv));
    if(iv != NULL)
        edit.setText(QString("%1").arg(*iv));
    if(sv != NULL)
        edit.setText(QString("%1").arg(*sv));
    if(cv != NULL)
        edit.setText(QString(cv));
    if(bv != NULL)
        check.setChecked(*bv);
    if(folder != NULL)
        label.setText(QString(folder));
    if(rgbv != NULL)
        colorbutton->update();
}
void EditInputs::select_folder(){
    QString foldername = QFileDialog::getExistingDirectory(this,"select directory");
    if(!foldername.isEmpty()){
        strcpy(folder,foldername.toLocal8Bit().data());
        label.setText(QString(folder));
    }
}
