﻿#include <stdio.h>
#include <stdlib.h>
#include <QString>
#include <QMessageBox>
#include "MathExt.h"

typedef struct gpxlist{
	double d,h,lat,lon;
	long int time;
	gpxlist *next,*prev;
}gpxlist;

class gpx{
public:
	gpx(char* filename);
	~gpx();
	void read_in();						//Startet Einlesen der Datei filename
	void setfilename();
	void calc_distance();				//berechnet Distanz aus Koordinaten
	double** get_d_h_t(long int* n);	//Distanz[][0],Hoehe[][1], UnixZeit[][2] als Array
	double** get_KOO(long int* n);		//Breite[][0],Laenge[][1] als Array
	double** get_complete(long int* n);	//Distanz[][0], Hoehe[][1], Breite[][2], Laenge[][3], UnixZeit[][4] als Array
	void* get_complete_List();			//Liste{double d,h,lon,lat; Liste *next, *prev}

private:
	static const int R0 = 6371;			//Erdradius
	gpxlist** l;						//Hauptliste, um die sich alles dreht
	char* file;							//behandelte Datei

	/*Arbeiten mit der Datenliste l*/
	void add_point(double lon, double lat, double h, long int time); 
										//fuegt Punkt zu l hinzu
	double distance(double lat1, double lon1, double lat2, double lon2);
										//berechnet Distanz auf l	
	/*XML-Hilfsfunktionen*/
	void replace_quotation(char* a);	//Ersetzt " durch '
    void extract_attribute(const char* attr, char* src, double* result);
    void extract_element(const char* elem, char* src, double* result);
	void extract_time(char* src, long int* unix_time);
};
