﻿#include "mainwindow.h"
#include "ui_mainwindow.h"

KOO* get_KOO_helper(qint64 id, void* osm){
    OSM* o = (OSM*) osm;
    return o->search(id,o->get_first_KOO());
}

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow){
    autoload_setting();
    ui->setupUi(this);
    centralWidget()->setLayout(ui->verticalLayout);
    showMaximized();
    init();
    centralWidget()->setMouseTracking(true);
    ui->Map->setMouseTracking(true);
    ui->profil->setMouseTracking(true);
    ui->profil->settings(&(c.PS));
    setMouseTracking(true);
    statusBar()->addWidget(statusLeft, 1);
    statusBar()->addWidget(statusMiddle, 2);
    connect(ui->actionClose,SIGNAL(triggered()),this,SLOT(close()));
    connect(ui->actionSpecify_SRTM3_data_folder,SIGNAL(triggered()),this,SLOT(set_SRTM3_folder()));
    connect(ui->actionLoad_btp,SIGNAL(triggered()),this,SLOT(load_btp()));
    connect(ui->actionSave_btp,SIGNAL(triggered()),this,SLOT(save_btp()));
    connect(ui->actionRead_osm,SIGNAL(triggered()),this,SLOT(read_osm()));
    connect(ui->actionBtp_startup_file,SIGNAL(triggered()),this,SLOT(set_start_btp()));
    connect(ui->profil,SIGNAL(mousex(double)),this,SLOT(profilinfo(double)));
    connect(ui->actionSTRONG_settings,SIGNAL(triggered()),this,SLOT(STRONG_settings()));
    connect(ui->actionClimbs,SIGNAL(triggered()),this,SLOT(AnalyseClimbs()));
    connect(ui->actionToggle_Climblayer,SIGNAL(triggered()),this,SLOT(toggle_Climblayer()));
    connect(ui->actionToggle_STRONGlayer,SIGNAL(triggered()),this,SLOT(toggle_STRONGlayer()));
    connect(ui->actionLoad_Climblayer,SIGNAL(triggered()),this,SLOT(load_Climblayer()));
    connect(ui->actionCreate_STRONGlayer,SIGNAL(triggered()),this,SLOT(create_STRONGlayer()));
    connect(ui->actionLoad_STRONGlayer,SIGNAL(triggered()),this,SLOT(load_STRONGlayer()));
    connect(ui->actionSave_STRONGlayer,SIGNAL(triggered()),this,SLOT(save_STRONGlayer()));
    connect(ui->actionGenerateMap,SIGNAL(triggered()),this,SLOT(generate_Map()));
    connect(ui->actionInvert_height_data,SIGNAL(triggered()),this,SLOT(invert_Hm()));
    connect(ui->actionNormalize_height_data,SIGNAL(triggered()),this,SLOT(normalize_Hm()));
    connect(ui->actionSave_gpx,SIGNAL(triggered()),SLOT(save_gpx()));
    connect(ui->actionSave_Profil_as_png,SIGNAL(triggered()),SLOT(save_profile()));
    connect(ui->actionSettings,SIGNAL(triggered()),SLOT(profil_settings()));
    connect(ui->actionOn_off,SIGNAL(triggered()),this,SLOT(toggle_poweranalysis()));
    connect(ui->actionSettings_2,SIGNAL(triggered()),this,SLOT(map_settings()));
    connect(PA,SIGNAL(recalced()),this,SLOT(update_profil()));
    connect(ui->profil,SIGNAL(clicked(double)),this,SLOT(center_track(double)));
    connect(ui->profil,SIGNAL(call_zoom_repaint(double,double)),this,SLOT(zoom_profil(double,double)));
    connect(ui->profil,SIGNAL(call_fullview()),this,SLOT(update_profil()));
    connect(ui->actionShow_Power,SIGNAL(triggered()),this,SLOT(toggle_showpower()));
    connect(ui->actionShow_Speed_in_plot,SIGNAL(triggered()),this,SLOT(toggle_showspeed()));
    connect(ui->actionAnalyse_gpx,SIGNAL(triggered()),this,SLOT(analyse_gpx()));
    connect(ui->actionLoad_STRONG_calculation,SIGNAL(triggered()),this,SLOT(load_STRONGcalc()));
    connect(ui->actionSave_STRONG_calculation,SIGNAL(triggered()),this,SLOT(save_STRONGcalc()));
    connect(ui->actionGenerate_tiles,SIGNAL(triggered()),this,SLOT(generate_tiles()));
    connect(ui->actionSplit_pbf,SIGNAL(triggered()),this,SLOT(split_europe_pbf()));
    connect(ui->actionCorrect_hgt_Files,SIGNAL(triggered()),this,SLOT(correct_hgt()));
    connect(ui->actionRead_osm_2,SIGNAL(triggered()),this,SLOT(read_europe()));
    connect(ui->actionGenerate_climbdata,SIGNAL(triggered()),this,SLOT(CA_europe()));
    connect(ui->actionGenerate_STRONG_layer,SIGNAL(triggered()),this,SLOT(STRONG_europe()));
    connect(ui->actionExtractZoom12,SIGNAL(triggered()),this,SLOT(zoom14_collection()));
    connect(ui->actionsave_binary,SIGNAL(triggered()),this,SLOT(save_track_binary()));
    connect(ui->actionSummitranking_split,SIGNAL(triggered()),this,SLOT(summitranking_split()));
    connect(ui->actionSummitranking_calc,SIGNAL(triggered()),this,SLOT(summitranking_calc()));
    connect(ui->actionSummitrankung_merge,SIGNAL(triggered()),this,SLOT(summitranking_collect()));
    connect(ui->actionSave_btr,SIGNAL(triggered()),this,SLOT(save_btr()));
    connect(ui->actionLoad_btr,SIGNAL(triggered()),this,SLOT(load_btr()));
    connect(ui->action_swapHmd,SIGNAL(triggered()),this,SLOT(swap_Hm_d()));
    connect(ui->actionShow3D,SIGNAL(triggered()),this,SLOT(show3D()));
    connect(ui->actionData_to_clipcoard,SIGNAL(triggered()),ui->profil,SLOT(data_to_clipboard()));
    connect(ui->actionPAData_to_clipboard,SIGNAL(triggered()),PA,SLOT(data_to_clipboard()));

    /*Track *tracks[8];
    Track* trackresult;
    bool errors[8];
    tracks[0] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\hesenbachN.btr",&get_KOO_helper,(void*)osm);
    tracks[1] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\hesenbachS.btr",&get_KOO_helper,(void*)osm);
    tracks[2] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\0hinterbaerenburg.btr",&get_KOO_helper,(void*)osm);
    tracks[3] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\0Hirschstange.btr",&get_KOO_helper,(void*)osm);
    tracks[4] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\0langgrundweg.btr",&get_KOO_helper,(void*)osm);
    tracks[5] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\0vorderbaerenburger.btr",&get_KOO_helper,(void*)osm);
    tracks[6] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\bobbahn.btr",&get_KOO_helper,(void*)osm);
    tracks[7] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\eisenstrasse.btr",&get_KOO_helper,(void*)osm);

    if(r->salesman(kold,knew,c.maxtype,c.mintype,osm,&(tracks[0]),8,&trackresult,errors)){
        ct = trackresult;
        update_map_track();
        update_profil();
    }*/
}

MainWindow::~MainWindow(){
    if(autosave) autosave_setting();
    delete map;
    delete osm;
    delete hd;
    delete ui;
}
void MainWindow::closeEvent(QCloseEvent *){
    PA->close();
}

void MainWindow::resizeEvent ( QResizeEvent * event ){
    /*QPixmap prev(event->size().width()-10,event->size().height()*0.8-10);
    prev.fill(Qt::black);
    QRectF Rdest(0,0,event->size().width()-10,event->size().height()*0.8-10);
    QRectF Rsrc(0,0,map->getwidth(),map->getheight());
    QPainter painter(&prev);
    painter.drawPixmap(Rdest,*cmap,Rsrc);
    ui->Map->setPixmap(prev);
    ui->Map->repaint();*/
    //QSize sold = event->oldSize();
    //QSize snew = event->size();
    //if(sold.width()>0 && sold.height() > 0)
        //if(qAbs(sold.width()-snew.width())>10 || qAbs(sold.height()-snew.height()) > 0)
        //not at programm start

}
void MainWindow::keyPressEvent(QKeyEvent *event){
    switch(event->key()){
        case Qt::Key_Right:
            zoom(1. , 0.5,   0); break;
        case Qt::Key_Left:
            zoom(1. ,-0.5,   0); break;
        case Qt::Key_Up:
            zoom(1. ,   0, 0.5); break;
        case Qt::Key_Down:
            zoom(1. ,   0,-0.5); break;
        case Qt::Key_Plus:
            zoom(0.5,   0,   0); break;
        case Qt::Key_Minus:
            zoom(2. ,   0,   0); break;
        case Qt::Key_Escape:
            if(c.input == routeshort ||
               c.input == routeflat)
                    reset_track();
            else
                emit stop_STRONG();
            break;
        case Qt::Key_Z:
            undo();
            break;
        case Qt::Key_Y:
            redo();
            break;
        case Qt::Key_Delete:
            reset_track();
            break;
        case Qt::Key_Backspace:
            if(QApplication::keyboardModifiers() == Qt::ControlModifier)
                delete_to_cross(10);
            else
                delete_to_cross(1);
            break;
        case Qt::Key_0:
            if(QApplication::keyboardModifiers() == Qt::ControlModifier)
                set_mintype(0);
            else
                set_maxtype(0);
            break;
        case Qt::Key_1:
            if(QApplication::keyboardModifiers() == Qt::ControlModifier)
                set_mintype(1);
            else
                set_maxtype(1);
            break;
        case Qt::Key_2:
            if(QApplication::keyboardModifiers() == Qt::ControlModifier)
                set_mintype(2);
            else
                set_maxtype(2);
            break;
        case Qt::Key_3:
            if(QApplication::keyboardModifiers() == Qt::ControlModifier)
                set_mintype(3);
            else
                set_maxtype(3);
            break;
        case Qt::Key_4:
            if(QApplication::keyboardModifiers() == Qt::ControlModifier)
                set_mintype(4);
            else
                set_maxtype(4);
            break;
        case Qt::Key_5:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
                set_mintype(5);
            else
                set_maxtype(5);
            break;
        case Qt::Key_PageUp:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
               selectSTRONG(fw,10);
            else
               selectSTRONG(fw,1);
            break;
        case Qt::Key_PageDown:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
               selectSTRONG(bw,10);
            else
               selectSTRONG(bw,1);
            break;
        case Qt::Key_C:
            set_routingmode(routeclimb);  break;
        case Qt::Key_A:
            set_routingmode(salesman);  break;
        case Qt::Key_E:
            set_routingmode(editdata);  break;
        case Qt::Key_F:
            set_routingmode(routeflat);  break;
        case Qt::Key_G:
            got_to_latlon();  break;
        case Qt::Key_K:
            set_routingmode(routeshort);  break;
        case Qt::Key_M:
            set_routingmode(routemountain);  break;
        case Qt::Key_S:
            set_routingmode(routeSTRONG);  break;
        case Qt::Key_T:{
            status2 = "preapring least time routing ...";
            update_statusbar();
            PowerAnalysis PAT(&(c.PA));
            osm->refresh_time(osm->get_first_KOO(),PAT.neighbour_to_time,
                              (void*)&PAT);
            set_routingmode(routetime); } break;
        case Qt::Key_L:
            set_routingmode(selectlayer);  break;
        case Qt::Key_N:
            toggle_preview(); break;
        case Qt::Key_Return:
            enter();break;
        case Qt::Key_F1:
            generate_Map();break;
    }
}
void MainWindow::zoom(double zoomfactor,double dlonfactor, double dlatfactor){
    map->scale(zoomfactor,dlonfactor,dlatfactor);
    update_map_raw();
}
void MainWindow::init(){
    selected_way = NULL;
    kold = knew = NULL;
    anchorfrom = anchorto = NULL;
    STRONGstate = readytotrace = traceback = 0;
    autosave = 1;
    SL = NULL;
    CL = NULL;
    SLN = SLc = 0;
    ct = new Track();
    lrt = new Track();
    cmap = new QPixmap;
    osm = new OSM;
    osm->load(c.start_btp);
    hd = new HeightData();
    hd->set_SRTM3_folder(c.SRTM3folder);
    map = ui->Map;
    map->set_data(hd,osm);
    map->settings(&(c.MS));
    map->init_map(1920,1080);
    r = new Routing(osm);
    UR = new UndoRedo;
    PA = new PowerAnalysis(&(c.PA));
    PA->show();
    statusLeft = new QLabel("coordinates", this);
    statusLeft->setFrameStyle(QFrame::Panel | QFrame::Sunken);
    statusMiddle = new QLabel("further information", this);
    statusMiddle->setFrameStyle(QFrame::Panel | QFrame::Sunken);
}
void MainWindow::show3D(){
    Terrain *t = new Terrain(osm,&ct,500,300,&c);
    double lat = (map->getmaxlat()+map->getminlat())/2;
    double lon = (map->getmaxlon()+map->getminlon())/2;
    t->setpos(lat,lon,map->XY_to_height(map->getwidth()/2,map->getheight()/2)+500,0,0,500);
    t->retexture();
    t->recalc();
    t->show();
}

void MainWindow::autoload_setting(){
    QString filename = QCoreApplication::applicationDirPath();
    filename.append("/settings.stg");
    FILE* f = fopen(filename.toLocal8Bit().data(),"rb");
    if(f != NULL){
        fread(&c,sizeof(config),1,f);
        fclose(f);
    }
    else
        init_config();
}
void MainWindow::autosave_setting(){
    QString filename = QCoreApplication::applicationDirPath();
    filename.append("/settings.stg");
    FILE* f = fopen(filename.toLocal8Bit().data(),"wb");
    fwrite(&c,sizeof(config),1,f);
    fclose(f);
}
void MainWindow::init_config(){
     c.mintype= 0;
     c.maxtype= 4;
     c.SRTM3folder[0] = '\0';
     c.start_btp[0] = '\0';
     BTP3setups(&(c.sconfig),&(c.mconfig),&(c.cconfig)).init();
     BTP3setups(&(c.CA)).init();
     BTP3setups(&(c.PS)).init();
     BTP3setups(&(c.MS)).init();
     c.input = routeshort;
     c.drawSTRONGlayer = 1;
     c.drawRoute = 0;
     c.drawClimblayer = 1;
     c.plotpower = 1;
     c.plotspeed = 1;
     PowerAnalysis().set_default(&(c.PA));
}
void MainWindow::update_map_raw(){
    QString status2keep = status2;
    status2 = "Map is rendering...";
    update_statusbar();

    climblayer* clt = NULL;
    if(CL != NULL && c.drawClimblayer)  clt = CL;
    STRONGlayer* slt = NULL;
    if(SL != NULL && c.drawSTRONGlayer)  slt = SL;

    map->draw_map(slt,clt,NULL,1);

    update_map_track();
    status2 = status2keep;
    update_statusbar();
}
void MainWindow::update_map_track(){
    map->draw_elements(ct,kold,knew,selected_way);
}
void MainWindow::update_map_MovObj(Way* w){
    QBrush brush(Qt::red);
    if(dstate != nonedot){
        if(dstate == crossdot)
            brush.setColor(Qt::yellow);
        if(dstate == crossdotmarked)
            brush.setColor(Qt::black);
        map->show_elements(w,xdot,ydot,brush);
    }
    else
        map->show_elements(w,-100,-100,brush);

}
void MainWindow::update_profil(){
    if(ct != NULL){
        double hm = ct->get_height_meters();
        double d = ct->get_length();
        if(ct == lrt && PA->isVisible() && PA->isready()){
            ui->profil->set_labels(QString("%1 km  %2 Hm  %3 Hm/km  %4 km/h  %5 W")
                                   .arg(d,0,'f',2)
                                   .arg(hm,0,'f',0)
                                   .arg(hm/d,0,'f',1)
                                   .arg(PA->get_v(),0,'f',1)
                                   .arg(PA->get_P(),0,'f',0),
                               "d [km]","h [m]");

        }
        else
            ui->profil->set_labels(QString("%1 km  %2 Hm  %3 Hm/km")
                                   .arg(d,0,'f',2)
                                   .arg(hm,0,'f',0)
                                   .arg(hm/d,0,'f',1),
                               "d [km]","h [m]");
        double **dt = NULL,**dt1 = NULL,**dt2 = NULL;
        int tc=0,tc1=0,tc2=0;
        dt = ct->get_d_h_array();
        tc = ct->get_array_length();
        if(c.plotspeed && ct == lrt && PA->isVisible() && PA->isready()){
            dt1 = PA->get_vdata();
            tc1 = PA->get_datacount();
        }
        if(c.plotpower && ct == lrt && PA->isVisible() && PA->isready()){
            dt2 = PA->get_Pdata();
            tc2 = PA->get_datacount();
        }
        ui->profil->set_data(dt,tc,dt1,tc1,dt2,tc2);
    }
}
void MainWindow::drawCross(QPainter *p){
    p->setPen(Qt::NoPen);
    p->setBrush(QBrush(Qt::green));
    if(kold != NULL)
        p->drawEllipse(map->lon_to_x(kold->lon)-5,
                       map->lat_to_y(kold->lat)-5,
                       11,11);
    if(knew != NULL)
        p->drawEllipse(map->lon_to_x(knew->lon)-5,
                       map->lat_to_y(knew->lat)-5,
                       11,11);
}
void MainWindow::drawRoute(QPainter *p){
    if(ct != NULL){
        // draw line
        p->setPen(QPen(QBrush(c.MS.trackcolor),map->zoomsize(c.MS.trackwidth)));
        map->draw_line(p,ct);
    }
}
void MainWindow::set_SRTM3_folder(){
    QString filename = QFileDialog::getExistingDirectory(this,"select SRTM3 data directory");
    strcpy(c.SRTM3folder,filename.toLocal8Bit().data());
    hd->set_SRTM3_folder(c.SRTM3folder);
    update_map_raw();
}
void MainWindow::mousePressEvent(QMouseEvent *event){
    if(event->button()==Qt::LeftButton && !traceback){
        xold = event->x()-centralWidget()->x();
        yold = event->y()-centralWidget()->y();
        // drag drop track modification might be activated
        if(	(c.input == routeshort || c.input == routeflat || c.input == routetime)
            && ct->found_anchors(map->Y_to_lat(yold),map->X_to_lon(xold),
                                 map->scale()*5,&anchorfrom,&anchorto)){
            // track was clicked at marked cross position, preparing for drag&drop
            if(c.input == routeshort){
                if(anchorfrom != NULL)
                    r->Dijkstra(anchorfrom,NULL,c.maxtype,c.mintype,osm,0,r->get_d);
                if(anchorto != NULL)
                    r->Dijkstra(anchorto,NULL,c.maxtype,c.mintype,osm,1,r->get_d);
            }
            if(c.input == routeflat){
                if(anchorfrom != NULL)
                    r->Dijkstra(anchorfrom,NULL,c.maxtype,c.mintype,osm,0,r->get_hm);
                if(anchorto != NULL)
                    r->Dijkstra(anchorto,NULL,c.maxtype,c.mintype,osm,1,r->get_hm);
            }
            if(c.input == routetime){
                if(anchorfrom != NULL)
                    r->Dijkstra(anchorfrom,NULL,c.maxtype,c.mintype,osm,0,r->get_t);
                if(anchorto != NULL)
                    r->Dijkstra(anchorto,NULL,c.maxtype,c.mintype,osm,1,r->get_t);
            }
            readytotrace = traceback = 1;
        }
    }
}
void MainWindow::mouseReleaseEvent(QMouseEvent *event){
    x = event->x()-centralWidget()->x();
    y = event->y()-centralWidget()->y();
    if(event->button()==Qt::LeftButton){
        if(traceback && (x != xold || y != yold))
            accept_ct();
        else{
            if(x == xold || y == yold){
                if(c.input == editdata){
                    // map element ist going to be edited
                    kold = NULL;
                    knew = NULL;
                    selected_way = osm->select_Way(map->Y_to_lat(y),map->X_to_lon(x));
                    if(selected_way != NULL){
                        status2 = QString("Way %1 selected, typ: %2")
                                    .arg(selected_way->id)
                                    .arg((int)selected_way->type);
                        update_statusbar();
                        update_map_track();
                    }
                }
                else{
                    // cross was was clicked
                    if(		(dstate == crossdot || dstate == crossdotmarked)
                        &&  kdot != NULL){
                        // cross on ct was clicked
                        ct->toggle_marker(kdot);
                        traceback = 0;
                        readytotrace = 0;
                        update_map_track();
                    }
                    else{
                        // cross aside track was clicked
                        if(STRONGstate == 1){
                            status2 = "STRONG calculation still running. ESC to quit.";
                            update_statusbar();
                            return;
                        }
                        if(STRONGstate == 2)
                            acceptSTRONG();

                        KOO* k = osm->get_first_KOO();
                        float d = 1e10;
                        osm->select_cross(map->Y_to_lat(y),map->X_to_lon(x),
                                          c.mintype,c.maxtype,&k,&d,k);
                        kold = knew;
                        knew = k;
                        if(kold != NULL && kold != knew){
                            if(event->modifiers()==Qt::ControlModifier){
                                if(knew == NULL || d > 0.1){
                                    knew = new KOO;
                                    knew->id = -1;
                                    knew->cd = NULL;
                                    knew->lat = map->Y_to_lat(y);
                                    knew->lon = map->X_to_lon(x);
                                }
                                route_airline();
                            }
                            else{
                                if(knew != NULL && kold->cd != NULL){
                                    // start and end are known, algorithms are
                                    //allowed to work
                                    if(c.input == routeshort)	route_short();
                                    if(c.input == routeflat)	route_flat();
                                    if(c.input == routetime)	route_time();
                                    if(c.input == salesman)     route_salesman();
                                    if(c.input == routeSTRONG
                                     ||c.input == routeclimb
                                     ||c.input == routemountain)
                                                                route_STRONG();
                                }
                            }
                        }
                        else{
                            if(knew == NULL || d > 0.1){
                                knew = new KOO;
                                knew->id = -1;
                                knew->cd = NULL;
                                knew->lat = map->Y_to_lat(y);
                                knew->lon = map->X_to_lon(x);
                            }
                            update_map_track();
                        }
                        // routing is finished, reset the old selected cross
                    }
                }
            }
            else{
                if(event->modifiers()==Qt::ControlModifier){
                    /*zoom box*/
                    zoom((1.*abs(x-xold)/map->size().width()+1.*abs(y-yold)/map->size().height())/2.,
                         1.*((x+xold)/2.-map->size().width()/2.)/map->size().width(),
                         1.*(map->size().height()/2.-(yold+y)/2.)/map->size().height());
                }
                else{
                    /*move map*/
                    zoom(1.,1.*(xold-x)/map->size().width(),1.*(y-yold)/map->size().height());
                }
            }
        }
    }
}
void MainWindow::mouseMoveEvent(QMouseEvent *event){
    this->setFocus();
    x = event->x()-centralWidget()->x();
    y = event->y()-centralWidget()->y();
    if(traceback){
        KOO* k; float d = 1e15;
        osm->select_cross(map->Y_to_lat(y),map->X_to_lon(x),
                          &k,&d,osm->get_first_KOO());
        status1 = QString("%1Â°N %2 Â°E %3 m")
                          .arg(map->Y_to_lat(y),10,'f',6)
                          .arg(map->X_to_lon(x),10,'f',6)
                          .arg(map->XY_to_height(x,y),7,'f',1);
        trace_back(k);
    }
    else{
        if(event->buttons()==Qt::LeftButton){
            if(event->modifiers()==Qt::ControlModifier){
                // zoom box
                map->show_zoombox(x,xold,y,yold);
                status1 = QString("%1Â°N %2Â°E %3 m")
                                  .arg(map->Y_to_lat(y),10,'f',6)
                                  .arg(map->X_to_lon(x),10,'f',6)
                                  .arg(map->XY_to_height(x,y),7,'f',1);
            }
            else{
                // move map
                map->show_translated(x,xold,y,yold);
                status1 = "";
            }
        }
        else{
            status1 = QString("%1Â°N %2Â°E %3 m")
                              .arg(map->Y_to_lat(y),10,'f',6)
                              .arg(map->X_to_lon(x),10,'f',6)
                              .arg(map->XY_to_height(x,y),7,'f',1);
            MouseToTrack();
            Way* w = NULL;
            if(c.input == editdata){
                w = osm->select_Way(map->Y_to_lat(y),map->X_to_lon(x));
                if(w != NULL)
                    status2 = QString("way id: %1").arg(w->id);
                else
                    status2 = "";
            }
            update_map_MovObj(w);
        }
    }
    update_statusbar();
}
void MainWindow::wheelEvent(QWheelEvent * event ){
    x = event->x()-centralWidget()->x();
    y = event->y()-centralWidget()->y();
    int xmiddle = map->getwidth()/2;
    int ymiddle = map->getheight()/2;
    if (event->delta() < 0)
        zoom(2. ,1.*(x-xmiddle)/map->getwidth(),
             1.*(ymiddle-y)/map->getheight());
    else
        zoom(0.5,1.*(x-xmiddle)/map->getwidth(),
             1.*(ymiddle-y)/map->getheight());
}
void MainWindow::update_statusbar(){
    statusLeft->setText(status1);
    statusMiddle->setText(status2);
    ui->statusBar->update();//repaint();
}
void MainWindow::load_btp(){
    QString filename = QFileDialog().getOpenFileName(this,"open BTP data","","BergTourenPlaner data (*.btp)");
    if(!filename.isEmpty()){
        status2 = QString("Loading %1 ...").arg(filename);
        update_statusbar();
        load_btp(filename);
    }
}
void MainWindow::load_btp(QString filename){
    bool centermap = (osm->get_status()<3);
    osm->load(filename.toLocal8Bit().data());
    set_routingmode(c.input);
    if(centermap){
        osm->calc_brect();
        // if this is the first data loaded at this BTP instance
        c.MS.minlat = osm->getminlat();
        c.MS.maxlat = osm->getmaxlat();
        c.MS.minlon = osm->getminlon();
        c.MS.maxlon = osm->getmaxlon();
        if(c.MS.minlat >= c.MS.maxlat){
            c.MS.minlat = qMax(-90.,c.MS.maxlat-0.1);
            c.MS.maxlat = qMin( 90.,c.MS.minlat+0.1);
        }
        if(c.MS.minlon >= c.MS.maxlon){
            c.MS.minlon = qMax(-180.,c.MS.maxlon-0.1);
            c.MS.maxlon = qMin( 180.,c.MS.minlon+0.1);
        }
        map->set_borders(c.MS.minlat,c.MS.maxlat,c.MS.minlon,c.MS.maxlon);
        map->calc_borders();
    }
    update_map_raw();
}

void MainWindow::save_btp(){
    QString filename = QFileDialog().getSaveFileName(this,"save BTP data","","BergTourenPlaner data (*.btp)");
    if(!filename.isEmpty()){
        status2 = QString("Saving data within window to %1 ...").arg(filename);
        update_statusbar();
        save_btp(filename,map->getminlat(),map->getmaxlat(), map->getminlon(),
                 map->getmaxlon());
        set_routingmode(c.input);
        update_map_raw();
    }
}
void MainWindow::save_btp(QString filename, double minlat, double maxlat,
                          double minlon, double maxlon){
    osm->save(filename.toLocal8Bit().data(), minlat, maxlat, minlon, maxlon);
}
void MainWindow::read_osm(){
    QString filename = QFileDialog().getOpenFileName(this,"read OSM data","","OpenStreetMap data (*.osm)");
    if(!filename.isEmpty()){
        read_osm(filename);
        update_map_raw();
    }
}
void MainWindow::read_osm(QString filename){
    status2 = "Data is processed. This may last several minutes.";
    update_statusbar();
    osm->setfilename(filename.toLocal8Bit().data());
    osm->read_OSM();
    status2 = "Data read. Continue with generating relational data base.";
    update_statusbar();
    osm->get_KOO_Waysavl();
    osm->check_lines();
    status2 = "Data base ready. Processing OSM-Relationdata.";
    update_statusbar();
    osm->RelationstoFace(osm->woodr,osm->wood);
    osm->RelationstoFace(osm->waterr,osm->water);
    status2 = "Relations processed. Loading heightdata server.";
    update_statusbar();
    osm->calc_brect();
    HeightData h2;
    h2.set_SRTM3_folder(&(c.SRTM3folder[0]));
    h2.reset_t(osm->getminlat()-0.1,
               osm->getmaxlat()+0.1,
               osm->getminlon()-0.2,
               osm->getmaxlon()+0.2);
    status2 = "Heightdata ready. Ranking summits.";
    update_statusbar();
    osm->calc_peak_index_pro(&h2);
    osm->sort_peaks();
    status2 = "Summits ranked. Generating streets height data.";
    update_statusbar();
    status2 = "OSM Processing has finished. First save data as *.btp an restart programm.";
    update_statusbar();
    set_routingmode(c.input);
    c.MS.minlat = osm->getminlat();
    c.MS.maxlat = osm->getmaxlat();
    c.MS.minlon = osm->getminlon();
    c.MS.maxlon = osm->getmaxlon();
    map->set_borders(c.MS.minlat,c.MS.maxlat,c.MS.minlon,c.MS.maxlon);
    map->calc_borders();
    update_map_raw();
    update_profil();
}

void MainWindow::set_start_btp(){
    QString filename = QFileDialog().getOpenFileName(this,"select BTP file","","BergTourenPlaner data (*btp)");
    if(filename.isEmpty()){
        c.start_btp[0] = '\0';
        status2 = QString("Loading no btp data at programm start.");
    }
    else{
        strcpy(c.start_btp,filename.toLocal8Bit().data());
        status2 = QString("Loading %1 at program start.").arg(filename);
    }
    update_statusbar();
}
void MainWindow::profilinfo(double x){
    if(ct != NULL){
        double h;
        ct->extract_h(x,&h);
        KOO k;
        ct->extract_KOO(&k,x);
        int xpx = map->lon_to_x(k.lon);
        int ypx = map->lat_to_y(k.lat);
        status1 = QString("%1Â°N %2Â°E %3 m [%4 km %5 m]")
                          .arg(k.lat,10,'f',6)
                          .arg(k.lon,10,'f',6)
                          .arg(map->XY_to_height(xpx,ypx),7,'f',1)
                          .arg(x,7,'f',3)
                          .arg(h,6,'f',1);
        if(ct==lrt && PA->isready() && PA->isVisible()){
            QTime time = QTime(0,0,0,0).addSecs(PA->get_t(x));
            status1.append(QString("[%1 km/h  %2 W  %3]")
                           .arg(PA->get_v(x),0,'f',1)
                           .arg(PA->get_P(x),0,'f',0)
                           .arg(time.toString()));
        }
        update_statusbar();
        xdot = map->lon_to_x(k.lon);
        ydot = map->lat_to_y(k.lat);
        dstate = waydot;
        update_map_MovObj(NULL);
    }

}
int MainWindow::trace_back(KOO* k){
    if(readytotrace){
        if(anchorto != NULL || anchorfrom != NULL){
            //QMessageBox().exec();
            Track *tfrom,*tto, start(lrt),end(lrt);
            // first route wayfrom anchorfrom to new cross
            if(anchorfrom != NULL){
                /*ein Zwischenpunkt wird veraendert*/
                start.trim_right(anchorfrom);
                if(anchorfrom->cd != NULL){
                    if(k->cd->s[0].from != NULL){
                        Neighbour** nl=NULL;
                        int nc;
                        r->extract_neighbourlist(&(anchorfrom->cd->s[0]),
                                                &(k->cd->s[0]),
                                                &nl,&nc);
                        tfrom = new Track(nl,nc);
                    }
                    else
                        tfrom = r->airline(hd,anchorfrom,k);
                }
                else
                    tfrom = r->airline(hd,anchorfrom,k);;
            }
            else{
                /*Der Startpunkt wird veraendert*/
                start.delete_complete();
                tfrom = new Track();
            }
            // now route way from new cross to anchorto
            if( anchorto != NULL){
                /*ein Zwischenpunkt wird veraendert*/
                end.trim_left(anchorto);
                if(anchorto->cd != NULL){
                    if(k->cd->s[1].from != NULL){
                        Neighbour** nl=NULL;
                        int nc;
                        r->extract_neighbourlist(&(anchorto->cd->s[1]),&(k->cd->s[1]),
                                                &nl,&nc);
                        tto = new Track(nl,nc);
                        tto->invert();
                    }
                    else
                        tto = r->airline(hd,k,anchorto);
                }
                else
                    tto = r->airline(hd,k,anchorto);
            }
            else{
                /*Der Endpunktt wird veraendert*/
                end.delete_complete();
                tto = new Track();
            }
            start.add(tfrom);
            start.add(tto);
            start.add(&end);
            if(ct != lrt)
                delete ct;
            ct = new Track(&start);
            update_map_track();
            update_profil();
            return 1;
        }
        else{
            if(	k != knew && k->cd->s[STRONGindex].via != NULL){
                Neighbour** nl = NULL; int nc;
                if(ct != lrt)
                    delete ct;
                ct = new Track(lrt);
                r->extract_neighbourlist(NULL, &(k->cd->s[STRONGindex]),&nl,&nc);
                if(nc>1){
                    Track ttemp(&(nl[1]),nc-1);
                    ct->add(&ttemp);
                }
                delete nl;
                update_profil();
                update_map_track();
                return 1;
            }
            else
                return 0;

        }
    }
    else
        return 0;

}
void MainWindow::route_airline(){
    UR->add(ct);
    Track *airtrack = r->airline(hd,kold,knew);
    ct->add(airtrack);
    delete airtrack;
    set_routingmode(c.input);
    lrt = ct;
    recalc_power();
    update_map_track();
    update_profil();
}
void MainWindow::route_short(){
    status2 = "Shortest track is routing ...";
    update_statusbar();
    if(!r->Dijkstra(kold,knew,c.maxtype,c.mintype,osm,0,r->get_d)){
        knew = kold;
        status2 = "Found no way!";
        update_statusbar();
        return;
    }
    Neighbour** nl=NULL;
    int nc;
    r->extract_neighbourlist(kold->cd->s,knew->cd->s,&nl,&nc);
    kold = NULL;
    Track tt(nl,nc);
    UR->add(ct);
    ct->add(&tt);
    set_routingmode(c.input);
    delete nl;
    lrt = ct;
    recalc_power();
    update_map_track();
    update_profil();
}
void MainWindow::route_salesman(){
    status2 = "Handelskaufmann-Problem wird geloest ...";
    update_statusbar();
    Track* result;
    QStringList fs = QFileDialog().getOpenFileNames(this,"Salesman customers","","BTP track (*.btr)");
    if(!fs.isEmpty()){
        bool* errors = new bool[fs.length()];
        Track **tracks = new Track*[fs.length()];
        bool all_tracks_OK = true;
        QString trackerror;
        for(int i = 0; i < fs.length(); i++){
            tracks[i] = new Track(fs[i].toLocal8Bit().data(),&get_KOO_helper,(void*)osm);
            if(!tracks[i]->notNULL()){
                trackerror.append(fs[i]).append(" could not be loaded into current data set.\n");
                all_tracks_OK = false;
            }
        }
        if(!all_tracks_OK){
            QMessageBox(QMessageBox::NoIcon,"Error",trackerror).exec();
            return;
        }
        if(!r->salesman(kold,knew,c.maxtype,c.mintype,osm,
                        tracks,fs.length(),&result,errors)){
            QString merr("Salesman could not be solved, because followings customers could not be reached:\n");
            for(int i = 0; i < fs.length(); i++)
                if(errors[i])
                    merr.append(fs[i]).append("\n");
            QMessageBox(QMessageBox::NoIcon,"Error",merr).exec();

        }
        else{
            UR->add(ct);
            ct->add(result);
            set_routingmode(c.input);
            lrt = ct;
            recalc_power();
            update_map_track();
            update_profil();
        }
    }
    set_routingmode(c.input);
}
void MainWindow::route_flat(){
    status2 = "Least vertical meter track is routing ...";
    update_statusbar();
    if(!r->Dijkstra(kold,knew,c.maxtype,c.mintype,osm,0,r->get_hm)){
        knew = kold;
        status2 = "Found no way!";
        update_statusbar();
        return;
    }
    Neighbour** nl=NULL;
    int nc;
    r->extract_neighbourlist(kold->cd->s,knew->cd->s,&nl,&nc);
    kold = NULL;
    Track tt(nl,nc);
    UR->add(lrt);
    lrt->add(&tt);
    if(ct != lrt)
        delete ct;
    ct = lrt;
    recalc_power();
    update_map_track();;
    update_profil();
    set_routingmode(c.input);
    delete nl;
}
void MainWindow::route_time(){
    status2 = "routing for least time ...";
    update_statusbar();
    if(!r->Dijkstra(kold,knew,c.maxtype,c.mintype,osm,0,r->get_t)){
        knew = kold;
        status2 = "Found no way!";
        update_statusbar();
        return;
    }
    Neighbour** nl=NULL;
    int nc;
    r->extract_neighbourlist(kold->cd->s,knew->cd->s,&nl,&nc);
    kold = NULL;
    Track tt(nl,nc);
    UR->add(ct);
    ct->add(&tt);
    //set_routingmode(c.input);
    delete nl;
    lrt = ct;
    recalc_power();
    update_map_track();
    update_profil();
}
void MainWindow::route_STRONG(){
    STRONGsetting* s;
    bool hmonly = true;
    if(c.input == routemountain) s = &(c.mconfig);
    if(c.input == routeSTRONG)   s = &(c.sconfig);
    if(c.input == routeclimb){   s = &(c.cconfig); hmonly = false;}

    STRONGcalc* sc = new STRONGcalc(osm,kold,knew,c.maxtype,c.mintype,s,
                  &STRONGtracks,&sN,hmonly);
    connect(sc,SIGNAL(refresh_progress(int)),this,SLOT(STRONG_preview(int)));
    connect(sc,SIGNAL(finished(int)),this,SLOT(route_STRONG_finalize(int)));
    connect(this,SIGNAL(stop_STRONG()),sc,SLOT(stop_calculations()));
    STRONGstate = 1;
    sc->start();
}
void MainWindow::route_STRONG_finalize(int succes){
    if(succes){
        // STRONG algorithm has succesfully finsihed
        STRONGindex = sN-1;
        if(c.input == routemountain){
            // search for the track with most Hm/km
            double minQu = 0, Qut = -1;
            for(int i = 0; i < sN; i++){
                if(STRONGtracks[i] != NULL){
                    Qut = STRONGtracks[i]->get_height_meters()/STRONGtracks[i]->get_length();
                    if(Qut > minQu){
                        STRONGindex = i;
                        minQu = Qut;
                    }
                }
            }
            STRONGstate = 2;
            acceptSTRONG();
            kold = NULL;
        }
        else{
            readytotrace = 1;
            STRONGstate = 2;
            if(STRONGtracks[STRONGindex] == NULL)
                selectSTRONG(bw,1);
            else{
                status2 = QString("STRONG %1/%2, select with page up/down, ENTER to accept, 'm' to select any crossroad as end point")
                                  .arg(STRONGindex+1)
                                  .arg(sN);
                update_statusbar();
            }
            kold = NULL;
        }
    }
    else{
        status2 = "Found no way. Free Memory ...";
        update_statusbar();
        r->finish_STRONG();
        STRONGstate = readytotrace = 0;
        knew = kold;
        update_map_track();
        set_routingmode(c.input);
        status2 = "Found no way.";
        update_statusbar();
    }
}
void MainWindow::delete_STRONG_tracks(){
    if(STRONGtracks != NULL){
        for(int i = 0; i < sN; i++)
            if(STRONGtracks[i] != NULL)
                STRONGtracks[i]->~Track();
        free(STRONGtracks);
        STRONGtracks = NULL;
    }
}
void MainWindow::acceptSTRONG(){
    if(	   c.input == routeSTRONG
        || c.input == routemountain
        || c.input == routeclimb){
        if(STRONGstate == 2){
            status2 = "Free Memory ...";
            update_statusbar();
            r->finish_STRONG();				//allokierten Speicher freigeben
        }
        // add selected STRONG track to existing ct
        UR->add(lrt);
        if(lrt != ct)
            delete lrt;
        lrt = ct;
        recalc_power();
        update_profil();
        knew = ct->get_last_KOO();
        readytotrace = traceback = STRONGstate = 0;
        set_routingmode(c.input);
        update_map_track();
    }
}
void MainWindow::reset_track(){
    dstate = nonedot;					//es gibt keinen Punkt mehr zu zeigen
    if(c.input != editdata && !traceback){
        /* if routing then clear tracks anyway*/
        kold = NULL;
        knew = NULL;
        UR->add(lrt);
        lrt->delete_complete();
        ct->delete_complete();
    }
    switch(c.input){
        case routeclimb:
        case routeSTRONG:
            acceptSTRONG();
            set_routingmode(c.input);
            break;
        case routeshort:
        case routeflat:
        case routemountain:
            set_routingmode(c.input);
            break;
        case editdata:
            if(selected_way != NULL){
                osm->del_Way(selected_way);
                status2 = QString("Way %1 was deleted!").arg(selected_way->id);
                update_statusbar();
                selected_way = NULL;
                update_map_raw();
            }
            break;
        default: break;
    }
    recalc_power();
    update_profil();
    update_map_track();;
}
void MainWindow::set_routingmode(inputstate ip){
    if(STRONGstate == 2)
        acceptSTRONG();
    c.input = ip;
    selected_way = NULL;
    switch(c.input){
    case routeshort:
        status2  = QString("[mint: %1, maxt: %2] Routet kuerzesten Weg; z fuer rueckgaengig, entf zum loeschen").arg(int(c.mintype)).arg(int(c.maxtype));
        break;
    case salesman:
        status2  = QString("[mint: %1, maxt: %2] Routet Handelskaufmannsproblem; z fuer rueckgaengig, entf zum loeschen").arg(int(c.mintype)).arg(int(c.maxtype));
        break;
    case routeflat:
        status2  = QString("[mint: %1, maxt: %2] Routet hoehenmeteraermsten Weg; z fuer rueckgaengig, entf zum loeschen").arg(int(c.mintype)).arg(int(c.maxtype));
        break;
    case routetime:
        status2  = QString("[mint: %1, maxt: %2] Routet kuerzeste Zeit; z fuer rueckgaengig, entf zum loeschen").arg(int(c.mintype)).arg(int(c.maxtype));
        break;
    case routeclimb:
        if(c.cconfig.noSTRONGPlus)
            status2  = QString("[points: %1, step: %2, mint: %3, c.maxt: %4, maxhmperkm: %5] routing STRONG, ESC to cancel, z undo, r redo, entf to delete")
                                .arg(c.cconfig.hmmax)
                                .arg(c.cconfig.hmstep)
                                .arg(int(c.mintype))
                                .arg(int(c.maxtype))
                                .arg(c.cconfig.hmperkm);
        else
            status2  = QString("[points: %1, step: %2, mint: %3, c.maxt: %4, maxhmperkm: %5, dhmin: %6, minP: %7, downtoupmax: %8] routing STRONG with restrictions, ESC to cancel, z undo, r redo, entf to delete")
                                .arg(c.cconfig.hmmax)
                                .arg(c.cconfig.hmstep)
                                .arg(int(c.mintype))
                                .arg(int(c.maxtype))
                                .arg(c.cconfig.hmperkm)
                                .arg(c.cconfig.dhmin)
                                .arg(c.cconfig.minP)
                                .arg(c.cconfig.downtoupmax);
        break;
    case routemountain:
        if(c.mconfig.noSTRONGPlus)
            status2  = QString("[HM: %1, step: %2, mint: %3, c.maxt: %4, maxhmperkm: %5] routing STRONG, ESC to cancel, z undo, r redo, entf to delete")
                                .arg(c.mconfig.hmmax)
                                .arg(c.mconfig.hmstep)
                                .arg(int(c.mintype))
                                .arg(int(c.maxtype))
                                .arg(c.mconfig.hmperkm);
        else
            status2  = QString("[HM: %1, step: %2, mint: %3, c.maxt: %4, maxhmperkm: %5, dhmin: %6, minP: %7, downtoupmax: %8] routing STRONG with restrictions, ESC to cancel, z undo, r redo, entf to delete")
                                .arg(c.mconfig.hmmax)
                                .arg(c.mconfig.hmstep)
                                .arg(int(c.mintype))
                                .arg(int(c.maxtype))
                                .arg(c.mconfig.hmperkm)
                                .arg(c.mconfig.dhmin)
                                .arg(c.mconfig.minP)
                                .arg(c.mconfig.downtoupmax);
        break;
    case routeSTRONG:
        if(c.sconfig.noSTRONGPlus)
            status2  = QString("[HM: %1, step: %2, mint: %3, c.maxt: %4, maxhmperkm: %5] routing STRONG, ESC to cancel, z undo, r redo, entf to delete")
                                .arg(c.sconfig.hmmax)
                                .arg(c.sconfig.hmstep)
                                .arg(int(c.mintype))
                                .arg(int(c.maxtype))
                                .arg(c.sconfig.hmperkm);
        else
            status2  = QString("[HM: %1, step: %2, mint: %3, c.maxt: %4, maxhmperkm: %5, dhmin: %6, minP: %7, downtoupmax: %8] routing STRONG with restrictions, ESC to cancel, z undo, r redo, entf to delete")
                                .arg(c.sconfig.hmmax)
                                .arg(c.sconfig.hmstep)
                                .arg(int(c.mintype))
                                .arg(int(c.maxtype))
                                .arg(c.sconfig.hmperkm)
                                .arg(c.sconfig.dhmin)
                                .arg(c.sconfig.minP)
                                .arg(c.sconfig.downtoupmax);
        break;
    case editdata:
        status2  = QString("Waehlen sie einen Weg durch Klicken zum Editieren aus; entf zum entfernen, Zahlen 0 bis 5 zum einstellen des Typ");
        break;
    case selectlayer:
        if(SL != NULL){
            status2  = QString("STRONGlayer %1 von %2 wird angezeigt; mit Bild auf/ab Layer auswaehlen").arg(SLc).arg(SLN);
            update_map_track();;
        }
        else
            status2  = QString("Kein STRONGlayer geladen");
        break;
    default: break;
    }
    update_statusbar();
}
void MainWindow::delete_to_cross(int cc){
    UR->add(lrt);
    lrt->delete_cross(cc);
    if(ct != lrt)
        delete ct;
    ct = lrt;
    if(ct->notNULL())
        knew = ct->get_last_KOO();
    else
        knew = NULL;
    kold = NULL;
    recalc_power();
    update_profil();
    update_map_track();
}
void MainWindow::set_mintype(char mt){
    c.mintype = qMin(mt,char(5));
    set_routingmode(c.input);
}
void MainWindow::set_maxtype(char mt){
    if(c.input == editdata && selected_way != NULL){
        osm->change_Waytype(selected_way,mt);
        status2 = QString("Weg %i geaendert\nneuer Typ: %i ")
                    .arg(selected_way->id)
                    .arg(selected_way->type);
        selected_way = NULL;
        update_statusbar();
        update_map_raw();
    }
    else{
        c.maxtype = qMin(mt,char(5));
        set_routingmode(c.input);
    }
}
void MainWindow::undo(){
    if(lrt != ct)
        delete lrt;
    lrt = ct = UR->undo(ct);
    recalc_power();
    kold = NULL;
    knew = ct->get_last_KOO();
    update_profil();
    update_map_track();;
}
void MainWindow::redo(){
    if(lrt != ct){
        delete lrt;
        delete ct;
    }
    else
        delete ct;
    lrt = ct = UR->redo();
    recalc_power();
    kold = NULL;
    knew = ct->get_last_KOO();
    update_profil();
    update_map_track();
}
void MainWindow::selectSTRONG(readdirection rd, short steps){
    if((c.input == routeSTRONG || c.input == routeclimb) && readytotrace){
        if( rd == fw ){
            STRONGindex = min( sN-1, STRONGindex + steps);
            while(STRONGindex < sN-1 && STRONGtracks[STRONGindex] == NULL)
                STRONGindex++;
            if(STRONGtracks[STRONGindex] == NULL)
                selectSTRONG(bw,1);
        }
        else{
            STRONGindex = max( 0, STRONGindex - steps);
            while(STRONGindex > 0 && STRONGtracks[STRONGindex] == NULL)
                STRONGindex--;
            if(STRONGtracks[STRONGindex] == NULL)
                selectSTRONG(fw,1);
        }
        status2 = QString("STRONG %1/%2, select with page up/down, ENTER to accept, 'm' to select any crossroad as end point")
                          .arg(STRONGindex+1)
                          .arg(sN);
        update_statusbar();
        STRONG_preview(STRONGindex);
    }
    if(c.input == selectlayer && SL != NULL){
        if( rd == fw )
            SL = r->STRONGlayer_create(SL,qMin(sN-1,SLc + steps));
        else
            SL = r->STRONGlayer_create(SL,qMax(0   ,SLc - steps));
        status2 = QString("STRONGlayer %1 von %2 is shown. Select layer with page up/down").arg(SLc).arg(SLN);
        update_statusbar();
        update_map_raw();
    }
}
void MainWindow::MouseToTrack(){
    dstate = nonedot;
    double ddot;
    kdot = NULL;
    if( ct != NULL && ct->notNULL()){
        KOO ktt;
        switch(ct->next_cross(map->Y_to_lat(y),map->X_to_lon(x),&kdot,map->scale()*5)){
            case 1:
                dstate = crossdot;
                xdot = map->lon_to_x(kdot->lon);
                ydot = map->lat_to_y(kdot->lat);
                return;
            case 2:
                dstate = crossdotmarked;
                xdot = map->lon_to_x(kdot->lon);
                ydot = map->lat_to_y(kdot->lat);
                return;
        }
        // there is no cross of ct in reach, search absolut nearest point on ct
        if(ct->near_check(map->Y_to_lat(y),map->X_to_lon(x),
                          (map->getmaxlat()-map->getminlat())*0.1))
            // the track is close to the mouse point
            if(ct->next_d(map->Y_to_lat(y),map->X_to_lon(x),&ddot))
                // the neares point was found
                if(ct->extract_KOO(&ktt,ddot)){
                    // calc with the nearest point
                    xdot = map->lon_to_x(ktt.lon);
                    ydot = map->lat_to_y(ktt.lat);
                    dstate = waydot;
                    ui->profil->set_marker(ddot);
                    double h; ct->extract_h(ddot,&h);
                    status1.append(QString(" [%1 km %2 m]")
                                    .arg(ddot,7,'f',3)
                                    .arg(h,6,'f',1));
                    if(ct==lrt && PA->isready()&& PA->isVisible()){
                        int timei = PA->get_t(ddot);
                        QTime time = QTime(0,0,0,0).addSecs(timei);
                        status1.append(QString("[%1 km/h  %2 W  %3]")
                                       .arg(PA->get_v(ddot),0,'f',1)
                                       .arg(PA->get_P(ddot),0,'f',0)
                                       .arg(time.toString()));
                    }
                    return;
                }
    }
    ui->profil->set_marker(ui->profil->get_xmin());
}

void MainWindow::enter(){
    if(traceback)
        accept_ct();
    else{
        if(STRONGstate == 1){
            status2 = "STRONG calculation still running. ESC to quit.";
            update_statusbar();
        }
        else{
            if(	  c.input == routeSTRONG
                ||c.input == routeclimb
                ||c.input == routemountain){
                if(readytotrace)
                    acceptSTRONG();
                else{
                    kold = knew;
                    knew = NULL;
                    route_STRONG();
                }
            }
            if(	  c.input == routeflat && knew != NULL){
                status2 = "Hoehenmeteraermster Weg mit offenem Ende wird geroutet ...";
                update_statusbar();
                r->Dijkstra(knew,NULL,c.maxtype,c.mintype,osm,0,r->get_hm);
                readytotrace = 1; STRONGindex = 0; traceback = 1;
                anchorto = anchorfrom = NULL;
                status2 = "Hoehenmeterarme Wege bereit ...";
                update_statusbar();
            }
            if(	  c.input == routeshort && knew != NULL){
                status2 = "Kuerzester Weg mit offenem Ende wird geroutet ...";
                update_statusbar();
                r->Dijkstra(knew,NULL,c.maxtype,c.mintype,osm,0,r->get_d);
                readytotrace = 1; STRONGindex = 0; traceback = 1;
                anchorto = anchorfrom = NULL;
                status2 = "Kurze Wege bereit ...";
                update_statusbar();
            }
            if(	  c.input == salesman){
                kold = knew;
                knew = NULL;
                route_salesman();
                knew = kold;
                kold = NULL;
            }
        }
    }
}
void MainWindow::accept_ct(){
    UR->add(lrt);
    if(lrt != ct)
        delete lrt;
    lrt = ct;
    recalc_power();
    update_profil();
    traceback = 0;
    readytotrace = 0;
    if(STRONGstate == 1)
        acceptSTRONG();
    knew = ct->get_last_KOO();
    kold = NULL;
    update_map_track();
    set_routingmode(c.input);
}
void MainWindow::toggle_preview(){
    if(readytotrace){
        anchorto = anchorfrom = NULL;
        if(traceback == 0)
            traceback = 1;
        else
            traceback = 0;
    }
}
void MainWindow::STRONG_preview(int i){
    status2 = QString("STRONG calculation: %1/%2 steps done").arg(i).arg(sN);
    update_statusbar();
    if(STRONGtracks[i] != NULL){
        if(ct != lrt)
            delete ct;
        ct = new Track(lrt);
        ct->add(STRONGtracks[i]);
        update_map_track();
        update_profil();
    }
}
void MainWindow::STRONG_settings(){
    if( BTP3setups(&(c.sconfig),&(c.mconfig),&(c.cconfig)).exec())
        set_routingmode(c.input);
}
void MainWindow::create_STRONGlayer(){
    if(STRONGstate == 2){
        SL = r->STRONGlayer_create(SL,STRONGindex);
        c.drawSTRONGlayer = 1;
        update_map_raw();
    }
    else{
        status2 = "There is no finished STRONG calculation to operate upon.";
        update_statusbar();
    }
}
void MainWindow::save_STRONGlayer(){
    QString filename = QFileDialog().getSaveFileName(this,"save STRONGlayer","","BTP STRONGlayer (*.bsl)");
    if(SL != NULL && !filename.isEmpty()){
        r->STRONGlayer_save(filename.toLocal8Bit().data(),SL);
        status2 = QString("saved STRONGlayer as %1").arg(filename);
        update_statusbar();
    }
}
void MainWindow::load_STRONGlayer(){
    QString filename = QFileDialog().getOpenFileName(this,"load STRONGlayer","","BTP STRONGlayer (*.bsl)");
    if(!filename.isEmpty()){
        c.drawSTRONGlayer = 1;
        SL = r->STRONGlayer_load(filename.toLocal8Bit().data());
        update_map_raw();
    }
}
void MainWindow::toggle_STRONGlayer(){
    if(c.drawSTRONGlayer)
        c.drawSTRONGlayer = 0;
    else
        c.drawSTRONGlayer = 1;
    update_map_raw();
}
void MainWindow::AnalyseClimbs(){
    if(BTP3setups(&(c.CA)).exec()){
        QString oldstatus2 = status2;
        status2 = "Analysing climbs ...";
        update_statusbar();
        ClimbAnalyse CA(osm,c.mintype,c.maxtype,c.CA.minP,c.CA.minS,c.CA.maxdwnHM,
                       c.CA.minHM,hd);
            //QMessageBox(QMessageBox::NoIcon,"sdfg",QString("%1").arg(1)).exec();
        if(c.CA.list)	CA.create_list(c.CA.ProjectName,c.CA.ProjectFolder);
            //QMessageBox(QMessageBox::NoIcon,"sdfg",QString("%1").arg(2)).exec();
        if(c.CA.Climblayer){
            status2 = "Creating Climblayer ...";
            update_statusbar();
            c.drawClimblayer = 1;
            //QMessageBox(QMessageBox::NoIcon,"sdfg",QString("%1").arg(3)).exec();
            CL = CA.get_ClimbLayer();
            //QMessageBox(QMessageBox::NoIcon,"sdfg",QString("%1").arg(4)).exec();
            CA.save_ClimbLayer(c.CA.ProjectName,c.CA.ProjectFolder,CL);
            //QMessageBox(QMessageBox::NoIcon,"sdfg",QString("%1").arg(5)).exec();
            update_map_raw();
        }

        if(c.CA.map){
            status2 = "Generating map ...";
            update_statusbar();
            MAP mt(hd,osm);
            mt.settings(&(c.MS));
            double widthtoheight = (osm->getmaxlon()-osm->getminlon())
                    *cos(M_PI*(osm->getmaxlat()+osm->getminlat())/2./180.)
                    /(osm->getmaxlat()-osm->getminlat());
            int height = int(sqrt(c.CA.mapsize*1000000/widthtoheight));
            int width= int(height*widthtoheight);
            mt.resize(width,height);
            mt.set_borders(osm->getminlat(),osm->getmaxlat(),osm->getminlon(),osm->getmaxlon());
            mt.calc_borders();
            climblayer *clt = NULL;
            if(c.CA.Climblayer) clt = CL;
            mt.draw_map(NULL,clt,NULL,0);
            QString filename = QString(c.CA.ProjectFolder)
                                .append(c.CA.ProjectName).append(".png");
            mt.save_to_png(filename);
        }
        if(c.CA.html){
            status2 = "Generating html data ...";
            update_statusbar();
            CA.create_html(c.CA.ProjectName,c.CA.ProjectFolder);
        }
            //QMessageBox(QMessageBox::NoIcon,"sdfg",QString("%1").arg(6)).exec();
        status2 = oldstatus2;
        update_statusbar();
    }
}
void MainWindow::load_Climblayer(){
    QString filename = QFileDialog().getOpenFileName(this,"load climblayer","","BTP climblayer (*.bbl)");
    if(!filename.isEmpty()){
        c.drawClimblayer = 1;
        ClimbAnalyse CA;
        CL = CA.load_ClimbLayer(filename.toLocal8Bit().data());
        update_map_raw();
    }
}
void MainWindow::toggle_Climblayer(){
    if(c.drawClimblayer)
        c.drawClimblayer = 0;
    else
        c.drawClimblayer = 1;
    update_map_raw();
}
void MainWindow::generate_Map(){
    ExtMapSettings ems;
    ems.maxlat = map->getmaxlat();
    ems.minlat = map->getminlat();
    ems.maxlon = map->getmaxlon();
    ems.minlon = map->getminlon();
    ems.drawCL = c.drawClimblayer;
    ems.drawSL = c.drawSTRONGlayer;
    ems.drawct = ct->notNULL();
    ems.mapsize = 4;
    if(BTP3setups(&ems).exec()){
        MAP mt(hd,osm);
        mt.settings(&(c.MS));
        double widthtoheight = (ems.maxlon-ems.minlon)
                                *cos(M_PI*(ems.maxlat+ems.minlat)/2./180.)
                                /(ems.maxlat-ems.minlat);
        int height = int(sqrt(ems.mapsize*1000000/widthtoheight));
        int width= int(height*widthtoheight);
        mt.resize(width,height);
        mt.set_borders(ems.minlat,ems.maxlat,ems.minlon,ems.maxlon);
        mt.calc_borders();
        STRONGlayer *slt = NULL;
        climblayer *clt = NULL;
        Track *ctt = NULL;
        if(ems.drawCL) clt = CL;
        if(ems.drawSL) slt = SL;
        if(ems.drawct) ctt = ct;
        mt.draw_map(slt,clt,ctt,0);

        QString filename = QFileDialog().getSaveFileName(this,"save Map","","portable network graphic (*.png)");
        if(!filename.isEmpty())
            mt.save_to_png(filename);
    }
}
void MainWindow::normalize_Hm(){
    osm->normalize_Hm(osm->get_first_KOO());
    status2 = "Routing Height data is normalized.";
    update_statusbar();
}
void MainWindow::invert_Hm(){
    osm->invert_Hm(osm->get_first_KOO());
    status2 = "Routing Height data is inverted.";
    update_statusbar();
}
void MainWindow::swap_Hm_d(){
    osm->swap_Hm_d(osm->get_first_KOO());
    status2 = "Height meters and distance swaped.";
    update_statusbar();
}

void MainWindow::save_profile(){
    QString filename = QFileDialog().getSaveFileName(this,"save Profil","","portable network graphic (*.png)");
    if(ct != NULL && !filename.isEmpty()){
        plot2D pt(ui->profil);
        pt.set_size(c.PS.width,c.PS.height);
        pt.refresh_pixmap();
        pt.save_to_png(filename.toLocal8Bit().data());
        status2 = QString("profil saved as %1").arg(filename);
        update_statusbar();
    }
}
void MainWindow::save_gpx(){
    QString filename = QFileDialog().getSaveFileName(this,"save track","","GPS exchange format (*.gpx)");
    if(ct != NULL && !filename.isEmpty()){
        ct->to_gpx(filename.toLocal8Bit().data());
        status2 = QString("track saved as %1").arg(filename);
        update_statusbar();
    }
}
void MainWindow::profil_settings(){
    BTP3setups(&(c.PS)).exec();
    update_profil();
}
void MainWindow::map_settings(){
    BTP3setups(&(c.MS)).exec();
    update_map_raw();
}
void MainWindow::recalc_power(){
    if(PA->isVisible())
        PA->calc_track(lrt);
}
void MainWindow::toggle_poweranalysis(){
    if(PA->isVisible())
        PA->hide();
    else{
        PA->show();
        recalc_power();
        update_profil();
    }
}
void MainWindow::center_track(double d){
    if(ct->notNULL()){
        KOO k;
        ct->extract_KOO(&k,d);
        zoom(1,
             (k.lon-map->getmaxlon())/(map->getmaxlon()-map->getminlon())+0.5,
             (k.lat-map->getmaxlat())/(map->getmaxlat()-map->getminlat())+0.5);
    }
}
void MainWindow::zoom_profil(double dmin, double dmax){
    if(ct == lrt && PA->isready()){
        float hm = ct->get_height_meters(dmin,dmax);
        float d = dmax-dmin;
        ui->profil->set_labels(QString("%1 km  %2 Hm  %3 Hm/km  %4 km/h  %5 W")
                               .arg(d,0,'f',2)
                               .arg(hm,0,'f',0)
                               .arg(hm/d,0,'f',1)
                               .arg(PA->get_v(dmin,dmax),0,'f',1)
                               .arg(PA->get_P(dmin,dmax),0,'f',0),
                                "d [km]","h [m]");
    }
    ui->profil->refresh_pixmap();
}
void MainWindow::toggle_showpower(){
    if(c.plotpower)
        c.plotpower = 0;
    else
        c.plotpower = 1;
    update_profil();
}

void MainWindow::toggle_showspeed(){
    if(c.plotspeed)
        c.plotspeed = 0;
    else
        c.plotspeed = 1;
    update_profil();
}
void MainWindow::analyse_gpx(QString filename){
    if(!filename.isEmpty()){
        gpx g(filename.toLatin1().data());
        double** data; long int length;
        data = g.get_complete(&length);
        if(length > 0){
            UR->add(ct);
            if(QMessageBox::Yes == QMessageBox::question(this,
                                               "Height data Handling",
                                               "Recalc height data?",
                                               QMessageBox::Yes|QMessageBox::No)){
                /*recalculate height data*/
                Neighbour *nb;
                WayHeight(hd,data[2],data[3],length,&nb);
                ct = new Track(&nb,1);
            }
            else{
                ct = new Track(data[0],data[1],data[2],data[3],length);
            }
            PA->calc_track(ct,data[0],data[4],length);
            for(long i = 0; i < 5; i++)
                free(data[i]);
            free(data);

            ct->get_brect(&(c.MS.minlat),&(c.MS.maxlat),
                          &(c.MS.minlon),&(c.MS.maxlon));
            lrt = ct;
            map->set_borders(c.MS.minlat,c.MS.maxlat,c.MS.minlon,c.MS.maxlon);
            map->calc_borders();
            update_map_raw();
            update_profil();
        }
        else
            QMessageBox(QMessageBox::NoIcon,"Error",QString("Unable read data from %1").arg(filename)).exec();
    }
}
void MainWindow::analyse_gpx(){
    QString filename = QFileDialog().getOpenFileName(this,"analyse gpx","","GPS exchange format (*.gpx)");
    analyse_gpx(filename);
}
void MainWindow::load_STRONGcalc(){
    QString filename = QFileDialog().getOpenFileName(this,"open STRONG calculation ","","STRONG calculation(*.sca)");
    //QString filename = "D:\\ClimbProject\\Osterzgebirge.sca";
    set_routingmode(routeSTRONG);
    STRONGcalc* sc = new STRONGcalc(osm,&sN,filename.toLocal8Bit().data(),
                                    &STRONGtracks);
    connect(sc,SIGNAL(finished(int)),this,SLOT(route_STRONG_finalize(int)));
    connect(sc,SIGNAL(status(QString)),this,SLOT(show_STRONG_status(QString)));

    STRONGstate = 1;
    sc->start();
}

void MainWindow::save_STRONGcalc(){
    if(STRONGstate == 2){
        QString filename = QFileDialog().getSaveFileName(this,"save STRONG calculation ","","STRONG calculation(*.sca)");
        //QString filename = "D:\\ClimbProject\\Osterzgebirge.sca";
        STRONGcalc* sc = new STRONGcalc(osm,sN,filename.toLocal8Bit().data(),
                                        &STRONGtracks);
        connect(sc,SIGNAL(finished(int)),this,SLOT(route_STRONG_finalize(int)));
        STRONGstate = 1;
        sc->start();
    }
    else{
        status2 = "There is no finished STRONG calculation to operate upon.";
        update_statusbar();
    }
}
void MainWindow::generate_tiles(){
    double maxlat0 = 52;
    double minlat0 = 36;
    double minlon0 = -11;
    double maxlon0 = 30;
    maxlon0 = -1.;
    /*maxlat0 = 60.0;
    minlat0 = 50.0;
    minlon0 = -11.0;
    malon0 = 2;*/


    int xmin, xmax, ymin, ymax;
    double step;
    maxlon0 += 180.;
    minlon0 += 180.;
    QString folderpath = "D:\\ClimbProject\\Tiles\\";
    Cmdl.clear();
    QString btppath = "D:\\ClimbProject\\btp-Data\\";
    for(int z = 9; z < 10; z++){
        step = 360. / pow(2.,z);
        xmin = int(floor(minlon0/step));
        xmax = int(floor(maxlon0/step));
        ymin = int(floor((180.-lattomercator(maxlat0))/step));
        ymax = int(floor((180.-lattomercator(minlat0))/step));
        for(int x = xmax; x >= xmin; x--)
        //for(int x = xmin; x <= xmax; x++)
            for(int y = ymin; y <= ymax; y++){
                webdatacmd w;
                w.x = x;
                w.z = z;
                w.y = y;
                w.dest = folderpath;
                w.src = btppath;
                w.mode = CreateTilesBTP;
                w.width = 256;
                w.height = 256;
                w.c = &c;
                w.osm = osm;
                Cmdl.append(w);
            }
    }
    /*for(int z = 5; z < 9; z++){
        step = 360. / pow(2.,z);
        xmin = int(floor(minlon0/step));
        xmax = int(floor(maxlon0/step));
        ymin = int(floor((180.-lattomercator(maxlat0))/step));
        ymax = int(floor((180.-lattomercator(minlat0))/step));
        for(int x = xmin; x <= xmax; x++)
            for(int y = ymin; y <= ymax; y++){
                webdatacmd w;
                w.x = x;
                w.z = z;
                w.y = y;
                w.dest = folderpath;
                w.mode = CreateTiles;
                w.width = 256;
                w.height = 256;
                w.c = &c;
                w.osm = osm;
                Cmdl.append(w);
            }
    }*/
    threadscount = 1;
    next_command();
}
void MainWindow::STRONG_europe(){
    double maxlat0 = 52;
    double minlat0 = 36;
    double minlon0 = -11;
    double maxlon0 = 30;

    /*maxlat0 = 60.0;
    minlat0 = 50.0;
    minlon0 = -11.0;
    maxlon0 = 2;*/

    int xmin, xmax, ymin, ymax;
    double step;
    maxlon0 += 180.;
    minlon0 += 180.;
    QString folderpath = "D:\\ClimbProject\\STRONGLayers\\";
    Cmdl.clear();
    QString btppath = "D:\\ClimbProject\\btp-Data\\";
    for(int z = 9; z < 10; z++){
        step = 360. / pow(2.,z);
        xmin = int(floor(minlon0/step));
        xmax = int(floor(maxlon0/step));
        ymin = int(floor((180.-lattomercator(maxlat0))/step));
        ymax = int(floor((180.-lattomercator(minlat0))/step));
        for(int x = xmin; x <= xmax; x++)
            for(int y = ymin; y <= ymax; y++){
                webdatacmd w;
                w.x = x;
                w.z = z;
                w.y = y;
                w.dest = folderpath;
                w.src = btppath;
                w.mode = CreateSTRONGLayers;
                w.width = 256;
                w.height = 256;
                w.c = &c;
                w.osm = osm;
                Cmdl.append(w);
            }
    }
    threadscount = -4;
    next_command();
}
void MainWindow::next_command(){
    threadscount--;
    for(int i = 0; i < 12-threadscount; i++ )
        if(Cmdl.length()>0){
            webdatacmd ele = Cmdl.takeLast();
            if(ele.mode == SummitCalc){
                SummitRanking* sr = new SummitRanking;
                QFuture<void> future = QtConcurrent::run(sr,
                                                   &SummitRanking::CalcSummits,
                                                   ele.y,
                                                   ele.x,
                                                   ele.src,
                                                   ele.dest);
                QFutureWatcher<void> m_futureWatcher;
                connect(&m_futureWatcher, SIGNAL(finished()),
                        this,SLOT(next_command()));
                m_futureWatcher.setFuture(future);
            }
            else{
                WebData* wd = new WebData(ele);
                connect(wd,SIGNAL(finished()),this,SLOT(next_command()));
                qRegisterMetaType<webdatacmd>("webdatacmd");
                connect(wd,SIGNAL(add(webdatacmd*)),this,SLOT(add_Cmd(webdatacmd*)));
                threadscount++;
                wd->start();
            }
        }
}
void MainWindow::add_Cmd(webdatacmd* w){
    Cmdl.append(*w);
}
void MainWindow::split_europe_pbf(){
    webdatacmd first;
    first.z = 0;
    first.x = 0;
    first.y = 0;
    first.mode = SplitEurope;

    Cmdl.append(first);
    threadscount = 1;
    next_command();
}
void MainWindow::correct_hgt(){
    QString foldername = QFileDialog::getExistingDirectory(this,"select SRTM3 data directory");
    if(!foldername.isEmpty()){
        QDir f(foldername,"*.hgt");
        HeightData HD;
        HD.set_SRTM3_folder(c.SRTM3folder);
        QString text;
        QStringList hgt = f.entryList();
        int correctedPoints;
        for(int i = 0; i < hgt.count();i++){
            correctedPoints = HD.correct_hgt(f.absoluteFilePath(hgt[i]).toLocal8Bit().data());
            if(correctedPoints > 0)
                text.append(QString("%1 corrected points in %2.\n").arg(correctedPoints).arg(hgt[i]));
        }
        if(text.isEmpty())
            text = "no hgt files corrected.";
        //HD.correct_hgt("C:\\Users\\User\\Desktop\\SRTM3\\N50E013.hgt");
        QMessageBox(QMessageBox::NoIcon,"hgt-correction",text).exec();
    }
}
void MainWindow::read_europe(){
    double maxlat0 = 72;
    double minlat0 = 36;
    double minlon0 = -11;
    double maxlon0 = 30;
    int z = 9;
    double step = 360. / pow(2.,z);
    int xmin = int(ceil((minlon0+180)/step));
    int xmax = int(floor((maxlon0+180)/step));
    int ymin = int(ceil((180.-lattomercator(maxlat0))/step));
    int ymax = int(floor((180.-lattomercator(minlat0))/step));
    QString folderpathsrc = "D:\\ClimbProject\\pbf-Data\\";
    QString folderpathdest = "D:\\ClimbProject\\btp-Data\\";
    for(int x = xmin; x < xmax; x++)
        for(int y = ymin; y < ymax; y++){
            webdatacmd w;
            w.dest = QString("%1%2-%3-%4.btp")
                      .arg(folderpathdest)
                      .arg(z)
                      .arg(x)
                      .arg(y);
            w.src = QString("%1%2-%3-%4.pbf")
                      .arg(folderpathsrc)
                      .arg(z)
                      .arg(x)
                      .arg(y);
            w.mode = ReadOSM;
            Cmdl.append(w);
        }
    threadscount = 1;
    next_command();
}
void MainWindow::CA_europe(){
    double maxlat0 = 72;
    double minlat0 = 36;
    double minlon0 = -11;
    double maxlon0 = 30;
    int z = 9;
    double step = 360. / pow(2.,z);
    int xmin = int(ceil((minlon0+180)/step));
    int xmax = int(floor((maxlon0+180)/step));
    int ymin = int(ceil((180.-lattomercator(maxlat0))/step));
    int ymax = int(floor((180.-lattomercator(minlat0))/step));
    QString folderpathsrc = "D:\\ClimbProject\\btp-Data\\";
    QString folderpathdest = "D:\\ClimbProject\\html-Data\\";
    for(int x = xmin; x < xmax; x++)
        for(int y = ymin; y < ymax; y++){
            webdatacmd w;
            w.z = 9;
            w.x = x;
            w.y = y;
            w.dest = QString("%1%2-%3")
                      .arg(folderpathdest)
                      .arg(x)
                      .arg(y);
            w.src = QString("%1%2-%3-%4.btp")
                      .arg(folderpathsrc)
                      .arg(z)
                      .arg(x)
                      .arg(y);
            w.mode = CreateHTML;
            Cmdl.append(w);
        }
    threadscount = 1;
    next_command();

}
void MainWindow::zoom14_collection(){
    double boxes[8][4] = {{10.15,51.33,11.55,51.95},//Harz
                          {9.44,49.85,17.8,51.5},//Rhoen-Jeseniky
                         {12.08,48.11,15.8,49.6},//BayWa
                         {6.5,46.95,9.4,48.92},//Aarau-Vosges-Schwarzwald
                         {1.8,43.9,45,46.2},//MassiveCentral
                         {18,48.55,21.3,49.9},//Slovensko
                         {6.9,48.8,9.44,51.6},// NRW
                         {4.4,48.9,8.35,50.8}};//Ardennen
    for(int b = 0; b < 8; b++){
        for(int z = 12; z < 15; z++){
            double step = 360. / pow(2.,z);
            int xmin = int(ceil((boxes[b][0]+180)/step));
            int xmax = int(floor((boxes[b][2]+180)/step));
            int ymin = int(ceil((180.-lattomercator(boxes[b][3]))/step));
            int ymax = int(floor((180.-lattomercator(boxes[b][1]))/step));
            for(int y = ymin; y < ymax; y++){
                QDir ydir(QString("D:\\ClimbProject\\ZoomedTiles")
                          .append(QString("\\%1\\%2")
                          .arg(z)
                          .arg(y)));
                if(!ydir.exists())
                    QDir (QString("D:\\ClimbProject\\ZoomedTiles")
                          .append(QString("\\%1")
                          .arg(z))).mkdir(ydir.dirName());
                for(int x = xmin; x < xmax; x++){
                    QFile f(QString("%1%2\\%3\\%4.png")
                           .arg("D:\\ClimbProject\\Tiles\\")
                           .arg(z)
                           .arg(y)
                           .arg(x));
                    f.copy(ydir.filePath(QString("%1.png").arg(x)));
                }
            }

        }
    }
}
void MainWindow::save_track_binary(){
    QString filename = QFileDialog().getSaveFileName(this,"save binary track","","BTP binary track(*.trk)");
    if(!filename.isEmpty())
        ct->to_binary_KOO(filename.toLocal8Bit().data());
}
void MainWindow::save_btr(){
    QString filename = QFileDialog().getSaveFileName(this,"save BTP track","","BTP track(*.btr)");
    if(!filename.isEmpty())
        ct->to_btr(filename.toLocal8Bit().data());
}

void MainWindow::load_btr(){
    QString filename = QFileDialog().getOpenFileName(this,"load BTP track","","BTP track(*.btr)");
    if(!filename.isEmpty()){
        UR->add(ct);
        ct = new Track(filename.toLocal8Bit().data(),&get_KOO_helper,(void*)osm);
        if(ct->notNULL()){
            knew = ct->get_last_KOO();
            lrt = ct;
            recalc_power();
            ct->get_brect(&(c.MS.minlat),&(c.MS.maxlat),
                          &(c.MS.minlon),&(c.MS.maxlon));
            update_map_raw();
            update_profil();
        }
        else
            undo();
    }
}
KOO* get_KOO(qint64 id);

void MainWindow::summitranking_split(){
    SummitRanking("D:\\Summitranking\\allCountries.txt","D:\\Summitranking\\");
}
void MainWindow::summitranking_calc(){
    double ll[3][2]=
    {{35,74},
     {28,83},
     {30,79}};
    //for(int x = -178; x < 179; x++)
    //    for(int y = -79; y <80; y++){
    for(int x = 12; x < 19; x++)
       for(int y = 49; y < 51; y++){
            SummitRanking* sr = new SummitRanking();
            connect(sr,SIGNAL(log(QString,QString)),this,SLOT(log_calc(QString,QString)));
            QtConcurrent::run(sr,&SummitRanking::CalcSummits,
                              y, x, QString("D:\\dem3\\"), QString("D:\\Summitranking\\"));
        }
    /*for(int i = 0; i < 3786; i++){
        SummitRanking* sr = new SummitRanking();
        connect(sr,SIGNAL(log(QString,QString)),this,SLOT(log_calc(QString,QString)));
        QtConcurrent::run(sr,&SummitRanking::CalcSummits,
                          ll[i][0],ll[i][1], QString("D:\\dem3\\"), QString("D:\\Summitranking\\"));
    }*/
    //threadscount = 1;
    //next_command();
}
void MainWindow::log_calc(QString logfilename,QString message){
    FILE *f = fopen(logfilename.toLocal8Bit().data(),"a");
    if(f!= NULL){
        fprintf(f,"%s",message.toLocal8Bit().data());
        fclose(f);
    }
}
void MainWindow::summitranking_collect(){
    QDir dir("D:\\Summitranking\\4thcalc_standarddeviation","*.lst");
    QStringList hgt = dir.entryList();
    FILE* f = fopen("D:\\Summitranking\\4thcalc_standarddeviation\\WorldSummits.txt","w");
    char line[9999];
    int maxi = hgt.count();
    for(int i = 0; i < maxi; i++){
        FILE *ft = fopen(dir.absoluteFilePath(hgt[i]).toLocal8Bit().data(),"r");
        int stop = 0;
        bool OK[3];
        while(!feof(ft) && !stop){
            fgets(line,999,ft);
            QStringList sl = QString(line).split('\t');
            if(sl.length() > 5){
                double index = sl.at(0).toDouble(&(OK[0]));
                double index2 = sl.at(5).toDouble(&(OK[1]));
                double index3 = sl.at(5).toDouble(&(OK[2]));
                if(OK[0] && OK[1] && OK[2]){
                    if((100 < index)){
                        if(index2 > 1000 || index3 > 500)
                            fprintf(f,"%s",line);
                    }
                    else
                        stop = 1;
                }
            }
        }
        fclose(ft);
    }
    fclose(f);
}
void MainWindow::got_to_latlon(){
    QString text = QInputDialog::getText(this, tr("got to KOO"),
                                              tr("Enter lat lon string like: '47.34 -135.5'"));
    QStringList sl = text.remove('\n').split(' ');
    if(sl.length()<2)
        sl= text.split('\t');
    bool OK[2];
    if(sl.length()>1){
        double lat = sl[0].toDouble(&(OK[0]));
        double lon = sl[1].toDouble(&(OK[1]));
        if(OK[1] && OK[0]){
            zoom(1,
                 (lon-map->getmaxlon())/(map->getmaxlon()-map->getminlon())+0.5,
                 (lat-map->getmaxlat())/(map->getmaxlat()-map->getminlat())+0.5);
        }
    }
}
