#include "terrainhelper.h"


dh::dh(double d, double h){
    this->d = d;
    this->y = y;
}
bool dh::operator<(const dh o2)const{
    if(d < o2.d && y > o2.y)
        return true;
    else
        return false;
}
xyz::xyz(){x = y = z =0;}
xyz::xyz(double lat,double lon, double h){
    double r = 6371000+h;
    x = r*(cos(lat*0.0174532925)*cos(lon*0.0174532925));
    y = r*(cos(lat*0.0174532925)*sin(lon*0.0174532925));
    z = r*(sin(lat*0.0174532925));
}
void xyz::fromEukl(double x, double y, double z){
    this->x = x;
    this->y = y;
    this->z = z;

}

double xyz::operator*(xyz o2)const{
    return this->x*o2.x+this->y*o2.y+this->z*o2.z;
}
double xyz::lat(){
    return atan(z/sqrt(x*x+y*y))*57.2957795131;
}
double xyz::lon(){
    return atan2(y,x)*57.2957795131;
}
double xyz::h(){
    return sqrt(x*x+y*y+z*z)-6371000;
}
void xyz::sphere(double *lat,double *lon, double *h){
    *lat = this->lat();
    *lon = this->lon();
    *h = this->h();
}
xyz xyz::operator*(const double o2)const{
    xyz a(*this);
    a.x *=o2;
    a.y *=o2;
    a.z *=o2;
    return a;
}

xyz xyz::operator+(xyz o2)const{
    xyz a(*this);
    a.x +=o2.x;
    a.y +=o2.y;
    a.z +=o2.z;
    return a;
}
xyz::xyz(xyz* a){
    x = a->x;
    y = a->y;
    z = a->z;
}
void xyz::substract(xyz a){
    x-=a.x;
    y-=a.y;
    z-=a.z;
}
void xyz::add(xyz a){
    x+=a.x;
    y+=a.y;
    z+=a.z;
}
xyz xyz::difference(xyz a){
    xyz b(a);
    b.substract(*this);
    return b;
}

void xyz::normalize(){
    double nrm = sqrt(x*x+y*y+z*z);
    if(nrm > 0){
        x /= nrm;
        y /= nrm;
        z /= nrm;
    }
}

xyz xyz::normalized(){
    xyz a(this);
    a.normalize();
    return a;
}
double xyz::nrm(){
    return sqrt(x*x+y*y+z*z);
}

px::px(xyz a){
    x = a.x;
    y = a.y;
    z = a.z;
    d = nrm();
}
void px::project(xyz* nh, xyz*nv, xyz*nz){
    X = this->operator *(nh);
    Y = this->operator *(nv);
    Z = this->operator *(nz);
    X = X/sqrt(1-X*X);
    Y = Y/sqrt(1-Y*Y);
}
void px::zoom(double f){
    X*=f;
    Y*=f;
}
bool px::operator<(const px o)const{
    return d > o.d;
}

