#ifndef TSP_H
#define TSP_H
#include "FibHeap.h"
#include "tspmatrix.h"
#include "QString"
#include <QMessageBox>
#include <Windows.h>

class TSP{
public:
    TSP(double** data,int c);
    edge* BranchAndBound(double* distance);     //!< exact solution
    edge* BranchAndBound(double* distance,int maxi);//!< exact solution
    edge* BranchAndBound_1way(double* distance);//!< exact solution
    edge* BruteForce(double* distance);         //!< exact solution
    edge* NearestNeighbour(double* distance);   //!< estimation
    edge* sort(edge* src, int from);            //!< returns appropriate member of an circular list
    static double free_RAM_Bytes();
private:
    int c;
    double** data;
    double solutionlength(TspMatrix* T);        //!< to check correct operation of T
};

#endif // TSP_H
